#!/usr/bin/perl
#
# bch_pbs_examine_complex.D.pl:
#	This script submits the jobs that mainly perform 'examine_complex_via_mblks.2.pl',
#	which examines both "correct" and "erroneous" segments.
#	It was created by slightly modifying the script 'bch_pbs_examine_purges.D.pl'.
#	[CREATED on May 31 (Tue), 2016.]
#
# bch_pbs_examine_purges.D.pl:
#	This script submits the jobs that mainly perform 'examine_purges_via_mblks.2.pl',
#	which examines those erroneous segments that only contains a single "Purge" each and nothing else.
#	It was created by slightly modifying the script 'bch_pbs_classify_msa_errors.D2.pl'.
#	[CREATION Started on May 8 (Sun), 2016, ENDED on Mmm dd (Wdd), 2016.]
#
# bch_pbs_classify_msa_errors.D2.pl:
#	This script submits the jobs that mainly perform 'classify_msa_errors_via_mblks.2.pl',
#	which is an extended version of 'classify_msa_errors_via_mblks.1.pl'.
#	It was created by slightly modifying the script 'bch_pbs_classify_msa_errors.D.pl'.
#	[CREATED on Oct 7 (Wed), 2015, ENDED on Oct .. (), 2015.]
#
# bch_pbs_classify_msa_errors.D.pl:
#	This script submits the jobs that mainly perform 'classify_msa_errors.1.pl',
#	which classifies MSA errors in each erroneously reconstructed segment by comparing reference and reconstructed MSAs.
#	It was created by modifying the script 'bch_pbs_cmp_gconf_stats.D.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Contrast_Analyses/Characteristics/Erroneous_Regions/MAFFT/E_INS_i/Gap_Config_Stats/').
#	(CREATION STARTED on Oct 10 (Fri), 2014, ENDED on Oct xx (yyy), 2014.)
#
# bch_pbs_cmp_gconf_stats.D.pl:
#	This script submits the jobs that mainly perform 'compare_ref_vs_rec_gconf_stats.pl',
#	which compares two non-equivalent MSAs of the same set of sequences in terms of
#	several summary statistics of gap configurations. 
#	It was created by modifying the script 'bch_pbs_cmp_prank_scores.D.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Contrast_Analyses/Scores/Erroneous_Regions/PRANK/Best_Match/PRANK_Scores/').
#	(CREATION STARTED on Oct 7 (Tue), 2014, ENDED on Oct x (yyy), 2014.)
#
# bch_pbs_cmp_prank_scores.D.pl:
#	This script submits the jobs that that mainly perform 'compare_ref_vs_rec_prank_scores.pl',
#	which compares two non-equivalent MSAs of the same set of sequences in terms of
#	profile-profile alginment score used by PRANK.
#	It was created by modifying the script 'bch_pbs_cmp_mafft_consist.D.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Contrast_Analyses/Scores/Erroneous_Regions/MAFFT/E_INS_i/MAFFT_Consist/').
#	(CREATION STARTED on Sep 18 (Thu), 2014, ENDED on Sep xx (yyy), 2014.)
#
# bch_pbs_cmp_mafft_consist.D.pl:
#	This script submits the jobs that that mainly perform 'compare_ref_vs_rec_mafft_consist.pl',
#	which compares two non-equivalent MSAs of the same set of sequences in terms of a
#	consistent score used by (the refinement step of) MAFFT.
#	It was created by modifying the script 'bch_pbs_cmp_compllimment.D.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Contrast_Analyses/Scores/Erroneous_Regions/MAFFT/E_INS_i/Compllimment/').
#	(CREATION STARTED on Sep 12 (Fri), 2014, ENDED on Sep xx (yyy), 2014.)
#
# bch_pbs_cmp_compllimment.D.pl:
#	This script submits the jobs that that mainly perform 'compare_compllimment.pl',
#	which compares two non-equivalent MSAs of the same set of sequences in terms of the 
#	CompLLiMMent (Complete Log-Likelihood of Multiple sequence alignMent) score.
#	It was created by modifying the script 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/Abs_Scoring.DNA/').
#	It also took borrowed the overall framework of 'bch_serial_reconst_dawg_msas_via_mafft.pl' (in '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Reconstructed_MSAs/MAFFT/E_INS_i').
#	(CREATION STARTED on Aug 7 (Thu), 2014, ENDED on Aug xx (yyy), 2014.)
#
# bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl:
#	This revised version of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' can handle
#	input date set of DNA alignments.
#	(CREATION STARTED on Apr 21 (Thu), 2011)
#
# bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl:
#	This script submits the jobs that mainly perform 'compare_ml_msa.bch.extJC.6t.PhyML.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl'.
#	(CREATION STARTED on Mar 24 (Thr), 2011, ENDED on Mar (), 2011)
#
# bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl:
#	This script submits the jobs that mainly perform 'compare_ml_msa.bch.extJC.6t.PAML.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl'.
#	(CREATED on Mar 23 (Wed), 2011)
#
# bch_pbs_cmp_ml_msa.extJC.6t.beta.pl:
#	This script submits the jobs that mainly perform 'compare_ml_msa.bch.extJC.6t.beta.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_apbayes_msa.extJC.6t.pl'.
#	(CREATED on Mar 15 (Tue), 2011)
#
# bch_pbs_cmp_apbayes_msa.extJC.6t.pl:
#	This script submits the jobs that mainly perform 'compare_apbayes_msa.bch.extJC.6t.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_apbayes_msa.extJC.6.pl'.
#	(CREATED on Mar 10 (Thu), 2011)
#
#	REVISED on Mar 11 (Fri), 2011:
#	The script now can submit the new version of 'compare_apbayes_msa.bch.extJC.6t.pl',
#	which can analyze both an amino-acid MSA and a nucleotide MSA.
#
# bch_pbs_cmp_apbayes_msa.extJC.6.pl:
#	This script submits the jobs that mainly perform 'compare_apbayes_msa.bch.extJC.6.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_apbayes_msa.extJC.5.pl'.
#	(CREATED on Mar 8 (Tue), 2011)
#
# bch_pbs_cmp_apbayes_msa.extJC.5.pl:
#	This script submits the jobs that mainly perform 'compare_apbayes_msa.bch.extJC.5.pl'.
#	It was created by slightly revising 'bch_pbs_cmp_apbayes_msa.extJC.3.pl'.
#	(CREATED on Dec 7 (Tue), 2010)
#
# bch_pbs_cmp_apbayes_msa.extJC.3.pl:
#	This revised script of 'bch_pbs_cmp_apbayes_msa.extJC.2.pl'
#	submits the jobs that mainly performs 'compare_apbayes_msa.bch.extJC.3.pl'.
#	(CREATION STARTED on Nov 26 (Fri), 2010, and ENDED on Nov 30 (Tue), 2010)
#
# bch_pbs_cmp_apbayes_msa.extJC.2.pl:
#	This revised script of 'bch_pbs_cmp_apbayes_msa.extJC.pl'
#	submits the jobs that mainly performs 'compare_apbayes_msa.bch.extJC.2.pl'.
#	(CREATED on Sept 24 (Fri), 2010)
#
# bch_pbs_cmp_apbayes_msa.extJC.pl:
#	This revised script of 'bch_pbs_cmp_ml_msa.extJC.pl'
#	submits the jobs of the copies of the script 'pbs_cmp_apbayes_msa.extJC.sh'.
#	(CREATED on July 14 (Wed), 2010)
#
# bch_pbs_cmp_ml_msa.extJC.pl:
#	This script submits the jobs of the copies of the script 'pbs_cmp_ml_msa.extJC.sh'.
#	(CREATED on June 30 (Wed), 2010)
#
# bch_pbs_cmp_ml_msa.2.pl:
#	This slightly revised version of the Perl script 'bch_pbs_cmp_ml_msa.pl'
#	submits the jobs of the copies of the script 'pbs_cmp_ml_msa.2.sh'.
#	(CREATED on May 14 (Fri), 2010)
#
# bch_pbs_cmp_ml_msa.pl:
#	This Perl script submits multiple jobs of the copies of
#	the script 'pbs_cmp_ml_msa.sh'.
#	Before running this script,
#	BE SURE TO CHECK the Perl scripts "$script_dir/compare_ml_msa.bch.pl"
#	and change the parameters as needed.
#
# bch_qsb_pipe_prep_ingr_minitrees.cds.pl:
#	This Perl scripts submits multiple jobs
#	that constructs pipelines to prepare ingredients of minitrees (for CDS sequences).
#	BE SURE TO CHECK the sub-master file "$script_dir/collect_extbw_besthits.cds.pl"
#	as well, before running this script.
#
# bch_qsb_pipe_lclscreen_homologs.nuc.pl:
# 	This revised version of 'bch_qsb_pipe_lclsrceen_homologs.pl'
#	mainly deals with pairwise CDS alignments made from the corresponding
#	peptide alignments.
#
# bch_qsb_pipe_lclsrceen_homologs.pl:
#

use strict;
use warnings;

use MyFile_manipu qw(
	enlist_files
	open_input_file2
	open_output_file list_sessions_ext
	);
	## open_input_file 

use MyArrayManipu qw( diff_array );

##use MyGridEngine qw( prepare_ge_script );
use MyPBS_UH qw( prepare_pbs_script );

sub peek_into_archive (\$$$$); ## IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl' in creation of 'bch_pbs_cmp_compllimment.D.pl'. ##

(our $CURR_WORK_DIR = ` pwd `) =~ s/\s+$//;

$| = 1; # Flush the buffer for standard output whenever it receives output.

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' on Mar 15 (Tue), 2011 #
my $program_path = $0;
my ($program_name) = ($program_path =~ m/([^\/]+)$/); 

	## Test Output Levels. (IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl' in creation of 'bch_pbs_cmp_compllimment.D.pl'.) ##
	## 0, silent; 1, very brief; 2, pretty brief; 3, rather verbose; 4, verbose; 5, very verbose, >5: extremely verbose. ##

	# (for the main part):
##our $TEST_LEVEL = 1;
##our $TEST_LEVEL = 3;
our $TEST_LEVEL = 5;

	### Important Parameters ###

	## ADDED to handle the new verson of 'compare_apbayes_msa.bch.extJC.6t.pl' (on Mar 11 (Fri), 2011) ##
##our $SEQTYPE = 'AA'; # 'AA' for amino-acid sequences, 'NT' for nucleotide sequences
our $SEQTYPE = 'NT'; # 'AA' for amino-acid sequences, 'NT' for nucleotide sequences

	## Options for the tree inference ##
	# (ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl' on Mar 23 (Wed), 2011) #
	# (REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' on Apr 21 (Thu), 2011) # 

###=for the actual analyses
our $SBST_MODEL='TN93'; # Substitution model for calculating PRANK scores. (For tree reconstruction, a simpler model may be used.)
##our $SBST_MODEL='HKY85'; # Substitution model for calculating PRANK scores. (For tree reconstruction, a simpler model may be used.)
our $CT_RCATE=1;  # Number of substitution rate categories
our $ALPHA=0; # Gamma shape parameter for rate variation across sites
our $TOPO_SEARCH='NNI'; # Tree topology search method
##our $RES_FREQ = ($SEQTYPE eq 'AA') ? 'm' : 'e';  # Option for residue frequencies (= 'e' when estimated from the alignment, = 'm' for ML-estimated values (for nucleotides) or model-specified values (for amino-acids), [= "fA,fC,fG,fT" for user-specified values. --- OBSOLETE NOW], = "fA,fG,fC,fT" for user-specified values (MODIFIED in creation of 'bch_pbs_cmp_mafft_consist.D.pl').
our $RES_FREQ = '0.25,0.25,0.25,0.25'; # This was the value used for our Dawg simulations.


	## MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. ##

	# Ratio of the inter-purine (i.e., A<->G) transition rate to the transversion rate.
our $SV_RATIO_R = 1; # This was the value used for our Dawg simulations.
##our $SV_RATIO_R = 20; # For TESTING.

	# Ratio of the inter-pyrimidine (i.e., T<->C) transition rate to the transversion rate.
our $SV_RATIO_Y = 1; # This was the value used for our Dawg simulations.
##our $SV_RATIO_Y = 5; # For TESTING.

####our $SV_RATIO = 2; # Transition/transversion ratio  (=2 is the default value for MAFFT). # MOVED from below in creation of 'bch_pbs_cmp_mafft_consist.D.pl' (on Sep 12 (Fri), 2014). #
###=cut

	## ADDED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. ##

=DISABLED in creation of 'bch_pbs_examine_purges.D.pl'. #
	# Parameters for the gap probability, which were obtained by fitting the function:
	# F [l] = $SCALE_FAC * (1 -x) * x*((l-1)  (with x = $PRB_GAP_EXT)
	# to the Power-Law distribution:
	# PL [l] = l**(-1.6) /[Sum_{l=1}^{\infty} l**(-1.6) ] (l=1,...,100).
	# [In the following, 2.180920.. = Sum_{l=1}^{100} l**(-1.6); 2.285739... = Sum_{l=1}^{\infty} l**(-1.6) ]
	# (IMPORTED from 'bch_serial_reconst_dawg_msas_via_prank_v2.pl'.)
our $SCALE_FAC = sprintf ("%7.5f", 0.746757 * 2.18092/2.28574);

	# Gap opening rate (relative to the substitution rate), which corresponds to 'r' in Loytynoja and Goldman (2005). (It should probably correspond to 1/2 of the total (relative) indel rate in Dawg (Cartwright, 2005). #
	# if = 'Dawgx{number}', the gap opening rate will be set at: {number} * {total indel rate used by Dawg} /2.
##our $GAPRATE = ''; # For the default value.
our $GAPRATE = "Dawgx$SCALE_FAC"; # For the best-fit geometric distribution to the power-law (of exponent -1.6).

	# Gap extension probability, which corresponds to  'epsilon' in Loytynoja and Goldman (2005).
##our $GAPEXT = ''; # For the default value.
our $GAPEXT=  0.3957; # For the best-fit geometric distribution to the power-law (of exponent -1.6).

	# Match extension probability, which corresponds to 'gamma' in Loytynoja and Goldman (2005).
our $MATCHEXT = ''; # For the default value.

	# = 1 if you want to open 'confirm'ed insertions forever (corresponds to the '+F' option of PRANK (recommended)),
	# = 0 if you want to leave the possibility of re-closing 'confirm'ed insertions (default for PRANK). 
our $IF_INSOPEN_FOREVER = 1;

#=For TESTING the script
$GAPRATE = 0.1;
$GAPEXT = 0.6;
$MATCHEXT = 0.001;
#=cut
=cut # END of "DISABLED in creation of 'bch_pbs_examine_purges.D.pl'." #


     # Hostname and Current working directory -- You have to specify them manually -- #
##my $hostname = 's-Computer-8.local';
my $hostname = 'Ezawa-Kiyoshi-no-Mac-Pro.local';

my $curr_work_dir = $CURR_WORK_DIR;
##my $curr_work_dir = '/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Contrast_Analyses/Scores/Erroneous_Regions/MAFFT/E_INS_i/Compllimment';

##my $e_mail = 'kezawa@lab.nig.ac.jp'; # E-mail address to which you want the messages to be sent. 

	## Input/Output Files/directories ##

	# Executable, control file and data file #
	# (ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' on Mar 15 (Tue), 2011)
	# (REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011)
	# (The executable is still effective in 'bch_pbs_cmp_mafft_consist.D.pl', when constructing a phylogenetic tree INDEPENDENT OF the Dawg control file.) 

my $main_exec = '/Users/kezawa3/Bioinformatics/PhyML/Compiled/bin/phyml';
##my $main_exec = '/Users/kezawa/Bioinformatics/PhyML/bin/phyml';
##my $main_exec = '/Users/kiyoshiezawa/Bioinformatics/PhyML.cmp/phyml-20110304/src/phyml';
##my $main_exec = '/Users/kiyoshiezawa/Bioinformatics/PhyML/PhyML_3.0/PhyML_3.0_macOS_ppc';
##my $dat_file = '/Users/kiyoshiezawa/Bioinformatics/PAML/Unix/paml43/dat/jones.dat'; # For the actual analyses #
##my $dat_file = '/Users/kiyoshiezawa/Bioinformatics/PAML/Unix/paml43/dat/wag.dat'; ## For the initial batch of tests #


	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' (on Mar 18 (Fri), 2011)
	# => REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' (on Apr 21 (Thu), 2011)
our $METHOD = $SBST_MODEL;

	# Binary files and Scripts #
##my $bin_perl = '/usr/bin/perl'; # Perl Interpreter #
my $script_dir = "$curr_work_dir/Scripts"; # Script-containing directory
##my $script_dir = "/Users/kiyoshiezawa/Ezawa_works_UH/Main_Project/2nd_Stage.DNA/ML_ScoringF6t.PhyML/Scripts"; # Script-containing directory

=for the predecessor
my @nec_plscripts = qw(
	compare_ml_msa.bch.pl ml_scoring_msa.bch.pl
	); # Necessary Perl Scripts #
=cut

	# NOTE: BE SURE TO CHECK the sub-master file
	# "$script_dir/compare_apbayes_msa.bch.extJC.pl"
	# as well, before running this script.

my $master_plscript = "$script_dir/examine_complex_via_mblks.2.pl";
##my $master_plscript = "$script_dir/examine_purges_via_mblks.2.pl";

##my $master_plscript = "$script_dir/classify_msa_errors_via_mblks.2.BK3_MOD.pl"; # For TESTING some new functions introduced into 'classify_msa_errors_via_mblks.2.pl'. #
##my $master_plscript = "$script_dir/classify_msa_errors_via_mblks.2.pl";
##my $master_plscript = "$script_dir/classify_msa_errors_via_mblks.1.pl";
##my $master_plscript = "$script_dir/classify_msa_errors.1.pl";
##my $master_plscript = "$script_dir/compare_ref_vs_rec_gconf_stats.pl";
##my $master_plscript = "$script_dir/Ingredients/compare_ref_vs_rec_prank_scores.stripped.pl";
##my $master_plscript = "$script_dir/compare_ref_vs_rec_prank_scores.pl";
##my $master_plscript = "$script_dir/Ingredients/compare_ref_vs_rec_mafft_consist.pl";

## my $aux_script_dir="$script_dir/Aux_scripts";


	### Template of the PBS-submitted scripts ###

my $tmpl_pbsscript = "$script_dir/pbs_examine_complex.mac.D.sh";
##my $tmpl_pbsscript = "$script_dir/pbs_examine_purges.mac.D.sh";

##my $tmpl_pbsscript = "$script_dir/pbs_classify_msa_errors.mac.D2.sh";
##my $tmpl_pbsscript = "$script_dir/pbs_classify_msa_errors.mac.D.sh";
##my $tmpl_pbsscript = "$script_dir/pbs_cmp_gconf_stats.mac.D.sh";
##my $tmpl_pbsscript = "$script_dir/pbs_cmp_prank_scores.mac.D.sh";
##my $tmpl_pbsscript = "$script_dir/pbs_cmp_mafft_consist.mac.D.sh";


	### (The following parts were IMPORTED from 'bch_serial_identify_equiv_regions.pl',
	### then modified in creation of 'bch_pbs_cmp_compllimment.D.pl'.)

	### Input MSA type to be used. ###
	##  -- This basically determines the type of input MSAs and the label of the output directory. -- ##

#my $input_msa_type = '12primates'; # For full-scale analyses. #
my $input_msa_type = '15mammals'; # For full-scale analyses. #
#my $input_msa_type = '9fe_mammals'; # For full-scale analyses. #
###my $input_msa_type = 'hogd_alt_lite_sbcl.1';
#my $input_msa_type = 'TESTs/Test1e'; # For TESTING. #

 	# ADDED in creation of 'bch_pbs_cmp_mafft_consist.D.pl' on Sept 12 (Fri), 2014. #
#my $aligner_type   = 'MAFFT/E_INS_i'; # For 'DBG2'.
##my $aligner_type   = 'MAFFT/G_INS_i';
##my $aligner_type   = 'PRANK/Default';
my $aligner_type   = 'PRANK/Best_Match';


	##### Input/Output Files #####

	## Archives of reference and reconstructed  MSAs (plus Dawg controle files). ##
	# $in_archive = "$inarch_dir/$archive_pref$id_class$archive_suff".

my $inarch_dir = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Prcd_Errors3/Erroneous_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Prcd_Errors/Erroneous_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Erroneous_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Erroneous_Regions/MAFFT/E_INS_i/$input_msa_type/Outputs";

my $archive_pref = 'class_';
##my $archive_pref = 'hog_d';
my $archive_suff = '.tgz';


my $inarch_dir2 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Prcd_Errors3/Erroneous_Regions/Equiv_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir2 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Prcd_Errors/Erroneous_Regions/Equiv_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir2 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Erroneous_Regions/Equiv_Regions/$aligner_type/$input_msa_type/Outputs";
##my $inarch_dir2 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Erroneous_Regions/Equiv_Regions/MAFFT/E_INS_i/$input_msa_type/Outputs";

my $archive_pref2 = 'class_';
##my $archive_pref2 = 'hog_d';
my $archive_suff2 = '.tgz';


=DISABLED in creation of 'bch_pbs_cmp_prank_scores.D.pl'.
		# ADDED in creation of 'bch_pbs_cmp_mafft_consist.D.pl' on Sep 12 (Fri), 2014. #
##my $inarch_dir3 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Errors/Reconstructed_MSAs/$aligner_type/$input_msa_type/Outputs";
my $inarch_dir3 = "/Users/kezawa3/Ezawa_works_UH/Main_Project/Secondary_Projects/ANALYSES/MSA_Prcd_Errors/Reconstructed_MSAs/$aligner_type/$input_msa_type/Outputs";

my $archive_pref3 = 'hog_d';
my $archive_suff3 = '.tgz';
=cut


=DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (1) #
my $in_auxfile = "../Aux_Inputs/Tbl_Purges/tbl_errsegs_w_purges.$input_msa_type.txt.gz"; # ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #
=cut


	### Top Output Directory ###

=For the predecessor 'bch_pbs_classify_msa_errors.D2.pl'.
##my $toptop_dir = "TESTs/PrePre/Test2b_P6rev"; ## For TESTING. ##
#my $toptop_dir = "TESTs/PrePre/DEBUGs/Test2d_P5.DBG1"; ## For TESTING (DEBUGGING). ##
##my $toptop_dir = "TESTs/PrePre_Test2b"; ## For TESTING. ##
##my $toptop_dir = "TESTs/Pre_Test11b5"; ## For TESTING. ##
##my $toptop_dir = "TESTs/Test2b5"; ## For TESTING. ##
##my $toptop_dir = "TESTs/Test2d5"; ## For TESTING. ##
##my $toptop_dir = "TESTs/Test3.5"; ## For TESTING. ##
##my $toptop_dir = "TESTs/DEBUGs/DBG8"; ## For TESTING (DEBUGGING). ##
##my $toptop_dir = "TESTs/DEBUGs/DBG9"; ## For TESTING (DEBUGGING). ##
##my $toptop_dir = "TESTs/DEBUGs/DBG10"; ## For TESTING (DEBUGGING). ##
##my $toptop_dir = "TESTs/Test2b_P10"; ## For TESTING the complete script. (NEW!!) ##
##my $toptop_dir = "TESTs/Test2h_P11"; ## For TESTING the complete script. (NEW!!) ##
=cut # END of "For the predecessor 'bch_pbs_classify_msa_errors.D2.pl'."

##my $toptop_dir = "TESTs/DBG/Debug1"; ## For DEBUGGING. ##
#my $toptop_dir = "TESTs/Test1a"; ## For TESTING. ##
##my $toptop_dir = "TESTs/Pre/Test3a"; ## For Preliminary TESTING. ##

my $toptop_dir = "Sample_$input_msa_type"; # For Sampling. (NEW) #
##my $toptop_dir = $input_msa_type; # For full-scale analyses. (NEW)


	## Temporary Input Files ##
	# $in_refmsa = "$tmp_dir/$in_refaln_pref$lcl_msa_id$in_refaln_suff", and
	# $in_recmsa = "$tmp_dir/$in_recaln_pref$lcl_msa_id$in_recaln_suff", and
	# $ctrl_file = "$tmp_dir/$ctrl_pref$lcl_msa_id$ctrl_suff",
	# where $tmp_dir = "$intmp_aln_dir/$archive_pref$id_class",
	# where $id_class is the ID of the class of MSAs,
	# and $lcl_msa_id is the ID of a MSA in a particular class.

my $intmp_aln_dir = "$toptop_dir/Temporary";

my $in_refaln_pref = 'refaln.';
my $in_refaln_suff = '.aln';

my $in_recaln_pref = 'recaln.';
my $in_recaln_suff = '.aln';

my $ctrl_pref = 'dawg_inp';
my $ctrl_suff = '.txt';


	# $list_segs = "$tmp_dir2/$list_segs_pref$lcl_msa_id$list_segs_suff",
	# where $tmp_dir2 = "$intmp_aln_dir/$archive_pref2$id_class",

my $list_segs_pref = 'equiv_rgs_brief.';
my $list_segs_suff = '.txt';


	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' on Mar 15 (Tue), 2011 #
	# => MODIFIED in creation of 'bch_pbs_cmp_compllimment.D.pl' (on Aug 8 (Fri), 2014). #
my $intree_name = (defined $ctrl_pref) ? join ('', $ctrl_pref, 'xxx', $ctrl_suff) : undef ;
##my $intree_name = 'dawg_inp.txt'; ## = undef if you want to infer an ML tree from the anchor MSA (REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011)


if ((defined $intree_name) and ($ALPHA eq '')) {
	print STDOUT "[ERROR '$program_name'] We canNOT ML-estimate the shape parameter (via option \$ALPHA='') when an input tree ('$intree_name') is specified !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' (on Apr 21 (Thu), 2011) #
###=For the actual analyses
if ((defined $intree_name) and ($RES_FREQ ne '0.25,0.25,0.25,0.25')) {
	print STDOUT "[CAUTION '$program_name'] The option '\$RES_FREQ\=$RES_FREQ' is NOT SUPPORTED when an input tree ('$intree_name') is specified !\n";
	print STDOUT "      --- instead, I will set '\$RES_FREQ\=0.25,0.25,0.25,0.25' ...\n\n";
	$RES_FREQ = '0.25,0.25,0.25,0.25';
}
###=cut
=For an Initial Batch of TESTING
if ((defined $intree_name) and ($RES_FREQ eq 'm')) {
	print STDOUT "[ERROR '$program_name'] We canNOT ML-estimate the nucleotide frequencies (via option \$RES_FREQ = 'm') when an input tree ('$intree_name') is specified !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}
=cut


##our $SV_RATIO = (defined $intree_name) ? 1 : ''; # Transition/transversion ratio  # Moved to above in creation of 'bch_pbs_cmp_mafft_consist.D.pl' on Sep 12 (Fri), 2014. #


	### Output files. ###
	### (IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl', then modified in creation of 'bch_pbs_cmp_compllimment.D.pl'.) ###

	# $topdir = "$outtoptop_dir/$mid_dir," where
	# $mid_dir = "$archive_pref$id_class."

my $outtoptop_dir = "$toptop_dir/Outputs";


	# $outdir = join ('', $outtop_dir, '/', $outdir_pref, $lcl_msa_id, $outdir_suff), where
	# $outtop_dir = "$topdir/Outputs";

my $outdir_pref = 'lclid_';
my $outdir_suff = '';

	# $pbs_script = "$pbs_dir/$pbs_script_name,e" where
	# $pbs_script_name = join ('', $pref_pbs, $lcl_msa_id, $suff_pbs), and
	# $pbs_dir = "$topdir/PBS_scripts."

##my $pref_pbs = 'pbs_cmp_ml_msa.';
##my $pref_pbs = 'pbs_cmp_mafft_consist.'; # MODIFIED in creation of 'bch_pbs_cmp_mafft_consist.D.pl'. #
##my $pref_pbs = 'pbs_cmp_prank_scores.'; # MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. #
##my $pref_pbs = 'pbs_cmp_gconf_stats.'; # A MAJOR MODIFICATION in creation of 'bch_pbs_cmp_gconf_stats.D.pl'. #
my $pref_pbs = 'pbs_classify_msa_errors.'; # A MAJOR MODIFICATION in creation of 'bch_pbs_classify_msa_errors.D.pl'. #
my $suff_pbs = '.sh';

	# $logpbs_file = join ('', $logpbs_dir, '/', $pref_logpbs, $lcl_msa_id, $suff_logpbs) , where
	# $logpbs_dir = "$topdir/Log_PBS."

my $pref_logpbs = "log_$pref_pbs";
my $suff_logpbs = '.txt';

	# "$outdir/$outtop_dir2" gives the directory of the interim output results #
	# (ADDED in rectifying the complex output directory structure on Nov 27 (Sat), 2010) ##
my $outtop_dir2 = 'Interim';


	### Check and list input directories & files ###

foreach my $exec ($main_exec) {
    unless (( -f $exec ) and ( -x $exec )) {
	print STDOUT "\n[ERROR '$program_name'] CanNOT FIND an EXECUTABLE '$exec' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
    }
}

foreach my $dir ($script_dir) {
    unless (( -d $dir ) and ( -r $dir )) {
	print STDOUT "\n[ERROR '$program_name'] CanNOT FIND a readable SCRIPT-CONTAINING DIRECTORY '$dir' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
    }
}

unless (( -f $tmpl_pbsscript ) and ( -r $tmpl_pbsscript )) {
	print STDOUT "\n[ERROR '$program_name'] CanNOT FIND a readable TEMPLATE of the PBS-script '$tmpl_pbsscript' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}

=DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (2)
unless (( -f $in_auxfile ) and ( -r $in_auxfile )) { # ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #

	print STDOUT "\n[ERROR '$program_name'] CanNOT FIND a readable Auxiliary Input File '$in_auxfile' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}
=cut

=for the predecessor
my @missing = ();
foreach my $script (@nec_plscripts) {
    my $path_script = "$script_dir/$script";
    (( -f $path_script ) and ( -r $path_script )) or (push @missing, $script);
}

if (@missing == 0) {
	print STDERR "\n   --- ALL Necessary Perl scripts are found !!\n\n";
} else {
	print STDOUT "\n[ERROR '$program_name'] The following Scripts are MISSING:\n";
	print STDOUT ' ' x 5, join (', ', @missing), " !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}
=cut

	# REVISED in creation of 'bch_pbs_cmp_apbayes_msa.extJC.3.pl' (on Nov 29 (Mon), 2010) #
##foreach my $script ($master_plscript, $slave_plscript_tr, $slave_plscript_sc) {
foreach my $script ($master_plscript) {
    unless (( -f $script ) and ( -r $script )) {
	print STDOUT "\n[ERROR '$program_name'] CanNOT FIND a readable Perl script '$script' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
    }
}

	## IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl,' then modified in creation of 'bch_pbs_cmp_compllimment.D.pl'. ##

foreach my $indir ($inarch_dir, $inarch_dir2) { # MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. #
##foreach my $indir ($inarch_dir, $inarch_dir2, $inarch_dir3) {...} # MODIFIED in creation of 'bch_pbs_cmp_mafft_consist.D.pl'. #
##foreach my $indir ($inarch_dir, $inarch_dir2) {...}
    unless (( -d $indir ) and ( -r $indir )) {
	print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable input directory '$indir' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
    }
}


my $list_id_classes0 = list_sessions_ext ($inarch_dir, $archive_pref, $archive_suff, '-');

unless (defined $list_id_classes0) {
	print STDOUT "[ERROR '$program_name'] 'list_sessions_ext' FAILED on the archive directory '$inarch_dir' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
}

my $list_id_classes = list_sessions_ext ($inarch_dir2, $archive_pref2, $archive_suff2, '-');

unless (defined $list_id_classes) {
	print STDOUT "[ERROR '$program_name'] 'list_sessions_ext' FAILED on the archive directory '$inarch_dir2' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
}

(undef, my $ext0, my $ext) = diff_array (@{$list_id_classes0}, @{$list_id_classes});
unless (@{$ext} == 0) {
	print STDOUT "[ERROR '$program_name'] The archive directory '$inarch_dir2' contains archives NOT FOUND in '$inarch_dir':\n";
	print STDOUT ' ' x 5, join (', ', @{$ext}), " .\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
}
unless (@{$ext0} == 0) {
	print STDOUT "[CAUTION '$program_name'] The archive directory '$inarch_dir' contains archives NOT FOUND in '$inarch_dir2': $!\n";
	print STDOUT ' ' x 5, join (', ', @{$ext0}), " .\n\n";
}

(@{$list_id_classes}>2) and (@{$list_id_classes} = @{$list_id_classes}[0,1]); ### For Sampling. ###

##@{$list_id_classes} = ('0050'); ### For DEBUGGING ('Debug1'). ###
##(@{$list_id_classes}>1) and (@{$list_id_classes} = ($list_id_classes->[0]) ); ### For TESTING the script ('Test1a'). ###

=For the predecessor 'bch_pbs_classify_msa_errors.D2.pl'.
##(@{$list_id_classes}>2) and (@{$list_id_classes} = @{$list_id_classes}[0,1]); ### For TESTING the script. ###
##@{$list_id_classes} = ('1_2'); ## For TESTING ('Test2a'). ##
##@{$list_id_classes} = ('1_4'); ## For TESTING ('Test2b'). ## For DEBUGGING ('DBG1' & 'DBG2'). ### For TESTING the script ('Test2d')
##@{$list_id_classes} = ('1_3'); ## For DEBUGGING the script ('DBG8'). # For TESTING the script ('Test2e')
##@{$list_id_classes} = ('1_5'); ## For DEBUGGING the script ('DBG9'). # For TESTING the script ('Test2f')
##@{$list_id_classes} = ('1_6'); ## For DEBUGGING the script ('DBG10').  # For TESTING the script ('Test2g')
##@{$list_id_classes} = ('2_7'); ## For TESTING ('Test2h'). ##
=cut # END of "For the predecessor 'bch_pbs_classify_msa_errors.D2.pl'."

	## END of "IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl,' then modified in creation of 'bch_pbs_cmp_compllimment.D.pl'." ##


foreach my $out_dir ($intmp_aln_dir, $outtoptop_dir) {

    unless ( -d $out_dir) {
	print STDOUT "[WARNING '$program_name'] CanNOT FIND an output directory '$out_dir' ! ... I will try to create one...\n\n";
	unless (0 == system (" mkdir -p $out_dir ") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to create the output directory '$out_dir': $? !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
    }
    unless ( -w $out_dir ) {
	print STDOUT "[WARNING '$program_name'] The output directory '$out_dir' is NOT WRITABLE ! ... I will try to change its permission mode...\n\n";
	unless (0 == system (" chmod -R u+w $out_dir ") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to change the permission mode of the output directory '$out_dir': $?  !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
    }
}


	### Declare the Beginning of the Script ###

	# REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' (on Mar 15 (Tue), 2011) #
print STDOUT "\n<< Program name: $program_name (path: $program_path) >>\n\n";
##print STDOUT "\n<< Program name: $0 >>\n\n";

	## ADDED on Mar 11 (Fri), 2011 ##
if ($SEQTYPE eq 'AA') {
	print STDOUT "Sequecne Type: Amino Acid Sequences.\n\n";
} elsif ($SEQTYPE eq 'NT') {
	print STDOUT "Sequence Type: Nucleotide Sequences.\n\n";
} else {
	print STDOUT "[ERROR '$program_name'] The seuqence type '$SEQTYPE' is UNEXPECTED. Please specify either 'AA' or 'NT' !!\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
}

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl' (on Mar 23 (Wed), 2011) #

print STDOUT "< Parameters for the Tree Inference >\n\n";
print STDOUT "Executable program: $main_exec .\n";
##print STDOUT "Executable program: $main_exec_tree .\n";
print STDOUT "Substitution model: $SBST_MODEL .\n";
print STDOUT "#{Substitution rate categories} = $CT_RCATE .\n";
print STDOUT "{Gamma shape parameter for rate variation across sites} = $ALPHA .\n";
print STDOUT "Option for the residue frequency: --resfreq=$RES_FREQ .\n"; # ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' (on Apr 12 (Tue), 2011)

	# MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl' (on Sep 17 (The), 2014). #
print STDOUT "Transition/Transversion Ratios:\n";
print STDOUT "   (For A<->G) $SV_RATIO_R ,\n";
print STDOUT "   (For T<->C) $SV_RATIO_Y .\n\n";
##print STDOUT "Transition/Transversion Ratio: $SV_RATIO .\n"; # ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' (on Apr 21 (Thu), 2011)

print STDOUT "Topology search method: $TOPO_SEARCH .\n\n";

=for the predecessor 'bch_pbs_cmp_prank_scores.D.pl'.

print STDOUT "< Parameters for Scoring the Reference &  Reconstructed MSAs (except those specified above) >\n\n";
##print STDOUT "< Parameters for the Alternative Scoring >\n\n";

	## ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' (on Mar 18 (Fri), 2011) ##
print STDOUT "Substitution model: $METHOD .\n\n";

	## ADDED in creation of 'bch_pbs_cmp_prank_scores.D.pl' (on Sep 29 (Mon), 2014). ##
print STDOUT '$GAPRATE  = ', $GAPRATE, " ,\n";
print STDOUT '$GAPEXT   = ', $GAPEXT,  " ,\n";
print STDOUT '$MATCHEXT = ', $MATCHEXT, " ,\n";
print STDOUT '$IF_INSOPEN_FOREVER = ', $IF_INSOPEN_FOREVER, " .\n\n\n";

=cut

print STDOUT "< Input/Output files/directories >\n\n"; # ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl' (on Mar 23 (Wed), 2011) #

print STDOUT "Hostname: $hostname .\n";
print STDOUT "Current working directory: $curr_work_dir .\n\n";
## print STDOUT "Perl Interpreter: '$bin_perl' .\n";
print STDOUT "Master Perl script: $master_plscript .\n";

print STDOUT "Template of the scripts to be submitted via Grid Engine: $tmpl_pbsscript .\n\n";


	# ADDED in creation of 'bch_pbs_cmp_mafft_consist.D.pl' (on Sept 12 (Fri), 2014). #
print STDOUT "{Input MSA type} = $input_msa_type .\n";
print STDOUT "{Aligner type}   = $aligner_type .\n\n";


	# IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl', then modified in creation of 'bch_pbs_cmp_compllimment.D.pl'. #

print STDOUT "Main Input archives: $inarch_dir/$archive_pref", '{ID_class}', "$archive_suff ,\n";
print STDOUT "          where {ID_class} = ", join (', ', @{$list_id_classes}), " .\n\n";
print STDOUT "Temporary input MSAs (reference):     $intmp_aln_dir/$archive_pref", '{ID_class}', "/$in_refaln_pref", '{local_MSA_ID}', "$in_refaln_suff ,\n";   
print STDOUT "Temporary input MSAs (reconstructed): $intmp_aln_dir/$archive_pref", '{ID_class}', "/$in_recaln_pref", '{local_MSA_ID}', "$in_recaln_suff ,\n";   
print STDOUT "Input tree and indel parameters:      $intmp_aln_dir/$archive_pref", '{ID_class}', "/$ctrl_pref", '{local_MSA_ID}', "$ctrl_suff .\n\n";   

print STDOUT "1st Subsidiary Input archives: $inarch_dir2/$archive_pref2", '{ID_class}', "$archive_suff2 .\n\n";
##print STDOUT "Subsidiary Input archives: $inarch_dir2/$archive_pref2", '{ID_class}', "$archive_suff2 .\n\n";
print STDOUT "List of disagreeing segments:      $intmp_aln_dir/$archive_pref2", '{ID_class}', "/$list_segs_pref", '{local_MSA_ID}', "$list_segs_suff .\n\n";
	# $in_refmsa = "$tmp_dir2/$list_segs_pref$lcl_msa_id$list_segs_suff", and
	# where $tmp_dir2 = "$intmp_aln_dir/$archive_pref2$id_class",

=DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (3)
print STDOUT "\nAuxiliary Input File (list of subject segments): $in_auxfile .\n\n\n"; # ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #
=cut

	# MODIFIEd in creation of 'bch_pbs_cmp_compllimment.D.pl'. #

print STDOUT "Output Directories: {outdir} = {top_dir}/Outputs/${outdir_pref}\{local_MSA_ID\}$outdir_suff ,\n";
print STDOUT "PBS job Scripts:   {top_dir}/PBS_scripts/${pref_pbs}\{local_MSA_ID\}$suff_pbs ,\n";
print STDOUT "Log Files for PBS jobs: {top_dir}/Log_PBS/${pref_logpbs}\{local_MSA_ID\}$suff_logpbs ,\n";
print STDOUT "   where {division}'s are the same as those for the input files ,\n";
print STDOUT "   and {top_dir} = $outtoptop_dir/$archive_pref\{ID_class\} is the top output directory for each class of MSAs.\n\n"; 

	## ADDED in rectifying the complex output directory structure (on Nov 27 (Sat), 2010) ## 
print STDOUT "Directories for the Interim Outputs: {outdir}/$outtop_dir2 .\n\n";

print STDOUT "Start: ", ` date ` , "\n";


	## As a preliminary process, convert $intmp_aln_dir into the absolute path if it is a relative path. ##
	## (ADDED in creation of 'bch_pbs_cmp_compllimment.D.pl' (on Aug 8 (Fri), 2014).) ##

unless ($intmp_aln_dir =~ m!^\s*/!) {
    my $intmp_aln_dir0 = $intmp_aln_dir;
    $intmp_aln_dir = "$CURR_WORK_DIR/$intmp_aln_dir";
    unless (( -d $intmp_aln_dir ) and ( -r $intmp_aln_dir )) {
    ##unless (( -f $intmp_aln_dir ) and ( -r $intmp_aln_dir )) {...}
	print STDOUT "[ERROR '$program_name'] FAILED to convert the relative path, '$intmp_aln_dir0,' into the absolute path: $!\n";
	print STDOUT  ' ' x 5 , " ... the readable directory, \"$intmp_aln_dir,\" does NOT EXIST !!\n\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
    }
    print STDOUT "[INFORMATION] Successfully converted the relative path, \"$intmp_aln_dir0,\" of the temporary input/output directory into the absolute path, \"$intmp_aln_dir\" ...\n\n";
}

=DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (5)
	### Preliminary Process (readin the list of subject segments). ###
	### (ADDED in creation of 'bch_pbs_examine_purges.D.pl'.)

my %class_msa_id2sbjct_segs; # = ("$id_class:$in_msa_id" => \@sbjct_segids, ...)

if (1) {
   my $fh_aux = open_input_file2 ($in_auxfile);
   unless (defined $fh_aux) {
	print STDOUT "[ERROR '$program_name'] 'open_input_file2' FAILED on the auxiliary input file '$in_auxfile' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
   }
   local $/ = "\n"; # Use the newline character as the input-record-separator. #
   my $aux_header = <$fh_aux>;

   while (my $line = <$fh_aux>) { # Preliminary while-loop. #

	my @fields = split /\t/, $line;
	(@fields>3) or next;

	my ($id_class, $in_msa_id, $segid) = @fields[0,1,2];

	my $combo_id = "$id_class:$in_msa_id";
	if (defined $class_msa_id2sbjct_segs{$combo_id}) {
	    push @{$class_msa_id2sbjct_segs{$combo_id}}, $segid;
	} else {
	    $class_msa_id2sbjct_segs{$combo_id} = [$segid];
	}

   }			# End of the preliminary while-loop. #
   close ($fh_aux);
}
	### END of "Preliminary Process (readin the list of subject segments)." ###

=cut # END of "DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (5)"


	### Main Process ###

my $ct_classes = my $ct_msas = my $ct_anom = my $ct_fail = my $ct_succ = 0;
my $ct_no_sbjct = 0; # ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #

	## This double-foreach-loop framework was IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl'
	## in creation of 'bch_pbs_cmp_compllimment.D.pl'. ##

foreach my $id_class (@{$list_id_classes}) { # Outer foreach-loop. (over archives (or classes)) #

    print STDOUT "<< Class: $id_class >>\n\n";

		# Examine the first archive. #

    my $in_archive = join ('', $inarch_dir, '/', $archive_pref, $id_class, $archive_suff);
		# $in_archive = "$inarch_dir/$archive_pref$id_class$archive_suff", and 

    unless (( -f $in_archive ) and ( -r $in_archive ) ) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable input archive file '$in_archive' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
    }

    my $mid_dir = join ('', $archive_pref, $id_class);

    my $list_in_msa_ids0 = peek_into_archive ($in_archive, $mid_dir, $in_refaln_pref, $in_refaln_suff);
    unless (defined $list_in_msa_ids0) {
	    print STDOUT "[ERROR '$program_name'] 'peek_into_archive' FAILED on the input archive '$in_archive' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
    }

		# Examine the second archive. #

    my $in_archive2 = join ('', $inarch_dir2, '/', $archive_pref2, $id_class, $archive_suff2);
		# $in_archive = "$inarch_dir/$archive_pref$id_class$archive_suff", and 

    unless (( -f $in_archive2 ) and ( -r $in_archive2 ) ) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable input archive file '$in_archive2' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
    }

    my $mid_dir2 = join ('', $archive_pref2, $id_class);

    my $list_in_msa_ids = peek_into_archive ($in_archive2, $mid_dir2, $list_segs_pref, $list_segs_suff);
    unless (defined $list_in_msa_ids) {
	    print STDOUT "[ERROR '$program_name'] 'peek_into_archive' FAILED on the input archive '$in_archive2' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
    }

    (undef, my $ex0, my $ex) = diff_array (@{$list_in_msa_ids0}, @{$list_in_msa_ids});
    unless (@{$ex}==0) {
	    print STDOUT "[ERROR '$program_name'] The archive '$in_archive2' contains MSAs not in the archive '$in_archive':\n";
	    print STDOUT ' ' x 5, join (', ', @{$ex}), " .\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
    }
    unless (@{$ex0}==0) {
	    print STDOUT "[WARNING '$program_name'] The archive '$in_archive' contains MSAs not in the archive '$in_archive2':\n";
	    print STDOUT ' ' x 5, join (', ', @{$ex0}), " .\n\n";
    }


    (@{$list_in_msa_ids}>2) and (@{$list_in_msa_ids} = @{$list_in_msa_ids}[0,1]); ## For Sampling. ##

    ##(@{$list_in_msa_ids}>1) and (@{$list_in_msa_ids} = ($list_in_msa_ids->[0]) ); ## For TESTING the script ('Test1a'). ##

=For the predecessor 'bch_pbs_examine_purges.D.pl'.
    ##@{$list_in_msa_ids} = ('0009981'); ## For DEBUGING ('Debug1'). ##
    ##@{$list_in_msa_ids} = ('0000001', '0000002', '0000004'); ## For TESTING ('Test1a'). ##
=cut

=For the predecessor 'bch_pbs_classify_msa_errors.D2.pl'.
    ##(@{$list_in_msa_ids}>1) and (@{$list_in_msa_ids} = ($list_in_msa_ids->[0]) ); ## For TESTING the script. ##
    ##(@{$list_in_msa_ids}>2) and (@{$list_in_msa_ids} = @{$list_in_msa_ids}[0,1]); ## For TESTING the script. ##
    ##@{$list_in_msa_ids} = ('0172'); ## For TESTING ('Test2a'). ##
    ##@{$list_in_msa_ids} = ('0227'); ## For TESTING ('Test2b', 'Test2c'). ##
    ##@{$list_in_msa_ids} = ('0050'); ## For DEBUGGING the script ('DBG1' & 'DBG2'). # For TESTING the script ('Test2d').
    ##@{$list_in_msa_ids} = ('0248'); ## For DEBUGGING the script ('DBG8').  # For TESTING the script ('Test2e').
    ##@{$list_in_msa_ids} = ('0047'); ## For DEBUGGING the script ('DBG9').  # For TESTING the script ('Test2f').
    ##@{$list_in_msa_ids} = ('0176'); ## For DEBUGGING the script ('DBG10').   # For TESTING the script ('Test2g').
    ##@{$list_in_msa_ids} = ('0075'); ## For TESTING ('Test2h'). ##
=cut


    my $topdir = "$outtoptop_dir/$mid_dir";
	# $topdir = "$outtoptop_dir/$archive_pref$id_class/";

    my $outtop_dir = "$topdir/Outputs";
    my $pbs_dir = "$topdir/PBS_scripts";
    my $logpbs_dir = "$topdir/Log_PBS";

    foreach my $odir ($outtop_dir, $pbs_dir, $logpbs_dir) {
       unless ( -d $odir) {
	  unless (0 == system (" mkdir -p $odir ") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to create the top-level output directory '$odir': $? !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	  }
       }
       unless ( -w $odir) {
	  unless (0 == system (" chmod -R u+w $odir ") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to change the permission mode of the top-level output directory '$odir': $?  !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	  }
       }
    }


    $ct_classes++;

 (print STDOUT "#{Input MSAs in the archive} = ", scalar (@{$list_in_msa_ids}), " .\n\n") if ($TEST_LEVEL>0);

    my $log_bch_pbs = "$logpbs_dir/log_batch_qsub_$pref_pbs.txt";

    foreach my $in_msa_id (@{$list_in_msa_ids}) { # Middle foreach-loop (over MSAs in the archive) #

	$ct_msas++;

  (print STDOUT "< Input MSA ID: $in_msa_id >\n\n") if ($TEST_LEVEL>0);

=DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (6)

		# ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #

	my $id_combo = "$id_class:$in_msa_id";
	my $sbjct_segids = $class_msa_id2sbjct_segs{$id_combo};
	unless ((defined $sbjct_segids) and (@{$sbjct_segids})) {

  (print STDOUT " ... NO SUBJECT SEGMENTS ...\n\n\n") if ($TEST_LEVEL>1); 

	    $ct_no_sbjct++;
	    next;
	}
	my $cnct_sbjct_segids = join (',', @{$sbjct_segids});

		# END of "ADDED in creation of 'bch_pbs_examine_purges.D.pl'." #

=cut # END of "DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. (6)"


		## Extract Input Files. ##
		## (IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl', then modified, in creation of 'bch_pbs_cmp_compllimment.D.pl'.)

		# Extract the input reference MSA file. #

	my $in_refmsa_name = join ('', $in_refaln_pref, $in_msa_id, $in_refaln_suff);
	my $extracted_refmsa_file = "$mid_dir/$in_refmsa_name";
	my $tmpin_refmsa = "$intmp_aln_dir/$extracted_refmsa_file";

	unless (0 == system ("tar -C $intmp_aln_dir -xpzf $in_archive $extracted_refmsa_file") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to extract a file '$extracted_refmsa_file' into '$intmp_aln_dir' from the archive '$in_archive', for the MSA '$in_msa_id' belonging to the class '$id_class': $? !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
	unless (( -f $tmpin_refmsa ) and ( -r $tmpin_refmsa )) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable temporary input MSA file '$tmpin_refmsa': $! !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}

	my $anchor_msa_file = $tmpin_refmsa;

		# Extract the input reconstructed MSA file. #

	my $in_recmsa_name = join ('', $in_recaln_pref, $in_msa_id, $in_recaln_suff);
	my $extracted_recmsa_file = "$mid_dir/$in_recmsa_name";
	my $tmpin_recmsa = "$intmp_aln_dir/$extracted_recmsa_file";

	unless (0 == system ("tar -C $intmp_aln_dir -xpzf $in_archive $extracted_recmsa_file") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to extract a file '$extracted_recmsa_file' into '$intmp_aln_dir' from the archive '$in_archive', for the MSA '$in_msa_id' belonging to the class '$id_class': $? !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
	unless (( -f $tmpin_recmsa ) and ( -r $tmpin_recmsa )) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable temporary input MSA file '$tmpin_recmsa': $! !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}

		# Extract the Dawg control file. #

	my $ctrl_file_name = join ('', $ctrl_pref, $in_msa_id, $ctrl_suff);
	my $extracted_ctrl_file = "$mid_dir/$ctrl_file_name";
	my $tmpin_ctrl = "$intmp_aln_dir/$extracted_ctrl_file";

	unless (0 == system ("tar -C $intmp_aln_dir -xpzf $in_archive $extracted_ctrl_file") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to extract a file '$extracted_ctrl_file' into '$intmp_aln_dir' from the archive '$in_archive', for the MSA '$in_msa_id' belonging to the class '$id_class': $? !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
	unless (( -f $tmpin_ctrl ) and ( -r $tmpin_ctrl )) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable temporary Dawg control file '$tmpin_ctrl': $! !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}

	my $intree_file = $tmpin_ctrl;

		# Extract the list of disagreeing segments. #

	my $list_segs_name = join ('', $list_segs_pref, $in_msa_id, $list_segs_suff);
	my $extracted_list_segs = "$mid_dir2/$list_segs_name";
	my $tmp_list_segs = "$intmp_aln_dir/$extracted_list_segs";

	unless (0 == system ("tar -C $intmp_aln_dir -xpzf $in_archive2 $extracted_list_segs") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to extract a file '$extracted_list_segs' into '$intmp_aln_dir' from the archive '$in_archive2', for the MSA '$in_msa_id' belonging to the class '$id_class': $? !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}
	unless (( -f $tmp_list_segs ) and ( -r $tmp_list_segs )) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable temporary Dawg control file '$tmp_list_segs': $! !\n\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die;
	}

		## END of "(IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl', then modified, in creation of 'bch_pbs_cmp_compllimment.D.pl'.)" ##


	my $div = $in_msa_id; # Set $div as an alias of $in_msa_id.

		# Carried over from the predecessor 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl'. #

	my $outdir = join ('', $outtop_dir, '/', $outdir_pref, $div, $outdir_suff);

	my $pbs_script_name = join ('', $pref_pbs, $div, $suff_pbs);
	my $pbs_script = "$pbs_dir/$pbs_script_name";
	my $logpbs_file = join ('', $logpbs_dir, '/', $pref_logpbs, $div, $suff_logpbs) ;


	##my @options = ([ '-M', $e_mail ], [ '-o', $logpbs_file ]);
	my @options = (
		##[ '-l', "walltime=24:00:00"],  # Maximum runtime # 
		[ '-l', "walltime=4:00:00"],  # Maximum runtime # 
		[ '-N', $pbs_script],	# job name #
		[ '-j', 'oe'],    # Merge standard error with standard output #
		[ '-o', "$hostname:$curr_work_dir/$logpbs_file" ], # The path and the filename for standard error #
		 );

	my %revisions = (
		##'bin_perl' => $bin_perl,
		'division' => $div,
		##'script_dir' => $script_dir,
		'master_plscript' => $master_plscript,

	# ADDED to handle the new version of 'compare_apbayes_msa.bch.extJC.6t.pl' (on Mar 10 (Fri), 2011)
		'seqtype' => $SEQTYPE,

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl' (on Mar 23 (Wed), 2011) #
		##'main_bin_tree' => $main_exec_tree, DISABLED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011
		'sbst_model' => $SBST_MODEL,
		'ct_rcate' => $CT_RCATE,
		'alpha' => $ALPHA,
		'topo_search' => $TOPO_SEARCH,
		'resfreq' => $RES_FREQ, # ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011 #

		    ## MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl' (on Sep 17 (Thu), 2014). ##
		'sv_ratio_r' => $SV_RATIO_R,
		'sv_ratio_y' => $SV_RATIO_Y,
		##'sv_ratio' => $SV_RATIO, # ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' (on Apr 21 (Thu), 2011)

			## DISABLED in creation of 'bch_pbs_examine_purges.D.pl'. ##
	#### ADDED in creation of 'bch_pbs_cmp_prank_scores.D.pl' (on Sep 29 (Mon), 2014). ##
	##	'gaprate' => $GAPRATE, 
	##	'gapext' => $GAPEXT,
	##	'matchext' => $MATCHEXT,
	##	'if_insopen_forever' => $IF_INSOPEN_FOREVER,

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' (on Mar 15 (Tue), 2011) #
		##'main_bin_clmlk' => $main_exec_clmlk, # REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PAML.pl' (on Mar 23 (Wed), 2011)  => DISABLED AGAIN in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011

		'main_bin' => $main_exec,  # REVISED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011.

		##'ctrl_file' => $ctrl_file, # DISABLED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.pl' on Apr 12 (Tue), 2011
		## 'dat_file' => $dat_file, # DISABLED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl' on Apr 21 (Thu), 2011

		'outtop_dir' => $outdir,
		'outtop_dir2' => $outtop_dir2, ## ADDED in rectifying the complex output directory structure (on Nov 27 (Sat), 2010) ##

	# MODIFIED in creation of 'bch_pbs_cmp_compllimment.D.pl' (on Aug 7 (Thu), 2014). # 
		'inaln_file_ref' => $tmpin_refmsa,
		'inaln_file_rec' => $tmpin_recmsa,
		'inlist_segs' => $tmp_list_segs,
		'inlist_params' => $tmpin_ctrl,
		##'indir' => $indir,

	# ADDED in creation of 'bch_pbs_cmp_mafft_consist.D.pl' (on Sep 12 (Fri), 2014). #
		##'inlist_lclhom' => $tmp_list_lclhom, ## DISABLED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. #

	# ADDED in creation of 'bch_pbs_cmp_ml_msa.extJC.6t.beta.pl' (on Mar 15 (Tue), 2011) #
		'intree' => $intree_file,
		   # DISABLED on Mar 15 (Tue), 2011, then RESURRECTED on Mar 16 (Wed), 2011
		'anchor_msa' => $anchor_msa_file,


	# ADDED in creation of 'bch_pbs_examine_purges.D.pl' (on May 9 (Mon), 2016). #
	# => DISABLED in creation of 'bch_pbs_examine_complex.D.pl'. #
		## 'sbjct_segs' => $cnct_sbjct_segids,

			);


	unless ( prepare_pbs_script ($tmpl_pbsscript, $pbs_script, @options, %revisions)) {
	    print STDOUT "[ERROR '$program_name'] FAILED to conduct 'prepare_pbs_script' on the division '$div' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}

	    ## ADDED on April 5 (Mon), 2010 ##
	unless (0 == system ("echo 'Division $div:' >> $log_bch_pbs") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to write the division number to the submission script for the division '$div' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}

#=DISABLED for TESTING the script
###=An AD-HOC measure on Mac (administered on  June 30 (Wed), 2010) ##
	unless (0 == system ("sh $pbs_script > $logpbs_file 2>&1") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to conduct 'system ( 'sh $pbs_script' )' for the division '$div' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}
	print STDOUT " The job for the division $div has been done .\n";
###=cut
#=cut

=DISABLED on Mac 
	unless (0 == system ("qsub $pbs_script >> $log_bch_pbs 2>&1") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to conduct 'system ( 'qsub $pbs_script' )' for the division '$div' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}
	print STDERR " The job for the division $div has been submitted .\n";
=cut

=Disabled on Mac (on June 30 (Wed), 2010)
	    ## ADDED on April 5 (Mon), 2010 ##
	unless (0 == system ("echo '' >> $log_bch_pbs") ) {
	    print STDOUT "[ERROR '$program_name'] FAILED to write a blank line to the submission script for the division '$div' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}
=cut

#=DISABLED for TESTING the script ('Pre_Test1a')
		# IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl,' then modified, in creation of 'bch_pbs_cmp_compllimment.D.pl'. #

	foreach my $ofile_name ('tbl_summ_examine_complex.txt') { # A MAJOR MODIFICATION in creation of 'examine_complex_via_mblks.2.pl'. #
	##foreach my $ofile_name ('tbl_summ_examine_purge.txt') {...} # A MAJOR MODIFICATION in creation of 'bch_pbs_examine_purges.D.pl'. #
	##foreach my $ofile_name ('tbl_summ_class_msa_errors.1.txt', 'tbl_summ_class_msa_errors.2.txt') { ...} # A MAJOR MODIFICATION in creation of 'bch_pbs_classify_msa_errors.D2.pl'.
	     my $ofile = "$outdir/$ofile_name";
	     unless (( -f $ofile ) and ( -r $ofile )) {
		print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable output file '$ofile'... I guess that the analysis via the script '$master_plscript' FAILED on the local MSA ID '$in_msa_id' !\n";
		print STDERR "[ERROR '$program_name'] $!\n";
		die;
	     }
	}

  (print STDOUT "\n ... Successfully extracted some input sequences, and classified the MSA errors into a number of types ...\n\n") if ($TEST_LEVEL>1);
  ##(print STDOUT "\n ... Successfully extracted some input sequences, and compared the alignments in terms of MAFFT consistent scores ...\n\n") if ($TEST_LEVEL>1);
  ##(print STDOUT "\n ... Successfully extracted some input sequences, and compared the alignments in terms of ComplLiMMent scores ...\n\n") if ($TEST_LEVEL>1);
#=cut

		# Remove the temporary input files. #
		# (IMPORTED from 'bch_pbs_cmp_compllimment.D.pl', then modified, in creation of 'bch_pbs_cmp_compllimment.D.pl'.) #

##=DISABLED for TESTING the script ('Pre_Test1a')
	foreach my $tmpin_file ($tmpin_refmsa, $tmpin_recmsa, $tmpin_ctrl, $tmp_list_segs) { # MODIFIED in creation of 'bch_pbs_cmp_prank_scores.D.pl'. (on Sep 29 (Mon), 2014).
	##foreach my $tmpin_file ($tmpin_refmsa, $tmpin_recmsa, $tmpin_ctrl, $tmp_list_segs, $tmp_list_lclhom) {...} # MODIFIED in creation of 'bch_pbs_cmp_mafft_consist.D.pl' (on Sep 12 (Fri), 2014). #
	##foreach my $tmpin_file ($tmpin_refmsa, $tmpin_recmsa, $tmpin_ctrl, $tmp_list_segs) {...}
	    unless (0 == system ("rm -f $tmpin_file") ) {
		print STDOUT "[ERROR '$program_name'] FAILED to remove the temporary input file '$tmpin_file': $? !\n";
		print STDERR "[ERROR '$program_name'] $!\n";
		die;
	    }
	}
##=cut

		## The double-foreach-loop framework was IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl' in creation of 'bch_pbs_cmp_compllimment.D.pl'. ##

	$ct_succ++;

    }					# End of the middle foreach-loop (over MSAs in the archive). #


		## Archive the Middle output directory (storing masked MSAs for the same chromosome.) ##

    my $out_archive_name = "$mid_dir.tgz";

       # $topdir = "$outtoptop_dir/$mid_dir";
    unless ( chdir $outtoptop_dir ) {  # MODIFIED in creation of 'bch_pbs_cmp_compllimment.D.pl' (on Aug 9 (Sat), 2014). #
       # $topdir = "$toptop_dir/$mid_dir".
    ##unless ( chdir $toptop_dir ) {...}
	print STDOUT "[ERROR '$program_name'] FAILED the subroutine 'chdir' to change the directory to '$outtoptop_dir' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
    }

    unless (0 == system ("tar -cpzf $out_archive_name $mid_dir") ) {
	print STDOUT "[ERROR '$program_name'] FAILED TO CREATE a tar-gzipped ARCHIVE '$out_archive_name out of the directory '$mid_dir' under the directory '$toptop_dir': $? !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
    }

    unless (0 == system ("rm -rf $mid_dir") ) {
	print STDOUT "[ERROR '$program_name'] FAILED to REMOVE the directory '$mid_dir' under the directory '$toptop_dir': $? !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
    }
 (print STDOUT "\n... Successfully archived the masked MSAs into '$out_archive_name' under '$toptop_dir'!!\n\n") if ($TEST_LEVEL>1);

    unless ( chdir $CURR_WORK_DIR ) {
	print STDOUT "[ERROR '$program_name'] FAILED the subroutine 'chdir' to RETURN TO the original place, '$CURR_WORK_DIR' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die;
    }

    ##($ct_chr>0) and last; ## For TESTING the script. ##

}			# END of the outer foreach-loop. (over archives (or classes)) #

##}		# End of the outermost foreach-loop # (For the predecessor 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl'.) #


print STDOUT "\n=== All Processes FINISHED !! ===\n\n";

print STDOUT "#{MSA Classes} = $ct_classes .\n";
print STDOUT "#{Input MSAs}  = $ct_msas .\n";
print STDOUT "    #{w/ No Subject Segments} = $ct_no_sbjct ,\n"; # ADDED in creation of 'bch_pbs_examine_purges.D.pl'. #
print STDOUT "    #{Anomalous} = $ct_anom ,\n";
print STDOUT "    #{Failed}    = $ct_fail ,\n";
print STDOUT "    #{Succeeded} = $ct_succ .\n\n";


##print STDOUT "\n\n == Finished submitting the jobs for ALL the divisions ==\n\n"; # For the predecessor 'bch_pbs_cmp_ml_msa.extJC.6t.PhyML.D.pl'. #
print STDOUT ` date ` , "\n";


	### DEFINITIONS OF THE SUBROUTINES ###

# peek_into_archive:
#	This subroutine looks into an input archive and outputs a list of entries.
#	The archive is supposed to be storing files with the following paths:
#	"$dir/$pref$id$suff",
#	where $id specifies the ID of the file.
#	(IMPORTED from 'bch_serial_reconst_dawg_msas_via_mafft.pl' in creation of 'bch_pbs_cmp_compllimment.D.pl'.)
#
# INPUT: (\$in_archive, $dir, $pref, $suff), where
#	$in_archive is the path to the input archive;
#	$dir/$pref/$suff are templates for the paths to the files stored in the archive.
#
# OUTPUT: \@list_ids, where
#	@list_ids stores the IDs of the archived files with the above paths.
#
sub peek_into_archive (\$$$$) {

	my ($in_archive, $dir, $pref, $suff) = @_;
	local $/ = "\n"; # Use the default input-record-separator. #

	my $fh_tmp;
	unless ( open ($fh_tmp, "tar -tzf ${$in_archive} |" ) ) {
	    print STDOUT "[ERROR 'peek_into_archive'] CanNOT fork or look into ${$in_archive}: $!\n";
	    return undef;
	}

	my @list_ids = ();

	my $ext_pref = "$dir/$pref"; # Extended prefix. #
	my $len_epref = length $ext_pref;
	my $len_suff = length $suff;

	while (my $tmp = <$fh_tmp>) { # Main while-loop (over input lines) #

	    $tmp =~ s/\s+$//; # Remove white spaces at the end of the entry (serving as a separator (and possibly a pad)).
	    ($ext_pref =~ m/^\.\//) or ($tmp =~ s/^\.\///); # Remove './' at the beginning of the entry unless $ext_pref begins with './'. (ADDED in creation of 'bch_serial_PAML.pl'.)

	    my $tmp_suff = substr ($tmp, - $len_suff, $len_suff, '');

	    ($tmp_suff eq $suff) or next; # Skip if the suffix doesn't match.

	    my $tmp_epref = substr ($tmp, 0, $len_epref, '');

	    ($tmp_epref eq $ext_pref) or next; # Skip if the extended prefix doesn't match.

	    push @list_ids, $tmp; # The remnant of the entry must be the ID.


	}			# End of the main while-loop (over input lines) #
	close ($fh_tmp);

	return \@list_ids;

}	# End of the subroutine 'peek_into_archive' #


