#!/usr/bin/perl
#
# tabulate_examine_purge_ctrls_mod.pl:
#	This modified version of 'tabulate_examine_purge_ctrls.pl' handles
#	the output files of '../Scripts/examine_purge_ctrls.2mod.pl'.
#	[CREATED on Jan 21 (Sun), 2018.]
#
# tabulate_examine_purge_ctrls.pl:
#	This Perl script reads in the main results of the Perl script 'examine_purge_ctrls.2.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by modifying the script 'tabulate_examine_purge.pl'.
#	(CREATED on May 14 (Sat), 2016)
#
# tabulate_examine_purge.pl:
#	This Perl script reads in the main results of the Perl script 'examine_purges_via_mblks.2.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by modifying the script 'tabulate_classify_msa_errors.pl'.
#	(CREATED on May 11 (Wed), 2016)
#
# tabulate_classify_msa_errors.pl:
#	This Perl script reads in the main results of the Perl script 'classify_msa_errors_via_mblks.1.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by modifying the script 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'.
#	(CREATED on Nov 16 (Sun), 2014)
#
# tabulate_cmp_ref_vs_rec_gconf_stats.pl:
#	This Perl script reads in the main results of the Perl script 'compare_ref_vs_rec_gconf_stats.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by slightly modifying the script 'tabulate_cmp_ref_vs_rec_cts_indels.pl'.
#	(CREATED on Nov 14 (Fri), 2014)
#
# tabulate_cmp_ref_vs_rec_cts_indels.pl:
#	This Perl script reads in the main results of the Perl script 'compare_ref_vs_rec_indel_cts.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by slightly modifying the script 'tabulate_cmp_ref_vs_rec_compllimment.pl'.
#	(CREATED on Oct 2 (Thu), 2014)
#
# tabulate_cmp_ref_vs_rec_compllimment.pl:
#	This Perl script reads in the main results of the Perl script 'compare_ref_vs_rec_compllimment.pl',
#	which are recorded in a table per MSA, and convert them into a single table.
#	The script was created by slightly modifying the script 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
#	(CREATED on Oct 2 (Thu), 2014)
#
# tabulate_cmp_ref_vs_rec_abs_scoring.pl:
#	This Perl script reads in the main results of the Perl script 'compare_ref_vs_rec_abs_scoring.PhyML.pl',
#	which are recorded in a table per MSA,
#	and convert them into a single table.
#

use strict;
use warnings;

use MyFile_manipu qw(
	open_input_file2 open_output_file list_sessions_ext tfm_labels2indices_gen
	);
use MyArrayManipu qw( compare_arrays );

sub extract_seg_set_attributes (\$); # Further MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #
##sub extract_seg_attributes (\$); # MODIFIED in creation of 'tabulate_classify_msa_errors.pl'. #
##sub extract_seg_scores_ref_rec (\$);

$| = 1; # Flush the buffer everytime it receives information to be written through the standard out.

my $program_path = $0;
my ($program_name) = ($program_path =~ m!([^/]+)$!);


	## Parameters concerning input data files to be read in. ##

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.

	# The following string specifies the top-input directory. #
##our $METHOD = 'Jones';
##our $METHOD = 'Poisson';
##our $METHOD = 'ExtJC.ct10';
##our $METHOD = 'ExtJC.ct20';
##our $METHOD = 'ExtJC.ct5';
##our $METHOD = 'ExtJC.20';
##our $METHOD = 'ExtJC.4';
##our $METHOD = 'HKY85';
our $METHOD = 'HKY85.3';

	# The following strings specify the sub-directories. #
our @TYPES = qw( Mild Medium Hard Superhard Crazy ); # For full-scale summary. #
##our @TYPES = qw( Mild Hard ); # For TESTING the script. #

=cut

	# The following strings label the fields in the input files. #
##our @IN_LABELS = ('Total_Score', 'Gap_Score', 'Av#{indel_events}', 'Av#{null_columns}');
##our @IN_LABELS = ('Total_Score', 'AvAv#{insertions}', 'AvAv#{deletions}', 'Av#{null_columns}'); # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_cts_indels.pl'. #
##our @IN_LABELS = ('Tot_seg_length', '#{Gapped_segments}', 'Tot#{gapped_columns}', 'Max_gaplength', 'Gap_Content'); # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'. #
##our @IN_LABELS = ( '#{Equiv_indels}', 'Tot#{composite-blocks}', '#{cblks}_skipped', '#{cblks}_no_assoc', '#{cblks}_noneff', '#{cblks}_eff', 'Tot_len{cblks}_eff', 'Types;of;associated;errors', 'Lengths,of,effective,composite,blocks');
##our @IN_LABELS = ('Rlv_branch', 'len(rlv_branch)', '#{involved_seqs}', 'block_size', '|shift|', '#{sbst_diffs}_exp', '#{sbst_diffs}_obs', 'P-value', 'log[Lk(sbst)]_[rec-ref]'); # MODIFIED in creation of 'tabulate_examine_purge.pl'. #
##our @IN_LABELS = ('Wd_size', '#{wds}', 'indx_wd', 'br_ID', 'br_len', '#{ext_offs}', '#{diffs}_exp', '#{diffs}_obs', 'P-value'); # MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #
our @IN_LABELS = ('Wd_size', '#{wds}', 'indx_wd', 'br_ID', 'br_len', '#{ext_offs}', '#{diffs}_exp', '#{diffs}_obs', 'P-value', 'P-value_random'); # MODIFIED in creation of 'tabulate_examine_purge_ctrls_mod.pl'. #


our $CT_INLABELS = @IN_LABELS;

	### Input/Output files/directories ###

#my $input_msa_type = '12primates';
my $input_msa_type = '15mammals';
##my $input_msa_type = '9fe_mammals';

#my $input_msa_type = 'TESTs/Test1a';

	# $infile1 = "$indir1/$infile_name1",
	# where $indir1 = "$intopdir1/$inmiddir_pref1$id_class$inmiddir_suff1/$inmidpath/$inmiddir_pref2$session_id$inmiddir_suff2/$inbottom_path"
	# with $id_class and $session_ids will be collected later.

my $intopdir1 = "../${input_msa_type}_lite/Outputs";

##my $intopdir1 = '../hogd_alt_lite_sbcl.1_lite/Outputs';
#my $intopdir1 = '../TESTs/Test2d_P10/Outputs';

my $inmiddir_pref1 = 'class_';
##my $inmiddir_pref1 = 'hog_d';
my $inmiddir_suff1 = '';
my $inmidpath = 'Outputs';
my $inmiddir_pref2 = 'lclid_';
my $inmiddir_suff2 = '';
my $inbottom_path = '';
##my $infile_name1 = 'tbl_summ_apbayes_msa.txt';
##my $infile_name1 = 'tbl_summ_cts_indels.txt'; # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_cts_indels.pl'. #
##my $infile_name1 = 'tbl_summ_gconf_stats.txt'; # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'. #
##my $infile_name1 = 'tbl_summ_class_msa_errors.txt'; # MODIFIED in creation of 'tabulate_classify_msa_errors.pl'. #
##my $infile_name1 = 'tbl_summ_class_msa_errors.1.txt'; # MODIFIED on Oct 25 (Sun), 2015. #
##my $infile_name1 = 'tbl_summ_examine_purge.txt'; # MODIFIED in creation of 'tabulate_examine_purge.pl'. #
my $infile_name1 = 'tbl_summ_examine_purge.txt'; # MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
	# $infile1 = "$indir1/$infile_name1",
	# where $indir1 = "$intopdir1/$type/$middir_name1/$indir_pre1f$session$indir_suff1",
	# with $type = 'Mild', 'Medium', or 'Hard'.
my $intopdir1 = "../$METHOD";
my $middir_name1 = 'Outputs';
##my $indir_pref1 = 'hog_v';
my $indir_pref1 = 'hog_d';
my $indir_suff1 = '';
my $infile_name1 = 'tbl_summ_apbayes_msa.txt';
=cut

	# $outfile = "$outdir/$out_pref$type$out_suff"
my $outdir = $input_msa_type;
##my $outdir = 'hogd_alt_lite_sbcl.1';
##my $outdir = "TESTs/Test1"; ### For TESTING the script ###
##my $outdir = "TESTs/Test2d_P10"; ### For TESTING the script ###

##my $outfile_name = 'tbl_cmp_ref_vs_rec_compllimment.txt';
##my $outfile_name = 'tbl_cmp_ref_vs_rec_cts_indels.txt'; # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_cts_indels.pl'. #
##my $outfile_name = 'tbl_cmp_ref_vs_rec_gconf_stats.txt'; # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'. #
##my $outfile_name = 'tbl_classify_msa_errors.txt'; # MODIFIED in creation of 'tabulate_classify_msa_errors.pl'. #
##my $outfile_name = 'tbl_classify_msa_errors.1.txt'; # MODIFIED on Oct 25 (Sun), 2015.  #
##my $outfile_name = 'tbl_examine_purge.txt'; # MODIFIED in creation of 'tabulate_examine_purge.pl'. #
my $outfile_name = 'tbl_examine_purge_ctrl.txt'; # MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
my $outdir = "$METHOD";
##my $out_pref = 'tbl_cmp_ref_vs_rec_abs_scoring.';
##my $out_suff = '.txt';
my $outfile_name = 'tbl_cmp_ref_vs_rec_abs_scoring.txt';
=cut


	## Check files/directories ##

foreach my $topdir ($intopdir1) {
##foreach my $topdir ($intopdir1, $intopdir2) {
    unless (( -d $topdir ) and ( -r $topdir )) {
	print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable TOP INPUT DIRECTORY '$topdir' !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
    }

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
    foreach my $type (@TYPES) {
	my $dir = "$topdir/$type";
	unless (( -d $dir) and ( -r $dir)) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable MIDDLE INPUT DIRECTORY '$dir' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n\n";
	    die ;
	}
    }
=cut

}

	# ADDED in creation of 'tabulate_cmp_ref_vs_rec_compllimment.pl'. #
my $list_id_classes = list_sessions_ext ($intopdir1, $inmiddir_pref1, $inmiddir_suff1, 'dr');
unless (defined $list_id_classes) {
	print STDOUT "[ERROR '$program_name'] 'list_sessions_ext' FAILED on the top input directory '$intopdir1' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
}

##(@{$list_id_classes}>2) and (@{$list_id_classes} = @{$list_id_classes}[0, 1]); ## For TESTING the script. ##

unless ( -d $outdir ) {
    unless (0 == system ("mkdir -p $outdir") ) {
	print STDOUT "[ERROR '$program_name'] FAILED to CREATE the OUTPUT DIRECTORY '$outdir': $? !\n";
	print STDERR "[ERROR '$program_name'] $!\n\n";
	die ;
    }
}
unless (( -r $outdir ) and ( -w $outdir )) {
    unless (0 == system ("chmod u+rw $outdir") ) {
	print STDERR "[ERROR '$program_name'] FAILED to CHANGE permission MODES of the output directory '$outdir': $? !\n";
	die "$! .\n\n";
    }
}


	### Declare the Beginning of the Script ###

print STDERR "\n<< Program name: $0 >>\n\n";

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
print STDERR "Scoring method: $METHOD .\n\n";
=cut

print STDERR "Input files:  {in_dir1}/$infile_name1,\n";

	# MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_compllimment.pl'. #
print STDERR "       where  {in_dir1} = {intopdir1}/$inmiddir_pref1", '{ID_class}', "$inmiddir_suff1/$inmidpath/$inmiddir_pref2", '{session_ID}', "$inmiddir_suff2/$inbottom_path ,\n";
print STDERR "       with {intopdir1} = $intopdir1 ,\n";
print STDOUT "             {ID_class} = ", join (', ', @{$list_id_classes}), " ,\n\n";
print STDERR "       and  {session_ID}'s will be determined in a class-specific manner.\n\n\n";

	# where $indir1 = "$intopdir1/$inmiddir_pref1$id_class$inmiddir_suff1/$inmidpath/$inmiddir_pref2$session_id$inmiddir_suff2/$inbottom_path"

=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
print STDERR "       where  {in_dir1} = {intopdir1}/{type}/$middir_name1/$indir_pref1\{session\}$indir_suff1,\n";
print STDERR "       with {intopdir1} = $intopdir1,\n";
print STDERR "            {type}   = ", join (', ', @TYPES), " ,\n";
print STDERR "     and    {session} will be determined in a type-specific manner.\n\n";
=cut

print STDOUT "Output file: {out_dir}/$outfile_name,\n";
print STDOUT "       where {out_dir} = $outdir .\n\n";

print STDOUT "\n", '# @IN_LABELS = (', join (', ', @IN_LABELS), ").\n\n\n";


	### Main Process ###

my $outfile = "$outdir/$outfile_name";
my $fh_out = open_output_file ($outfile, 1);
unless (defined $fh_out) {
	print STDOUT "[ERROR '$program_name'] 'open_output_file' FAILED on the output file '$outfile' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
}

	# MODIFIED in creation of 'tabulate_classify_msa_errors.pl'. #

print $fh_out join ("\t", 'ID_Class', 'Session_ID', 'Segment_ID', @IN_LABELS), "\n\n";
=For the predecessor 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'.
print $fh_out join ("\t", 'ID_Class', 'Session_ID', 'Segment_ID');
##print $fh_out join ("\t", 'Type', '#Session_ID', 'segment_ID');

foreach my $in_label (@IN_LABELS) { print $fh_out "\t${in_label}.ref\t${in_label}.rec"; }
print $fh_out "\n\n";
=cut

my $ct_in = my $ct_succ = my $ct_fail = 0;
my $totct_sessions = my $totct_segs = 0;
my $totct_out_entries = 0; # ADDED in creation of 'tabulate_examine_purge_ctrls.pl'. #


foreach my $id_class (@{$list_id_classes}) { # Main outermost foreach-loop (over classes). #

   print STDOUT "\n<< Class ID: $id_class >>\n\n";

   my $inmiddir1 = join ('', $intopdir1, '/', $inmiddir_pref1, $id_class, $inmiddir_suff1, '/', $inmidpath);


=For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
foreach my $type (@TYPES) {...} # Main outermost foreach-loop (over types) #

    print STDERR "\n<< Type: $type >>\n\n";

    my $inmiddir1 = join ('', $intopdir1, '/', $type, '/', $middir_name1);
    ##my $inmiddir2 = join ('', $intopdir2, '/', $type, '/', $middir_name2);
=cut

    foreach my $dir ($inmiddir1) {
    ##foreach my $dir ($inmiddir1, $inmiddir2) {
	unless (( -d $dir ) and ( -r $dir )) {
	    print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable MIDDLE INPUT DIRECTORY '$dir' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die ;
	}
    }


	# where $indir1 = "$intopdir1/$inmiddir_pref1$id_class$inmiddir_suff1/$inmidpath/$inmiddir_pref2$session_id$inmiddir_suff2/$inbottom_path"

		# MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_compllimment.pl'. #
    my $sessions = list_sessions_ext ($inmiddir1, $inmiddir_pref2, $inmiddir_suff2, 'dr');
    ##my $sessions = list_sessions_ext ($inmiddir1, $indir_pref1, $indir_suff1, 'dr'); ## For the predecessor 'tabulate_cmp_ref_vs_rec_abs_scoring.pl'.
    unless (defined $sessions) {
	print STDOUT "[ERROR '$program_name'] 'list_sessions_ext' FAILED on the middle input directory '$inmiddir1' !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
    }

    ##(@{$sessions}>2) and (@{$sessions} = @{$sessions}[0,1]); ## For TESTING the script.

    my $ct_sessions = @{$sessions};
    ##$totct_sessions += $ct_sessions;

    print STDERR "\n\n --- Fetched $ct_sessions sessions belonging to the class '$id_class':\n\n";
    ##print STDERR "\n\n --- Fetched $ct_sessions sessions belonging to the type '$type':\n\n";
    print STDERR join (', ', @{$sessions}), " .\n\n";

    foreach my $session (@{$sessions}) { # Middle foreach-loop (over sessions) #

	print STDERR "< Session ID: $session >\n\n";
	$totct_sessions++;

		# where $indir1 = "$intopdir1/$inmiddir_pref1$id_class$inmiddir_suff1/$inmidpath/$inmiddir_pref2$session_id$inmiddir_suff2/$inbottom_path"
	my $indir1 = join ('', $inmiddir1, '/', $inmiddir_pref2, $session, $inmiddir_suff2, '/', $inbottom_path);
	##my $indir1 = join ('', $inmiddir1, '/', $indir_pref1, $session, $indir_suff1);
	##my $indir2 = join ('', $inmiddir2, '/', $indir_pref2, $session, $indir_suff2);

	foreach my $dir ($indir1) {
	##foreach my $dir ($indir1, $indir2) {
	    unless (( -d $dir ) and ( -r $dir )) {
		print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable INPUT DIRECTORY '$dir' !\n";
		print STDERR "[ERROR '$program_name'] $!\n";
		die ;
	    }
	}

		# $infile1 = "$indir1/$infile_name1",
	my $infile1 = "$indir1/$infile_name1";

	foreach my $file ($infile1) {
	    unless (( -f $file ) and ( -r $file )) {
		print STDOUT "[ERROR '$program_name'] CanNOT FIND a readable INPUT FILE '$file' !\n";
		print STDERR "[ERROR '$program_name'] $!\n";
		die ;
	    }
	}

		## Read-in an input file (table) for each MSA. ##

	local $/ = "\n\\\\\n\n"; # A non-default input-record-separator #

	my $fh_in1 = open_input_file2 ($infile1);
	unless (defined $fh_in1) {
	    print STDOUT "[ERROR '$program_name'] 'open_input_file2' FAILED on the input file '$infile1' !\n";
	    print STDERR "[ERROR '$program_name'] $!\n";
	    die ;
	}

	my $ct_segs = 0;
	while (my $in = <$fh_in1> ) { # Middle-inner while-loop (over segments) #

	    $ct_in++;

			# MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #

	    my ($seg_id, $set_lists_attributes) = extract_seg_set_attributes ($in);
	    unless ((defined $seg_id) and (defined $set_lists_attributes) ) {
		(defined $seg_id) or ($seg_id = 'undef');
		print STDOUT "[ERROR '$program_name'] 'extract_seg_set_attributes' FAILED for the segment '$seg_id' !\n";
		##$ct_fail_seg++;
		##next;
		print STDOUT "[ERROR '$program_name'] $!\n";
		die ;
	    }

=For the predecessor 'tabulate_examine_purge.pl'.

	    my ($seg_id, $list_attributes) = extract_seg_attributes ($in);
	    unless ((defined $seg_id) and (defined $list_attributes) ) {
		(defined $seg_id) or ($seg_id = 'undef');
		print STDOUT "[ERROR '$program_name'] 'extract_seg_scores_ref_rec' FAILED for the segment '$seg_id' !\n";
		##$ct_fail_seg++;
		##next;
		print STDOUT "[ERROR '$program_name'] $!\n";
		die ;
	    }
=cut # END of "For the predecessor 'tabulate_examine_purge.pl'."

	    $ct_segs++;

	    my $ct_out_entries = @{$set_lists_attributes};

			# MODIFIED in creation of 'tabulate_examine_purge_ctrls.pl'. #
	    print STDERR "{ Segment ID: $seg_id (#{entries} = $ct_out_entries) }\n\n";
	    ##print STDERR "{ Segment ID: $seg_id }\n\n";

	    foreach my $list_attributes (@{$set_lists_attributes}) { # Inner foreach-loop (over the output entries) # The foreach-loop was added in creation of 'tabulate_examine_purge_ctrls.pl'. #

		my @outinfo = ($id_class, $session, $seg_id, @{$list_attributes});

		print $fh_out join ("\t", @outinfo), "\n";

	    }					# End of the inner foreach-loop (over the output entries) # The foreach-loop was added in creation of 'tabulate_examine_purge_ctrls.pl'. #

	    $ct_succ++;

	    $totct_out_entries += $ct_out_entries; # ADDED in creation of 'tabulate_examine_purge_ctrls.pl' #

	}			# End of the middle-inner while-loop (over segments) #

	print STDERR "\n --- $ct_segs segments were processed in the session '$session' ---\n\n";

	close ($fh_in1);

	$totct_segs += $ct_segs;

	### ($totct_segs >= 2) and last; ### For TESTING the script ###

    } # Middle foreach-loop (over sessions) #

} # End of the main outermost foreach-loop (over classes) #

close ($fh_out);


print STDERR "\n\n=== ALL the Processes ENDED !! ===\n\n";

print STDERR "\n#{Inputs} = $ct_in .\n";
print STDERR "#{Inputs successfully processed} = $ct_succ .\n";
print STDERR "#{Inputs failed to be processed} = $ct_fail .\n";
print STDERR "Total#{input sessions} = $totct_sessions .\n";
print STDERR "Total#{input Segments} = $totct_segs .\n\n";

print STDERR "Total#{output entries} = $totct_out_entries .\n\n"; # ADDED in creation of 'tabulate_examine_purge_ctrls.pl'. #

## my $ct_in = my $ct_succ = my $ct_fail = 0;
## my $totct_sessions = my $totct_segs = 0;

unless (0 == $ct_fail) {
	print STDOUT "[ERROR '$program_name'] FAILED to process $ct_fail inputs !\n";
	print STDERR "[ERROR '$program_name'] $!\n";
	die ;
}



	### DEFINITIONS of the Subroutines ###


# extract_seg_set_attributes:
#	This subroutine reads in attributes of multiple entries assigned to a segment.
#	It was created by modifying 'extract_seg_attributes'
#	in the Perl script 'tabulate_examine_purge.pl'.
#	(CREATED in creation of 'tabulate_examine_purge_ctrls.pl' on May 15 (Sun), 2016.)
#
# extract_seg_attributes:
#	This subroutine reads in attributes of a segment.
#	The subroutine was created by modifying 'extract_seg_scores_ref_rec'
#	in the Perl script 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'.
#	(CREATED in creation of 'tabulate_classify_msa_errors.pl' on Nov 16 (Sun), 2014.)
#
# extract_seg_scores_ref_rec:
#	This subroutine reads in scores and some other information on
#	the reference and reconstructed MSAs for a segment.
#	The subroutine was created by modifying the subroutine 'extract_seg_scores'
#	in the Perl script 'summary_results_scoring.2D.pl'.
#
# extract_seg_scores:
#	This subroutine reads in IDs, ranks, and scores of the alternative MSAs
#	for a segment.
#
# INPUT: \$in_chunk.
#
# OUTPUT: ($seg_id, \@set_lists_attributes), where
#	$seg_id is the ID of the segment whose record is being extracted;
#	@list_attributes (= @{$set_lists_attributes[$indx_en]}) stores attributes of the $indx_en th entry
#	recorded in the input chunk associated with the segment.
#
sub extract_seg_set_attributes (\$) {

	my ($in_chunk) = @_;

	${$in_chunk} =~ s/^\s+//;
	${$in_chunk} =~ s/\s+\\\\\s+$//;

	my @lines = split /\n+/, ${$in_chunk};

	unless (@lines>=2) { # Further MODIFIED for DEBUGGING 'tabulate_examine_purge_ctrls.pl'. #
	##unless (@lines>=3) {...} # MODIFIED in creation of 'extract_seg_set_attributes'. #
	####unless (@lines==3) {...}
	    print STDERR "[ERROR 'extract_seg_set_attributes'] Found an ANOMALOUS INPUT CHUNK: $! !\n";
	    print STDERR "'${$in_chunk}' .\n\n";
	    return (undef, undef, undef);
	}

	my $title = shift @lines;
	my ($seg_id) = ($title =~ m/Segment\s+ID\:\s+(\S+)/ );
	unless (defined $seg_id) {
	    print STDERR "[ERROR 'extract_seg_set_attributes'] Found an ANOMALOUS TITLE: $! !\n";
	    print STDERR "'$title' .\n\n";
	    return (undef, undef, undef);
	}

	my $in_labels = shift @lines;
	unless (defined $in_labels) {
	    print STDERR "[ERROR 'extract_seg_set_attributes'] Found NO LINE of labels for the segment '$seg_id': $! !\n";
	    print STDERR "'$in_labels' .\n\n";
	    return ($seg_id, undef, undef);
	}

	if ((@lines == 1) and ($lines[0] =~ m/^\.\.\./)) {

	    print "[INFORMATION 'extract_seg_set_attributes'] The segment '$seg_id' has NO ENTRY for the reason: '$lines[0]' : $! !\n\n";

	    return ($seg_id, []);
	}

	my @set_lists_attributes = (); # ADDED in creation of 'extract_seg_set_attributes'. #

	while (@lines>0) { # Main while-loop (over entries). # The while-loop was ADDED in creation of 'extract_seg_set_attributes'. #

	   my $line = shift @lines;
	   my @list_attributes = split /\s+/, $line;

	   unless (@list_attributes >= $CT_INLABELS -2) {
		print STDERR "[CAUTION 'extract_seg_set_attributes'] Found an ANOMALOUS LINE for the segment '$seg_id': $! !\n";
		print STDERR "[CAUTION 'extract_seg_set_attributes'] '$line' .\n\n";

			# MODIFIED in creation of 'extract_seg_set_attributes'. #
		print STDOUT "[CAUTION 'extract_seg_set_attributes']   ... I will NOT store this 'entry' ...\n\n";
		next;
	       ##return ($seg_id, undef);
	   }

	   foreach my $i ($CT_INLABELS-2, $CT_INLABELS-1) { (defined $list_attributes[$i]) or ($list_attributes[$i] = 'None'); }

	   push @set_lists_attributes, \@list_attributes; # ADDED in creation of 'extract_seg_set_attributes'. #

	}		# End of the main while-loop (over entries). # The while-loop was ADDED in creation of 'extract_seg_set_attributes'. #

	return ($seg_id, \@set_lists_attributes); # MODIFIED in creation of 'extract_seg_set_attributes'. #
	##return ($seg_id, \@list_attributes);

}		# End of the subroutine 'extract_seg_set_attributes'. #


=For the predecessor 'tabulate_examine_purge.pl'.

	    ## ($seg_id, $list_attributes) = extract_seg_attributes ($in);

# extract_seg_attributes:
#	This subroutine reads in attributes of a segment.
#	The subroutine was created by modifying 'extract_seg_scores_ref_rec'
#	in the Perl script 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'.
#	(CREATED in creation of 'tabulate_classify_msa_errors.pl' on Nov 16 (Sun), 2014.)
#
# extract_seg_scores_ref_rec:
#	This subroutine reads in scores and some other information on
#	the reference and reconstructed MSAs for a segment.
#	The subroutine was created by modifying the subroutine 'extract_seg_scores'
#	in the Perl script 'summary_results_scoring.2D.pl'.
#
# extract_seg_scores:
#	This subroutine reads in IDs, ranks, and scores of the alternative MSAs
#	for a segment.
#
# INPUT: \$in_chunk.
#
# OUTPUT: ($seg_id, \@list_attributes), where
#	$seg_id is the ID of the segment whose record is being extracted;
#	@list_attributes stores attributes of the segment recorded in the input chunk.
#
sub extract_seg_attributes (\$) {

	my ($in_chunk) = @_;

	${$in_chunk} =~ s/^\s+//;
	${$in_chunk} =~ s/\s+\\\\\s+$//;

	my @lines = split /\n+/, ${$in_chunk};

	unless (@lines==3) {
	    print STDERR "[ERROR 'extract_seg_attributes'] Found an ANOMALOUS INPUT CHUNK: $! !\n";
	    print STDERR "'${$in_chunk}' .\n\n";
	    return (undef, undef, undef);
	}
	my $title = shift @lines;
	my ($seg_id) = ($title =~ m/Segment\s+ID\:\s+(\S+)/ );
	unless (defined $seg_id) {
	    print STDERR "[ERROR 'extract_seg_attributes'] Found an ANOMALOUS TITLE: $! !\n";
	    print STDERR "'$title' .\n\n";
	    return (undef, undef, undef);
	}

	my $in_labels = shift @lines;
	unless (defined $in_labels) {
	    print STDERR "[ERROR 'extract_seg_attributes'] Found NO LINE of labels for the segment '$seg_id': $! !\n";
	    print STDERR "'$in_labels' .\n\n";
	    return ($seg_id, undef, undef);
	}

	my $line = shift @lines;
	my @list_attributes = split /\s+/, $line;

	unless (@list_attributes >= $CT_INLABELS -2) {
	    print STDERR "[CAUTION 'extract_seg_attributes'] Found an ANOMALOUS LINE for the segment '$seg_id': $! !\n";
	    print STDERR "'$line' .\n\n";
	    return ($seg_id, undef);
	}

	foreach my $i ($CT_INLABELS-2, $CT_INLABELS-1) { (defined $list_attributes[$i]) or ($list_attributes[$i] = 'None'); }

	return ($seg_id, \@list_attributes);

}		# End of the subroutine 'extract_seg_attributes'. #

=cut # END of "For the predecessor 'tabulate_examine_purge.pl'."


=For the predecessor 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'.
# extract_seg_scores_ref_rec:
#	This subroutine reads in scores and some other information on
#	the reference and reconstructed MSAs for a segment.
#	The subroutine was created by modifying the subroutine 'extract_seg_scores'
#	in the Perl script 'summary_results_scoring.2D.pl'.
#
# extract_seg_scores:
#	This subroutine reads in IDs, ranks, and scores of the alternative MSAs
#	for a segment.
#
# INPUT: \$in_chunk.
#
# OUTPUT: ($seg_id, \@list_scores_ref, \@list_scores_rec), where
#	$seg_id is the ID of the segment whose record is being extracted;
#	@list_scores_ref/rec = ($tot_score, $gap_score, $avct_indels, $avct_null_clms)
#	for the subject segment of the reference/reconstructed MSA, with
#	$tot_score being the total score (log-likelihood), which is the summation of $gap_score and the score for the substitution pattern,
#	$gap_score being the score (log-likelihood) of the gap-pattern,
#	$avct_indels is the average count of the indels (in the parsimonious scenario),
#	$avct_null_clms is the average count of the null columns, each of which consists solely of gap characters.
#
sub extract_seg_scores_ref_rec (\$) {

	my ($in_chunk) = @_;

	${$in_chunk} =~ s/^\s+//;
	${$in_chunk} =~ s/\s+\\\\\s+$//;

	my @lines = split /\n+/, ${$in_chunk};
	unless (@lines==4) {
	##unless (@lines>2) {
	    print STDERR "[ERROR 'extract_seg_scores_ref_rec'] Found an ANOMALOUS INPUT CHUNK: $! !\n";
	    print STDERR "'${$in_chunk}' .\n\n";
	    return (undef, undef, undef);
	}
	my $title = shift @lines;
	my ($seg_id) = ($title =~ m/Segment\s+ID\:\s+(\S+)/ );
	unless (defined $seg_id) {
	    print STDERR "[ERROR 'extract_seg_scores_ref_rec'] Found an ANOMALOUS TITLE: $! !\n";
	    print STDERR "'$title' .\n\n";
	    return (undef, undef, undef);
	}

	my $in_labels = shift @lines;
	unless (defined $in_labels =~ m!^Ref/Rec!) {
	##unless (defined $in_labels =~ m/^\#Rank/) {
	    print STDERR "[ERROR 'extract_seg_scores_ref_rec'] Found an ANOMALOUS line of labels for the segment '$seg_id': $! !\n";
	    print STDERR "'$in_labels' .\n\n";
	    return ($seg_id, undef, undef);
	}

	my %label2scores; # ($label => \@list_scores, ...) where $label eq 'Ref' or 'Rec'. 
			  # with @list_scores = ($tot_score, $gap_score, $avct_indels, $avct_null_clms).
	while (my $line = shift @lines) { # Foreach-loop (over segments) #

	    my @list_scores = split /\s+/, $line;

	    unless (@list_scores == 6) { # MODIFIED in creation of 'tabulate_cmp_ref_vs_rec_gconf_stats.pl'. #
	    ##unless (@list_scores == 5) {...}

		print STDERR "[CAUTION 'extract_seg_scores_ref_rec'] Found an ANOMALOUS LINE for the segment '$seg_id': $! !\n";
		print STDERR "'$line' .\n\n";
		next;
	    }

	    my $label = shift @list_scores;

	    $label2scores{$label} = \@list_scores;

	}		# End of the foreach-loop (over segments) #

	my $list_scores_ref = $label2scores{'Ref'};
	my $list_scores_rec = $label2scores{'Rec'};

	return ($seg_id, $list_scores_ref, $list_scores_rec);

}		# End of the subroutine 'extract_seg_scores_ref_rec' #
=cut

