# pbs_ingr_correl_as_vs_srd.mac.D.sh:
#	This script wraps around 'ingr_correl_alnshear_cb_vs_srd.verXXX.pl'.
#	It was created by substantially modifying 'pbs_examine_complex.mac.D.sh'.
#	[CREATION STARTED on 2020/03/27, ENDED on 2020/03/dd.]
#	
# pbs_examine_complex.mac.D.sh:
#	This script wraps around 'examine_complex_via_mblks.2.pl'.
#	It was created by modifying 'pbs_examine_purges.mac.D.sh'.
#	[CREATION STARTED on May 30th (Mon), 2016, ENDED on May 31st (Tue), 2016.]
#
# pbs_examine_purges.mac.D.sh:
#	This script wraps around 'examine_purges_via_mblks.2.pl'.
#	It was created by slightly modifying 'pbs_classify_msa_errors.mac.D2.sh'.
#	[CREATION Started on May 8 (Sun), 2016, ENDED on Mmm dd (www), 2016.]
#
#	[ ... OMITTED the middle part of the history of the predecessors ...]
#
# pbs_cmp_ml_msa.sh:
# This script is a wrapper of the Perl script 'compare_ml_msa.bch.pl'
# which enables the handling by PBS.
#
# Run for four hours
#PBS -l walltime=4:00:00
# Jab name
#PBS -N cmp_ml_msa.test
# Export current environment to job
# ###PBS -V -- Comment out
# Merge Standard error into Standard output
#PBS -j oe
# Specify the file to which the standard output is printed
#PBS -o login2.tlc2.uh.edu:/home/k/kezawa/Main_Project/1st_Stage/ML_Scoring/TESTs2/Test1/log_pbs_cmp_ml_msa.txt
#

	### User-Supplied Parameters ###

division='test'

echo "Division: $division"
echo ''


##resfreq='0.25,0.25,0.25,0.25' ## User-specified version ##
BASE_FREQS='0.25,0.25,0.25,0.25' ## User-specified version ## MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). #


##echo "Option for the residue frequencies: $resfreq" # ADDED in creation of 'pbs_cmp_ml_msa.extJC.6t.PAML.sh' (on Mar 25 (Fri), 2011) #
echo "Option for the residue frequencies: BASE_FREQS = $BASE_FREQS" # MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). #

echo ''

	# Input/Output files/directories #

##master_plscript='/Users/kezawa3/Ezawa_works_KyuTech/Study/New_Alignment_Programs/Alignment_Neighborhood_Explorer/ANALYSES/Preliminaries/Examine_Complex/PRANK/Best_Match/Full_Analyses/Scripts/examine_complex_via_mblks.2.pl'
master_plscript='/Users/kezawa3/Ezawa_works_KyuTech/Study/New_Alignment_Programs/OpenSource/Exported/ANEX_P/Main_Scripts/ingr_correl_alnshear_cb_vs_srd.ver0.6.pl'


inaln_file_ref='../Inputs/refaln.0000031.aln'
inaln_file_rec='../Inputs/recaln.0000031.aln'
inlist_segs='../Inputs/equiv_rgs_brief.0000031.txt'
inlist_params='../Inputs/dawg_inp0000031.txt'


sv_ratio_r='1' # Inter-Purine (i.e., A<->G) Transition/Transversion ratio.
sv_ratio_y='1' # Inter-Pyrimidine (i.e., A<->G) Transition/Transversion ratio.

echo ''

	# MODIFIED in creation of 'pbs_cmp_prank_scores.mac.D.sh'. #
echo  "Transition/Transversion ratio (A<->G) = '$sv_ratio_r'" 
echo  "Transition/Transversion ratio (T<->C) = '$sv_ratio_y'" 
echo ''


		### ADDED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (1) ###

DIS_LEN_SRD='30'
CT_EFF_DGTS='2'

TN_PARAMS="$sv_ratio_r,$sv_ratio_y,1"

echo "TN_PARAMS = '$TN_PARANS'"
echo "DIS_LEN_SRD = '$DIS_LEN_SRD'"
echo "CT_EFF_DGTS = '$CT_EFF_DGTS'"
echo ''

		### END of "ADDED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (1)" ###

##outtop_dir='../TESTs/Pre/TESTs7/Test7m.alpha_ml'
outtop_dir='../TESTs/PBS/Test1' # Modified in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). #


		### MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). ###

outtop_dir2='.'  # "$outtop_dir/$outtop_dir2" gives the top directory for the output file system. #
##	# ADDED in rectifying the complex output directory structure (on Nov 27 (Sat), 2010) #
##outtop_dir2='Interim'  # "$outtop_dir/$outtop_dir2" gives the directory for the interim outputs #
##
##	  # A MAJOR MODIFICATION in creation of 'pbs_examine_complex.mac.D.sh'. #
##out_summ_file1="tbl_summ_examine_complex.txt"
####out_summ_file2="tbl_summ_class_msa_errors.2.txt"
######out_summ_file="tbl_summ_class_msa_errors.txt" # A MAJOR MODIFICATION in creation of 'classify_msa_errors.1.pl'. #
##
		### END of "MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (1)" ###

log_dir="LogFiles"
##logfile="log_classify_msa_errors.txt" # MODIFIED in creation of 'pbs_classify_msa_errors.mac.D.sh'. #
logfile="log_ingr_correl_as_vs_srd.txt" # MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh'. #


	### END of the Parameter Setting by the User ###


echo 'Start Time:'
date

echo ''
echo 'Hostname:'
hostname

echo ''
echo 'Current directory:'
pwd
echo ''

	## Disabled as an AD-HOC measure on Mac
##echo '$PBS_O_WORKDIR ='
##echo $PBS_O_WORKDIR
##echo ''
##
##echo '$TMPDIR ='
##echo $TMPDIR
##echo ''

##top_tmp_dir=$PWD

echo ''
echo 'change directory to the temporary directory assigned to this job'
echo ''

##TMPDIR=$PWD; ## An AD-HOC measure for running on Mac

	## Disabled as an AD-HOC measure on Mac ##
##if cd $TMPDIR ; then
##	echo "Successfully changed the directory to '$TMPDIR' !"
##else
##	echo "FAILED to change the directory to '$TMPDIR' !!"
##	exit 1
##fi
echo ''
echo 'Current directory:'
pwd

top_tmp_dir=$PWD

	## For TESTING the environment ##
##echo $top_tmp_dir
##echo '$PATH ='
##echo $PATH
##echo ''
##echo '$PERL5LIB ='
##echo $PERL5LIB

if [ ! -d $indir ] ; then
    echo "CanNOT FIND the INPUT DIRECTORY '$indir' !"
    exit 1
fi

if [ ! -d $outtop_dir ] ; then
    if mkdir -p $outtop_dir ; then
	echo "Successfully created the directory '$outtop_dir' !"
    else
	echo "FAILED to create the directory '$outtop_dir' !!"
	exit 1
    fi
fi

	## Disabled as an AD-HOC measure on Mac ##
cd $outtop_dir

echo ''
echo 'Current directory:'
pwd

	# REVISED in creation of 'pbs_cmp_apbayes_msa.extJC.mac.2.sh' #
##for file in $master_plscript $slave_plscript_tr $slave_plscript_sc
for file in $master_plscript
do
    if [ ! -r $file ] ; then
	echo ''
	echo "NO readable Perl script '$file' !"
	echo ''
	exit 1
    fi
done

		### DISABLED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (2) ###

##	# ADDED in creation of 'pbs_cmp_ml_msa.extJC.mac.6.beta.sh' (on Mar 15 (Tue), 2011) #
##	# The for-loop ADDED in creation of 'pbs_cmp_ml_msa.extJC.mac.6t.PAML.sh' (on Mar 23 (Wed), 2011) #
##	# => The for-loop DISABLED in creation of 'pbs_cmp_ml_msa.extJC.mac.6t.PhyML.sh' (on Mar 25 (Fri), 2011) #
####for main_bin in $main_bin_tree $main_bin_clmlk
####do
##    if [ ! -x $main_bin ] ; then
##	echo ''
##	echo "NO executable binary file '$main_bin' !"
##	echo ''
##	exit 1
##    fi
####done
##
####for file in $intree
####for file in $anchor_msa
####for file in $ctrl_file $inaln $intree $dat_file $anchor_msa
##for file in $intree $dat_file $anchor_msa
##do
##   if [ ! -r $file ] ; then
##	echo "No input file $file ."
##	exit 1
##   fi
####
####   if cp $file ./ ;
####   then
####   	echo "Successfully copied the file '$file' to the current directory!"
####   else
####   	echo "FAILED to copy the file '$file' to the current directory !!"
####   	exit 1
####   fi
##done
##
##
##if [ ! -d $log_dir ] ; then
##    if  mkdir -p $log_dir ; then
##	echo "Successfully created the directory '$log_dir' !"
##    else
##	echo "FAILED to create the directory '$log_dir' !!"
##	exit 1
##    fi
##fi
##
		### END of "DISABLED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (2)" ###



		### MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (3) ###

##	## ADDED in rectifying the complex output directory structure (on Nov 27 (Sat), 2010) ##
echo ''
##echo "Drectory for the interim outputs: $outtop_dir2"
echo "Top Directory for the output file system: $outtop_dir2"
echo ''
##
		### END of "MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). (3)" ###


## Usage:  [perl] compare_ml_msa.bch.extJC.6t.beta.pl {main_binary} {control_file} {sbst_model_file} {sequence_type ('AA' for amino acid sequences, 'NT' for  nucleotide sequences)} {input_tree_file} {in_top_dir} {out_top_dir} {out_summ_file} {log_dir} [ --intree={input_tree_file} ]
##if (time perl $master_plscript $main_bin $ctrl_file $dat_file $seqtype $anchor_msa  $indir $outtop_dir2 $out_summ_file $log_dir --intree=$intree ) > $logfile 2>&1 ;


		### ... OMITTED the history of REVISIONS ... ###


			## MODIFIED in creation of 'pbs_ingr_correl_as_vs_srd.mac.D.sh' (on 2020/03/27). ##

##if (time perl $master_plscript $main_bin $seqtype $anchor_msa  $inaln_file_ref $inaln_file_rec $inlist_segs $inlist_params $outtop_dir2 $out_summ_file1 $log_dir  --sbst_model=$sbst_model --ct_rcate=$ct_rcate --alpha=$alpha --topo_search=$topo_search --resfreq=$resfreq --sv_ratio_r=$sv_ratio_r --sv_ratio_y=$sv_ratio_y  --ctrl=$ctrl_file --sbst_mtrx=$dat_file --intree=$intree ) > $logfile 2>&1 ;

##Usage:  [perl] ingr_correl_alnshear_cb_vs_srd.ver0.6.pl {inaln_file_ref} {inaln_file_rec} {inlist_segs} {inlist_params} {out_top_dir} [options] 
##   where the [options] can consist of any (or none) of the following:
##
##            --BASE_FREQS=f(A),f(G),f(C),f(T)   (default=0.25,0.25,0.25,0.25),
##                     where f(N) is the frequency of nucleotide 'N' at the root;
##
##            --TN_PARAMS=alpha1,alpha2,beta     (default=1,1,1),
##                     where alpha1 is the transitional substitution rate between A and G,
##                           alpha2 is the transitional substitution rate between C and T,
##                           beta is the transversional substitution rate;
##
##            --DIS_LEN_SRD=integer     for the maximum number of sites in a line of the SRD Map (default=30);
##
##            --CT_EFF_DGTS=integer     for the number of effective digits when displaying each SRD (default=2).


##if (time perl $master_plscript $inaln_file_ref $inaln_file_rec $inlist_segs $inlist_params $outtop_dir2 
##  ---BASE_FREQS=$BASE_FREQS --TN_PARAMS=$TN_PARAMS --DIS_LEN_SRD=$DIS_LEN_SRD --CT_EFF_DGTS=$CT_EFF_DGTS ) > $logfile 2>&1 ; # A BUG fixed on 2020/03/27.
if (time perl $master_plscript $inaln_file_ref $inaln_file_rec $inlist_segs $inlist_params $outtop_dir2 --BASE_FREQS=$BASE_FREQS --TN_PARAMS=$TN_PARAMS --DIS_LEN_SRD=$DIS_LEN_SRD --CT_EFF_DGTS=$CT_EFF_DGTS ) > $logfile 2>&1 ;
then
	echo "Successfully conducted the script '$master_plscript' !"
else
	echo "FAILED to conduct the script '$master_plscript' !"
	echo ''

	##cd 
	cd $top_tmp_dir ## Disabled as an AD-HOC measure on Mac ##

		## (Disabled the copying function and see the performance change)
		## Disabled as an AD-HOC measure on Mac ##
	##if (tar -cpf - $outtop_dir | tar -xpf - -C $PBS_O_WORKDIR/)
	##then
	##    echo "Successfully copied the outputs to the submit directory !"
	##else
	##    echo "FAILED to copy the outputs to the submit directory !!"
	##fi

	echo ''
	echo 'Time:'
	date

	exit 1
fi

####cd ..
cd $top_tmp_dir ## Disabled as an AD-HOC measure on Mac ##

	## (Disabled the copying function and see the performance change)
	## Disabled as an AD-HOC measure on Mac ##
##if (tar -cpf - $outtop_dir | tar -xpf - -C $PBS_O_WORKDIR/) 
##then
##	echo "Successfully copied the outputs to the submit directory !"
##else
##	echo "FAILED to copy the outputs to the submit directory !!"
##	exit 1
##fi


	## Disabled as an AD-HOC measure on Mac ##
##if rm -rf $outtop_dir ;
##then
##	echo "Successfully removed the temporary directory '$outtop_dir' !"
##else
##	echo "FAILED to remove the temporary directory '$outtop_dir' !"
##	exit 1
##fi 

echo ''
echo '=== ALL THE PROCESSES ENDED ==='
echo ''
echo ''
echo 'End Time:'
date

exit 0


