#!/usr/bin/perl
#
# test_cmerge_gblock_pair.pl:
#	This Perl script examines the behaviors of the subroutines, 'list_nn_purge_and_cmerge_candidates' & 'cmerge_gblock_pair', BOTH in "MyANEX_Main.pm".
#	It was created by modifying the MAIN part of 'test_purge_gblock_pair.pl'.
#	[CREATED on 2019/07/19.]
#
# test_purge_gblock_pair.pl:
#	This Perl script examines the behaviors of the subroutines, 'list_nn_purge_and_cmerge_candidates' & 'purge_gblock_pair', BOTH in "MyANEX_Main.pm".
#	It was created by modifying the MAIN part (& some other necessary parts) of 'test_serial_shifts_point2point.pl'.
#	[CREATED on 2019/07/14.]
#
# test_serial_shifts_point2point.pl:
#	This Perl script examines the behaviors of the subroutine, 'serial_shifts_point2point',
#	as well as its main satellite subroutine, 'serial_shifts_sgl_gblock', BOTH in "MyANEX_Main.pm".
#	It was created by somewhat modifying the script, 'test_compt_aln_degeneracy.pl',
#	especially its 2nd part.
#	[CREATED on 2019/07/10.]
#
# test_compt_aln_degeneracy.pl:
#	This Perl script examines the behaviors of the subroutine,
#	'compt_aln_degeneracy', in the Perl package "MyGapPatternTopology.pm".
#	It also briefly examines the behaviors of the subroutine,
#	'mk_orgs_bds_gb_coords', in "MyANEX_Supple.pm".
#	The script was created by somewhat modifying the script,
#	'test_chk_posrel_amg_vequiv_gblks.pl',
#	and by RESURRECTING the MAIN part of 'test_search_for_coll_cmpl_gblks.pl'.
#	[CREATION STARTED on 2019/04/03, ENDED on 2019/04/05.]	
#
# test_chk_posrel_amg_vequiv_gblks.pl:
#	This Perl script examines the behaviors of 4 subroutines,
#	'mk_sets_vert_equiv_gblks', 'mk_sets_swappable_gblks',
#	'chk_ovlp_bw_vequiv_gblks' and 'chk_pos_orders_amg_swpbl_gblks',
#	ALL in the Perl package "MyGapPatternTopology.pm".
#	The script was created by taking advantage of almost all parts of the script,
#	'test_vretract_gblock_ends.pl'.
#	[CREATION STARTED on 2019/03/31, ENDED on 2019/04/01.]
#	[REVISED on 2019/04/03:]
#	This revision is associated with the MAJOR revision (or augmentation) of the subroutine 'chk_ovlp_bw_vequiv_gblks'.
#
# test_vretract_gblock_ends.pl:
#	This Perl script examines the behaviors of 4 subroutines,
#	'vretract_left_end_sbj_gblk', 'vretract_right_end_sbj_gblk',
#	'vretract_right_ends_vincluded_gblks', and ' vretract_left_ends_vincluded_gblks',
#	ALL in the Perl package "MyGapPatternTopology.pm".
#	It also briefly examines the behavior of 'shift_gblock'	in "MyANEX_Main.pm".
#	The script was created by modifying the near-bottom part of the script,'test_vextend_gblock_ends.pl'.
#	[CREATED on 2019/03/28.]
#
# test_vextend_gblock_ends.pl:
#	This Perl script examines the behaviors of 4 subroutines,
#	'vextend_right_end_sbj_gblk', 'vextend_left_end_sbj_gblk',
#	'vextend_rear_ends_rflnk_vincluded_gblks' and 'vextend_rear_ends_lflnk_vincluded_gblks',
#	ALL in the Perl package "MyGapPatternTopology.pm".
#	The script was created by modifying sthe near-bottom part of the script, 'test_compt_inter_gblock_distance.pl'.
#	[CREATED on 2019/03/24.]
#
# test_compt_inter_gblock_distance.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'compt_inter_gblock_distance',
#	in the Perl package "MyGapPatternTopology.pm".
#	It also examines the behaviors of two other subroutines, 'ct_necessary_shifts' and 'compt_distance_bw_gblk_and_pt', in the same Perl package.
#	The script was created by modifying the near-bottom part of the script, 'test_search_for_coll_cmpl_gblks.pl'.
#	[CREATED on 2019/03/21.]
#
# test_search_for_coll_cmpl_gblks.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'search_for_coll_cmpl_gblks',
#	which is a conglomerate of 3 main subroutines,
#	'mk_br2up_down2blocks', 'mk_list_coll_cmpl_gblocks', and 'mk_gblock2coll_cmpl',
#	ALL in the Perl package "MyGapPatternTopology.pm".
#	It also examines a subroutine, 'mk_list_gblock_sizes', also in the package "MyGapPatternTopology.pm".
#	The script was created by modifying the MAIN part of the script, 'test_extensive_exam_inter_block_relations.pl'.
#	[CREATION STARTED on 2019/03/16, ENDED on 2019/03/19.]
#
# test_extensive_exam_inter_block_relations.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'extensive_exam_inter_block_relations', 
#       which is a conglomerate of four main subroutines,
#       'mk_inter_block_relations', 'mk_list_interfering_blocks',
#       'mk_list_interfering_blocksets', and 'mk_list_cmpl_interfering_blocksets',
#	ALL in the Perl package "MyGapPatternTopology.pm".
#	The script was created by taking advantage of the script, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl',
#	excluding the functions computing alignment probabilities under a given substitution model.
#	[CREATION STARTED on 2019/03/10, ENDED on 2019/03/12.]
#
# test_nonrec_mlt_shifts_noninf_gapblocks.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'nonrec_mlt_shifts_noninf_gapblocks', of the Perl package "MyANEX_Main.pm".
#	The script was created by slightly modifying the script 'test_shift_bl_and_compt_prob_incr.pl'.
#	[CREATION STARTED on 2019/03/03, ENDED on 2019/03/07.]
#
# test_shift_bl_and_compt_prob_incr.pl:
#	This Perl script examines the behaviors of the subroutine, 'shift_bl_and_compt_prob_incr',
#	in the Perl package "MyANEX_Main.pm".
#	It also briefly examines the behaviors of the subroutines that prepare the inputs
#	of 'shift_bl_and_compt_prob_incr'.
#	The script was created by modifying 'test_br_calc_sbst_prob_sgl_clm.pl'.
#	[CREATION STARTED on 2019/03/01, ENDED on 2019/03/03.]
#
# test_br_calc_sbst_prob_sgl_clm.pl:
#	This Perl script examines the behaviors of the subroutine, 'br_calc_sbst_prob_sgl_clm',
#	in the Perl package "MyLikelihoods_respattern_msa_dna.pm".
#	It also briefly examines the behaviors of the subroutines, 'associate_nodeids_w_msa_rows' & 'mk_init_set_columns0', in "MyANEX_Supple.pm".
#	[CREATION STARTED on 2019/02/27, ENDED on 2019/03/01.]
#
# test_calc_prob_descresstats2.pl:
#	This Perl script examines the behaviors of the subroutine, 'calc_prob_descresstats_cond_ancstat2',
#	in the Perl package 'MyLikelihoods_respattern_msa_dna.pm.'
#	The script was created by modifying 'test_calc_prob_descresstats.pl'.
#	(CREATED on Apr 30 (Sat), 2016.)
#
# test_calc_prob_descresstats.pl:
#	This Perl script examines the behavoirs of subroutines,
#	'calc_prob_descresstats_cond_ancstat' and 'calc_prob_descresstats',
#	in the Perl package 'MyPRANK_Scores.pm.'	
#	The script was created by partially exploiting the framework of 'test_create_pw_imp_score_mtrx.pl'.
#	(CREATED on Sep 20 (Sat), 2014)
#

use strict;
use warnings;

use MyMalnIO qw(
	pr_ODEN_input
	);

use MyTreeManipu_II qw( output_tree make_node2parent );

	# MODIFIED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. #
use MyLikelihoods_respattern_msa_dna qw(
	calc_prob_descresstats_cond_ancstat2
	calc_clm_probs
	br_calc_sbst_prob_sgl_clm
	);
##use MyLikelihoods_respattern_msa_dna qw(
##	calc_prob_descresstats_cond_ancstat2
##	);

=for the predecessor 'test_calc_prob_descresstats.pl'
use MyPRANK_Scores qw(
	calc_prob_descresstats_cond_ancstat
	calc_prob_descresstats
	);
=cut

	# ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (1) #
use MyTreeMap_indels_spt_odr_finer qw(
	enum_psm_indel_hsts_for_msa_finer_PRE
	enum_psm_indel_hsts_for_msa_finer_1ST_HF
	);
#use MyTreeManipu_III qw(
#	make_node2abs_depth
#	);

	# MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #
	# => The 'mk_orgs_bds_gb_coords' was further ADDED in creation of 'test_compt_aln_degeneracy.pl'. #
use MyANEX_Supple qw(
	prepare_sliding_windows
	extract_br_info_gblocks
	mk_init_set_columns0
	mk_orgs_bds_gb_coords
	);
	# MOVED 'associate_nodeids_w_msa_rows' to "use MyTreeMap_sppl qw( ...)" below, in creation of 'test_serial_shifts_point2point.pl'. #
#use MyANEX_Supple qw(
#	associate_nodeids_w_msa_rows
#	mk_init_set_columns0
#	);

	# END of "ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (1)" #

	# ADDED in creation of 'test_serial_shifts_point2point.pl'. (US) #
use MyTreeMap_sppl qw(
	associate_nodeids_w_msa_rows
	); # MOVED 'associate_nodeids_w_msa_rows' from "use MyANEX_Supple qw(...)" above, in creation of 'test_serial_shifts_point2point.pl'.
	# END of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (US)" #

	# ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0) #
use MyTreeMap_indels_spt_odr2 qw(
	br_list_gblocks
	);

	# MODIFIED in creation of 'test_purge_gblock_pair.pl'. (US) #
use MyANEX_Main qw(
	list_nn_purge_and_cmerge_candidates
	purge_gblock_pair
	cmerge_gblock_pair
	); # => Added 'cmerge_gblock_pair' in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19). #

=For the predecessor, 'test_serial_shifts_point2point.pl'. (US)
	# MODIFIED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #
	# => Further MODIFIED in creation of 'test_vretract_gblock_ends.pl'. #
	# => Yet Further MODIFIED in creation of 'test_serial_shifts_point2point.pl'. #
use MyANEX_Main qw(
	serial_shifts_point2point
	);
##use MyANEX_Main qw(
##	shift_gblock
##	);
####use MyANEX_Main qw(
####	nonrec_mlt_shifts_noninf_gapblocks
####	printout_multidim_storage
####	);
######use MyANEX_Main qw(
######	shift_bl_and_compt_prob_incr
######	);
	# END of "ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0)" #
=cut # END of "For the predecessor, 'test_serial_shifts_point2point.pl'. (US)"

	# END of "MODIFIED in creation of 'test_purge_gblock_pair.pl'. (US)" #


	# ADDED in creation of 'test_extensive_exam_inter_block_relations.pl'. (0) #
	# => MODIFIED in creation of 'test_search_for_coll_cmpl_gblks.pl'. (0) #
	# => Further MODIFIED in creation of 'test_compt_inter_gblock_distance.pl'.
	# => Yet Further MODIFIED in creation of 'test_vextend_gblock_ends.pl'.
	# => Yet Further MODIFIED, again, in creation of 'test_vretract_gblock_ends.pl'.
	# => MODIFIED, once again, in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.
use MyGapPatternTopology qw(
	mk_inter_block_relations
	mk_list_gblock_sizes
	mk_br2up_down2blocks

	search_for_coll_cmpl_gblks
	compt_aln_degeneracy

	mk_lists_gblocks_w_spec_bounds

	cts_vincluding_vincluded_onx_gblks

	vextend_right_end_sbj_gblk
	vextend_left_end_sbj_gblk
	vextend_rear_ends_rflnk_vincluded_gblks
	vextend_rear_ends_lflnk_vincluded_gblks

	vretract_left_end_sbj_gblk
	vretract_right_end_sbj_gblk
	vretract_right_ends_vincluded_gblks
	vretract_left_ends_vincluded_gblks

	mk_sets_vert_equiv_gblks
	mk_sets_swappable_gblks
	chk_ovlp_bw_vequiv_gblks
	chk_pos_orders_amg_swpbl_gblks
	);  # The 'search_for_coll_cmpl_gblks' & 'compt_aln_degeneracy' were added in creation of 'test_compt_aln_degeneracy.pl'.
	    # The 'cts_vincluding_vincluded_onx_gblks' was added in creation of 'test_serial_shifts_point2point.pl'.

##use MyGapPatternTopology qw(
##	mk_inter_block_relations
##	mk_list_gblock_sizes
##	mk_lists_gblocks_w_spec_bounds
##
##	vextend_right_end_sbj_gblk
##	vextend_left_end_sbj_gblk
##	vextend_rear_ends_rflnk_vincluded_gblks
##	vextend_rear_ends_lflnk_vincluded_gblks
##
##	vretract_left_end_sbj_gblk
##	vretract_right_end_sbj_gblk
##	vretract_right_ends_vincluded_gblks
##	vretract_left_ends_vincluded_gblks
##	);
####use MyGapPatternTopology qw(
####	mk_inter_block_relations
####	mk_lists_gblocks_w_spec_bounds
####	vextend_right_end_sbj_gblk
####	vextend_left_end_sbj_gblk
####	vextend_rear_ends_rflnk_vincluded_gblks
####	vextend_rear_ends_lflnk_vincluded_gblks
####	);
######use MyGapPatternTopology qw(
######	mk_inter_block_relations
######	ct_necessary_shifts
######	compt_distance_bw_gblk_and_pt
######	compt_inter_gblock_distance
######	);
########use MyGapPatternTopology qw(
########	mk_inter_block_relations
########	extensive_exam_inter_block_relations
########	mk_list_gblock_sizes
########	search_for_coll_cmpl_gblks
########	);
##########use MyGapPatternTopology qw(
##########	extensive_exam_inter_block_relations
##########	);

	# END of "ADDED in creation of 'test_extensive_exam_inter_block_relations.pl'. (0)" #


$| = 1; # Flush the input buffer as soon as it receives data.

my ($plscript_name) = ($0 =~ m!([^/]+)$!);

	### Glogal parameter setting ###

our $TOP_NODE = $MyTreeManipu_II::TOP_NODE;
our $INDX_LENGTH = $MyTreeManipu_II::INDX_LENGTH;
##our $INDX_BOOT = $MyTreeManipu_II::INDX_BOOT;

our $GAP = '-';
our $CHAR_PRES = 'N'; # Added on 2019/02/28.

our @RESIDUES = our @NUCLEOTIDES = @MyLikelihoods_respattern_msa_dna::NUCLEOTIDES; # Unless otherwise stated, nucleotide MSA scores will be calculated according to this order (or index assignment) of the nucleotide bases.
##our @RESIDUES = our @NUCLEOTIDES = @MyPRANK_Scores::NUCLEOTIDES; # Unless otherwise stated, nucleotide MSA scores will be calculated according to this order (or index assignment) of the nucleotide bases.
our $CT_NUCLS = @NUCLEOTIDES;

my @labels_resfreqs = ();
foreach my $res (@NUCLEOTIDES) { push @labels_resfreqs, "f($res)"; }


our $STRING_UNDEF = 'undef'; # Added on 2019/03/04. #
##our $STRING_UNDEF = 'N/A'; # Added on 2019/03/04. #

our $MAXCT_1WAY_SHIFTS = 10; # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

	# ADDED in creation of 'test_purge_gblock_pair.pl'. (GL1) #
our $THRSH_DIST_PURGE  = $MAXCT_1WAY_SHIFTS;
our $THRSH_DIST_CMERGE = $MAXCT_1WAY_SHIFTS;
	# END of "ADDED in creation of 'test_purge_gblock_pair.pl'. (GL1)" #


=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL1)
$MyGapPatternTopology::SOPHIST_MVBLTY_TEST_FOR_CAD = 1; # ADDED in MAJOR REVISION of 'test_compt_aln_degeneracy.pl' regarding 'compt_aln_degeneracy' (on 2019/04/05).
=cut # End of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL1)"

	### Parameters to adjust the verboseness of the test outputs. ###
	### (0, silent; 1, very modest; 2, modest; 3, medium; 4, verbose; 5, very verbose.)

=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL2)
        # For 'calc_prob_descresstats_cond_ancstat2'. #
$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 0;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 1;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 5;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 6;
=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL2)"

=for the predecessor 'test_calc_prob_descresstats.pl'
        # For 'calc_prob_descresstats_cond_ancstat'. #
##$MyPRANK_Scores::TEST_LEVEL_cpdca = 0;
##$MyPRANK_Scores::TEST_LEVEL_cpdca = 5;
$MyPRANK_Scores::TEST_LEVEL_cpdca = 6;
=cut


	# ADDED in creation of 'test_cmerge_gblock_pair.pl'. (GL) #
$MyANEX_Main::TEST_LEVEL_cmrg_gbp = 6;
	# END of "ADDED in creation of 'test_cmerge_gblock_pair.pl'. (GL)" #

=For the predecessor, 'test_purge_gblock_pair.pl'. (GL1)
	# ADDED in creation of 'test_purge_gblock_pair.pl'. (GL 2) #
$MyANEX_Main::TEST_LEVEL_prg_gbp = 6;
	# END of "ADDED in creation of 'test_purge_gblock_pair.pl'. (GL 2)" #
=cut # END of "For the predecessor, 'test_purge_gblock_pair.pl'. (GL1)"

=For the predecessor, 'test_serial_shifts_point2point.pl'. (GL)
	# ADDED in creation of 'test_serial_shifts_point2point.pl'. (GL) #
$MyANEX_Main::TEST_LEVEL_ssh_p2p = 5;
$MyANEX_Main::TEST_LEVEL_ssh_sgblk = 5;
	# END of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (GL)" #
=cut # END of "For the predecessor, 'test_serial_shifts_point2point.pl'. (GL)"

	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1b)
$MyANEX_Main::TEST_LEVEL_sh_gblk = 0;
##$MyANEX_Main::TEST_LEVEL_sh_gblk = 5;
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1b)"


=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL3)

	# Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0b) #

	# For 'shift_bl_and_compt_prob_incr'. #
$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr = 0;
##$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr = 5;

	# END of "Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0b)" #

	# ADDED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (0b) #

	# For 'nonrec_mlt_shifts_noninf_gapblocks'. #
$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = 0;
##$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = 6;

	# END of "ADDED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (0b)" #

	# ADDED in creation of 'test_extensive_exam_inter_block_relations.pl'. (0b) #

	# For the subroutine, 'extensive_exam_inter_block_relations':
$MyGapPatternTopology::TEST_LEVEL_exex_iblk_rltns = 0;
##$MyGapPatternTopology::TEST_LEVEL_exex_iblk_rltns = 1;
##$MyGapPatternTopology::TEST_LEVEL_exex_iblk_rltns = 5;

	# END of "ADDED in creation of 'test_extensive_exam_inter_block_relations.pl'. (0b)" #

	# ADDED in creation of 'test_search_for_coll_cmpl_gblks.pl'. (0b) #

	# For the subroutine, 'search_for_coll_cmpl_gblks':
 ##$MyGapPatternTopology::TEST_LEVEL_sch4ccgb = 0;
 ##$MyGapPatternTopology::TEST_LEVEL_sch4ccgb = 1;
 $MyGapPatternTopology::TEST_LEVEL_sch4ccgb = 5;
	# END of "ADDED in creation of 'test_search_for_coll_cmpl_gblks.pl'. (0b)" #

	# ADDED in creation of 'test_compt_aln_degeneracy.pl'. (0b) #

	# For the subroutine 'compt_aln_degeneracy'.
##$MyGapPatternTopology::TEST_LEVEL_cad = 0;
##$MyGapPatternTopology::TEST_LEVEL_cad = 1;
$MyGapPatternTopology::TEST_LEVEL_cad = 5;

	# END of "ADDED in creation of 'test_compt_aln_degeneracy.pl'. (0b)" #
=cut # End of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (GL3)"


	# ADDED in creation of 'test_vextend_gblock_ends.pl'. (0b) #

	# For the subroutine, 'vextend_right_end_sbj_gblk':
$MyGapPatternTopology::TEST_LEVEL_vx_re_sgb = 0;
## $MyGapPatternTopology::TEST_LEVEL_vx_re_sgb = 3;

	# For the subroutine, 'vextend_left_end_sbj_gblk':
 $MyGapPatternTopology::TEST_LEVEL_vx_le_sgb = 0;
 ##$MyGapPatternTopology::TEST_LEVEL_vx_le_sgb = 3;

	# END of "ADDED in creation of 'test_vextend_gblock_ends.pl'. (0b)" #

	### Input Variables. ###

	# Equilibrium residue frequencies. #

my @equil_resfreqs = (0.1, 0.2, 0.3, 0.4);

	# Full MSA. #


	# MOVED to below (with modification) (on 2019/03/01).
##my $ct_seqs = 4;
##
##my @seqids = ();
##for (my $k=1; $k<=$ct_seqs; $k++) { push @seqids, sprintf ("seq%04d", $k); }

=for tests 1, 1p

our %LRBDS2SHIFT = ("6:7" => -1); # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

my @sequences = (
	#0123456789
	"at-gca--gc", # seq 1
	"attg--ttgc", # seq 2
	"-ttg--ttgc", # seq 3
	"attgca--gc", # seq 4
	);
=cut

	# MODIFIED in creation of 'test_vextend_gblock_ends.pl'. (1) #
=for tests 2, 2p

our %LRBDS2SHIFT = ("0:0" => +1); # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

my @sequences = (
	#0123456789
	"at--", # seq 1
	"g---", # seq 2
	"---c", # seq 3
	"--gt", # seq 4
	);
=cut
##=for tests 2, 2p
##my @sequences = (
##	#0123456789
##	"at---", # seq 1
##	"g----", # seq 2
##	"----c", # seq 3
##	"---gt", # seq 4
##	);
##=cut
	# END of "MODIFIED in creation of 'test_vextend_gblock_ends.pl'. (1)" #

	# ADDED in creation of 'test_serial_shifts_point2point.pl'. (IN) #
=for tests 2ext.

our %LRBDS2SHIFT = ("0:0" => +1, "3:3" => -1);

my @sequences = (
	#0123456789
	"at--", # seq 1
	"g---", # seq 2
	"---c", # seq 3
	"--gt", # seq 4
	);
=cut # End of "for tests 2ext."
	# END of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (IN)" #

=for tests 3 & 3p & 3pp & 3ext.

our %LRBDS2SHIFT = ("1:3" => +4, "4:4" => +4); # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

my @sequences = (
	#0123456789AB
	"a---atgcatgc", # seq 1
	"a---atacatac", # seq 2
	"gtgc-cgtatcc", # seq 3
	"atgc-tgcatgc", # seq 4
	"ataca----tgt", # seq 5
	"gtacg----tgt", # seq 6
	);
=cut # End of "for tests 3 & 3p & 3pp & 3ext."
=for tests 5 & 5p & 5pp.
my @sequences = (
	#0123456789ABCD
	"a---atgcatgctg", # seq 1
	"a---atacatactg", # seq 2
	"gtgc-cgtatcccg", # seq 3
	"atgc-tgcatgcca", # seq 4
	"atacat---tgttg", # seq 5
	"gtacgtgca---tg", # seq 6
	);
=cut # End of "for tests 5 & 5p & 5pp."
=for test 5ext.

our %LRBDS2SHIFT = ("0:3" => +4, "8:10" => -3); # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

my @sequences = (
	#0123456789ABCD
	"----atgcatgctg", # seq 1
	"----atacatactg", # seq 2
	"gtgc-cgtatcccg", # seq 3
	"atgc-tgcatgcca", # seq 4
	"ataca---atgttg", # seq 5
	"gtacgtgc---ttg", # seq 6
	);
=cut # End of "for test 5ext."
=for tests 6 & 6p & 6pp.
my @sequences = (
	#0123456789ABCD
	"a---atgcatgct--g", # seq 1
	"a---atacatact--g", # seq 2
	"gtgc-cgtatccct-g", # seq 3
	"atgc-tgcatgcct-a", # seq 4
	"atacat---tgtt-ag", # seq 5
	"gtacgtgca---t--g", # seq 6
	);
=cut # End of "for tests 6 & 6p & 6pp."
=for test 7.
my @sequences = (
	#0123456789ABCDEFG
	"a-----atgcatg-ctg", # seq 1
	"a-----atacata-ctg", # seq 2
	"gtgt-c-cgtatcgccg", # seq 3
	"atgt-c-tgcatggcca", # seq 4
	"ata-acat---tg-ttg", # seq 5
	"gta--cgtgca----tg", # seq 6
	);
=cut # End of "for test 7."
=for test 8.
my @sequences = (
	#0123456789AB
	"at--------gc", # seq 1
	"a----------c", # seq 2
	"gtg---gtatcc", # seq 3
	"gtg---gtatcc", # seq 4
	"atgcatg--tgc", # seq 5
	"atgc-tg--tgc", # seq 6
	);
=cut # End of "for test 8."

=for test 9.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (1,4);
our $SHIFT = +1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"g---------------cg", # seq 1
	"g------------cgc--", # seq 2
	"g---------------cg", # seq 3
	"g----------------g", # seq 4
	"gtgta-----gtg---cg", # seq 5
	"gtgtacccta------cg", # seq 6
	);
=cut # End of "for test 9."
=for test 10.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (13, 16);
our $SHIFT = -1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"gc---------------g", # seq 1
	"--cgc------------g", # seq 2
	"gc---------------g", # seq 3
	"g----------------g", # seq 4
	"gc---gtg-----atgtg", # seq 5
	"gc------atcccatgtg", # seq 6
	);
=cut # End of "for test 10."

=for test 11.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (1,4);
our $SHIFT = +1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"g---------------cg", # seq 1
	"g------------cgc-a", # seq 2
	"g---------------cg", # seq 3
	"g----------------g", # seq 4
	"gtgta-----gtg---cg", # seq 5
	"gtgtacccta-------g", # seq 6
	);
=cut # End of "for test 11."
=for test 12.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (13, 16);
our $SHIFT = -1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"gc---------------g", # seq 1
	"a-cgc------------g", # seq 2
	"gc---------------g", # seq 3
	"g----------------g", # seq 4
	"gc---gtg-----atgtg", # seq 5
	"g-------atcccatgtg", # seq 6
	);
=cut # End of "for test 12."

=for test 13.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (4,4);
our $SHIFT = +1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"gtgt------------cg", # seq 1
	"gtgt---------cgc-a", # seq 2
	"gt--------------cg", # seq 3
	"g----------------g", # seq 4
	"gtgta-----gtg---cg", # seq 5
	"gtgtacccta-------g", # seq 6
	);
=cut # End of "for test 13."
=for test 14.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)
our ($LBD_SBJ, $RBD_SBJ) = (13, 13);
our $SHIFT = -1; # "+1" or "-1"
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (1a)"

my @sequences = (
	#012345678901234567
	"gc------------tgtg", # seq 1
	"a-cgc---------tgtg", # seq 2
	"gc--------------tg", # seq 3
	"g----------------g", # seq 4
	"gc---gtg-----atgtg", # seq 5
	"g-------atcccatgtg", # seq 6
	);
=cut # End of "for test 14."

	#  ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (0c) #

=for tests 15A & 15B.

our ($LBD_SBJ, $RBD_SBJ) = (11,11); # For 15A
our $SHIFT = +6; # For 15A

#our ($LBD_SBJ, $RBD_SBJ) = (9,9); # For 15B
#our $SHIFT = -6; # For 15B

my @sequences = (
	#012345678901234567
	"gtgt-c--t-gtgcctag", # seq 1
	"gtgt-c--t-gtg---ag", # seq 2
	"gtgt-c--t-gtgcctag", # seq 3
	"gtgt-c--t-gtgcctag", # seq 4
	"gtgtaccctag-g-c--g", # seq 5
	"--gtaccctag-g-c--g", # seq 6
	);
=cut # End of "for tests 15A & 15B."

=for test 16.

#our ($LBD_SBJ, $RBD_SBJ) = (10,10);
#our $SHIFT = +6;
#our %LRBDS2SHIFT = ("10:10" => +6); # For "pre-test16".
our %LRBDS2SHIFT = ("10:10" => -2);

my @sequences = (
	#012345678901234567
	"gtgt-c--t-gtgcctag", # seq 1
	"gtgt-c--t-gtg---ag", # seq 2
	"gtgt-c--t-gt-cctag", # seq 3
	"gtgt-c--t-gt-cctag", # seq 4
	"gtgtacccta-t--c--g", # seq 5
	"--gtacccta-t--c--g", # seq 6
	);
=cut # End of "for test 16."

=for test 17.

##our ($LBD_SBJ, $RBD_SBJ) = (9,9);
##our $SHIFT = -6;
##our %LRBDS2SHIFT = ("9:9" => -6); # For "pre-test17".
our %LRBDS2SHIFT = ("10:10" => -4);

my @sequences = (
	#012345678901234567
	"gtgt-c--t-gtgcctag", # seq 1
	"gtgt-c--t-gtg---ag", # seq 2
	"gtgt-c----gtgcctag", # seq 3
	"gtgt-c----gtgcctag", # seq 4
	"gtgtaccc-a-tg-c--g", # seq 5
	"--gtaccc-a-tg-c--g", # seq 6
	);
=cut # End of "for test 17."

	#  END of "ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (0c)" #

=for test 25.
my @sequences = (
	#012345678901234567
	"gtgt---tagtgcctag", # seq 1
	"gtgt---tagtgcctag", # seq 2
	"gtg------gtgc-tag", # seq 3
	"gtg------gtgc-tag", # seq 4
	"gtgtacctagtg---ag", # seq 5
	"gtgta-ctagt-----g", # seq 6
	);
=cut # End of "for test 25."

		# ADDED in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19-20). (IN) #
=for test 26.
my @sequences = (
	#01234567890123456
	"gtg----tagtgcctag", # seq 1
	"gtg----tagtgcctag", # seq 2
	"gt-------gtgc-tag", # seq 3
	"gt-------gtgc-tag", # seq 4
	"gtgtacctagtg---ag", # seq 5
	"gtgta-ctagt-----g", # seq 6
	);
=cut # End of "for test 26."
=for test 26rev.
my @sequences = (
	#01234567890123456
	"tgcctaggtg----tag", # seq 1
	"tgcctaggtg----tag", # seq 2
	"tgc-taggt-------g", # seq 3
	"tgc-taggt-------g", # seq 4
	"tg---aggtgtacctag", # seq 5
	"t-----ggtgta-ctag", # seq 6
	);
=cut # End of "for test 26rev."
=for test 27.
my @sequences = (
	#01234567890123456
	"tgt---taggtgcctag", # seq 1
	"tgt---taggtgcctag", # seq 2
	"tg------ggtgc-tag", # seq 3
	"tg------ggtgc-tag", # seq 4
	"tgtacctaggt----ag", # seq 5
	"tgta-ctagg------g", # seq 6
	);
=cut # End of "for test 27."
=for test 27rev.
my @sequences = (
	#01234567890123456
	"gtgcctagtgt---tag", # seq 1
	"gtgcctagtgt---tag", # seq 2
	"gtgc-tagtg------g", # seq 3
	"gtgc-tagtg------g", # seq 4
	"gt----agtgtacctag", # seq 5
	"g------gtgta-ctag", # seq 6
	);
=cut # End of "for test 27rev."
=for test 28.
my @sequences = (
	#0123456789012345
	"gtg-----agtgctag", # seq 1
	"gtg-----agtgctag", # seq 2
	"gtg-----agtgctag", # seq 3
	"gtg-----agtgctag", # seq 4
	"gtgtacctagtg--ag", # seq 5
	"gtgt--ctagtg--ag", # seq 6
	);
=cut # End of "for test 28."
=for test 28rev.
my @sequences = (
	#0123456789012345
	"gtgctaggtg-----a", # seq 1
	"gtgctaggtg-----a", # seq 2
	"gtgctaggtg-----a", # seq 3
	"gtgctaggtg-----a", # seq 4
	"gtg--aggtgtaccta", # seq 5
	"gtg--aggtgta--ta", # seq 6
	);
=cut # End of "for test 28rev."
=for test 29.
my @sequences = (
	#0123456789012345
	"tg--aggtgctgcag", # seq 1
	"tg--aggtgctgcag", # seq 2
	"tg----gtgctgcag", # seq 3
	"tg----gtgctgcag", # seq 4
	"tgct--gtg----ag", # seq 5
	"tgct--gtg----ag", # seq 6
	);
=cut # End of "for test 29."
#=for test 29rev.
my @sequences = (
	#0123456789012345
	"tgctgcagtgag--g", # seq 1
	"tgctgcagtgag--g", # seq 2
	"tgctgcagtg----g", # seq 3
	"tgctgcagtg----g", # seq 4
	"tg----agtg--ctg", # seq 5
	"tg----agtg--ctg", # seq 6
	);
#=cut # End of "for test 29rev."
		# END of "ADDED in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19-20). (IN)" #



=For test 3.
my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([0, 3], [1, 3], [1, 3]);
##my @bds_bl_coords = ([0, 4], [0, 4], [0, 4]);
=cut # End of "For test 3."
=For test 3ext.
my @org_bl_coords = (1, 4, 5);
my @bds_bl_coords = ([0, 9], [0, 11], [0, 8]);
=cut # End of "For test 3ext."
=For test 5.
my @org_bl_coords = (1, 4, 6, 9);
my @bds_bl_coords = ([0, 10], [0, 13], [0, 11], [0, 11]);
=cut # End of "For test 5."


=DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #
	## Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0c) #

	# Set of $bl-$sh pairs to be tried. #
#my @set_bl_sh_pairs = ([0, +1], [0, +1], [2, -1], [2, -1]); # For test 3A.
#my @set_bl_sh_pairs = ([0, -2], [0, -1], [0, -1]); # For test 3B.
my @set_bl_sh_pairs = ([2, +2], [2, +1], [2, +1], [2, +1], [2, +1]); # For test 3C.

	## END of "Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0c)" #

=cut # END of "DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'." #


	# MOVED from above with modification (on 2019/03/01). #
my $ct_seqs = @sequences;

my @seqids = ();
for (my $k=1; $k<=$ct_seqs; $k++) { push @seqids, sprintf ("seq%04d", $k); }

	# END of "MOVED from above with modification (on 2019/03/01)." #


my @full_msa = ();
foreach my $seq (@sequences) { push @full_msa, \$seq; }

my $lenaln = length $sequences[0] ;


	# Phylogenetic Tree. #

=for tests 1 & 2
my %node2ch = (
	5 => [1, 2],
	6 => [3, 4],
	7 => [5, 6],
	);
my %name2id = (
	$TOP_NODE => 7,
	);
=cut # End of "for tests 1 & 2"
=for tests 1p & 2p
my %node2ch = (
	5 => [1, 2],
	6 => [3, 4, 5],
	);
my %name2id = (
	$TOP_NODE => 6,
	);
=cut # End of "for tests 1p & 2p"
#=for tests 3, 3ext, 5, 6, 7, 8, 9-15.
my %node2ch = (
	7 => [1, 2],
	8 => [3, 4],
	9 => [5, 6],
	10 => [7,8],
	11 => [9, 10],
	);
my %name2id = (
	$TOP_NODE => 11,
	);
#=cut # End of "for tests 3, 3ext, 5, 6, 7, 8, 9-15."
=for tests 3p, 5p, 6p.
my %node2ch = (
	7 => [1, 2],
	8 => [3, 4],
	9 => [5, 6],
	10 => [7,8, 9],
	);
my %name2id = (
	$TOP_NODE => 10,
	);
=cut # End of "for tests 3p, 5p, 6p."
=for tests 3pp, 5pp, 6pp.
my %node2ch = (
	7 => [1, 2],
	8 => [3, 4],
	9 => [5, 6],
	10 => [8, 9],
	11 => [7, 10],
	);
my %name2id = (
	$TOP_NODE => 11,
	);
=cut # End of "for tests 3pp, 5pp, 6pp."

for (my $k=0; $k< $ct_seqs; $k++) { my $name = $seqids[$k]; $name2id{$name} = $k +1; }


	# Pre-processing before the main tests. #

my $node2pa = make_node2parent (%node2ch);
my %id2name;
foreach my $name (keys %name2id) { # 2nd preliminary foreach-loop #
	($name eq $TOP_NODE) and next;
	my $id = $name2id{$name};
	$id2name{$id} = $name;
}			# End of the 2nd preliminary foreach-loop #
my $topnode_id = $name2id{$TOP_NODE};

my %br_attr ; # Dummy.


	# Assign 'transition matrix' to each branch in the tree. #

=for tests 1 & 2.
my %br2tr_mtrx = (
	1 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	2 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	3 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	4 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	5 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	6 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],
	);
=cut # End of "for tests 1 & 2."

#=for tests 3, 3ext, 5.
my %br2tr_mtrx = (
	1 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	2 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	3 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	4 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	5 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	6 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	7 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	8 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	9 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	10 =>  [ [0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	##11 =>  [ [0.4, 0.1, 0.2, 0.3],
	##	[0.7, 0.1, 0.1, 0.1],
	##	[0.4, 0.3, 0.1, 0.2],
	##	[0.4, 0.2, 0.2, 0.2] ], # Usually, NO transition matrix is assigned to the root.

	);
#=cut # End of "for tests 3, 3ext, 5."


	### Declare the beginning of the script ###

print STDOUT "\n<<<< Program name: $plscript_name (path: $0) >>>>\n\n";

print STDOUT "<< Glogal Parameters >>\n\n";

=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 1)
	# ADDED in MAJOR REVISION of 'test_compt_aln_degeneracy.pl' regarding 'compt_aln_degeneracy' (on 2019/04/05).
print STDOUT '$MyGapPatternTopology::SOPHIST_MVBLTY_TEST_FOR_CAD = ', $MyGapPatternTopology::SOPHIST_MVBLTY_TEST_FOR_CAD , " .\n\n\n";
	# END of "ADDED in MAJOR REVISION of 'test_compt_aln_degeneracy.pl' regarding 'compt_aln_degeneracy' (on 2019/04/05)."
=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 1)"



=DISABLED in creation of 'test_purge_gblock_pair.pl'. (DC 1)
	# ADDED in creation of 'test_compt_aln_degeneracy.pl'. #
print STDOUT '%LRBDS2SHIFT = ( # "$lbd_sbj:$rbd_sbj" => $shift,', "\n";
foreach my $lrbds (sort keys %LRBDS2SHIFT) {
	print STDOUT "\t", $lrbds, ' => ', $LRBDS2SHIFT{$lrbds}, ",\n";
}
print STDOUT "\t) .\n\n";
=cut # END of "DISABLED in creation of 'test_purge_gblock_pair.pl'. (DC 1)"


=DISABLED in creation of 'test_compt_aln_degeneracy.pl'.
	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (2a)
print STDOUT '($LBD_SBJ, $RBD_SBJ) = ', "($LBD_SBJ, $RBD_SBJ) .\n\n";
print STDOUT '$SHIFT = ', "$SHIFT .\n\n";
	# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (2a)"
=cut # END of "DISABLED in creation of 'test_compt_aln_degeneracy.pl'."

print STDOUT '$GAP = ', $GAP, " ,\n";
print STDOUT '$CHAR_PRES = ', $CHAR_PRES, " .\n\n"; # Added on 2019/03/01.

print STDOUT '$STRING_UNDEF = ', $STRING_UNDEF, " .\n\n"; # Added on 2019/03/04. #

print STDOUT '$MAXCT_1WAY_SHIFTS  = ', $MAXCT_1WAY_SHIFTS , " .\n\n"; # ADDED in creation of 'test_compt_aln_degeneracy.pl'.

	# ADDED in creation of 'test_purge_gblock_pair.pl'. (DC 2) #
print STDOUT '$THRSH_DIST_PURGE  = ', $THRSH_DIST_PURGE , " ,\n";
print STDOUT '$THRSH_DIST_CMERGE = ', $THRSH_DIST_CMERGE , " .\n\n";
	# END of "ADDED in creation of 'test_purge_gblock_pair.pl'. (DC 2)" #


=DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (1)

print STDOUT '$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = ', $MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca, " .\n\n";
##print STDOUT '$MyPRANK_Scores::TEST_LEVEL_cpdca = ', $MyPRANK_Scores::TEST_LEVEL_cpdca, " .\n\n"; # For the predecessor 'test_calc_prob_descresstats.pl'.

print STDOUT '$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr  = ', $MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr , " .\n\n"; # Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'#

print STDOUT '$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = ', $MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks , " .\n\n"; # Added in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #

=cut # END of "DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (1)"

=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 2)
print STDOUT '$MyGapPatternTopology::TEST_LEVEL_exex_iblk_rltns = ', $MyGapPatternTopology::TEST_LEVEL_exex_iblk_rltns, " .\n\n"; # ADDED in creation of 'test_extensive_exam_inter_block_relations.pl'.


##=DISABLED in creation of 'test_compt_inter_gblock_distance.pl'. (2) => RESURRECTED in creation of 'test_compt_aln_degeneracy.pl'.
print STDOUT '$MyGapPatternTopology::TEST_LEVEL_sch4ccgb = ', $MyGapPatternTopology::TEST_LEVEL_sch4ccgb, " .\n\n"; # ADDED in creation of 'test_search_for_coll_cmpl_gblks.pl'. 
##=cut # END of "DISABLED in creation of 'test_compt_inter_gblock_distance.pl'. (2) => RESURRECTED in creation of 'test_compt_aln_degeneracy.pl'."
=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 2)"

=DISABLED in creation of 'test_vretract_gblock_ends.pl'. (1)
	# ADDED in creation of 'test_vextend_gblock_ends.pl'. (0c) #
print STDOUT '$MyGapPatternTopology::TEST_LEVEL_vx_re_sgb = ', $MyGapPatternTopology::TEST_LEVEL_vx_re_sgb, " ,\n\n";

print STDOUT '$MyGapPatternTopology::TEST_LEVEL_vx_le_sgb = ', $MyGapPatternTopology::TEST_LEVEL_vx_le_sgb, " .\n\n\n";
	# END of "ADDED in creation of 'test_vextend_gblock_ends.pl'. (0c)" #
=cut # END of "DISABLED in creation of 'test_vretract_gblock_ends.pl'. (1)"

	# ADDED in creation of 'test_cmerge_gblock_pair.pl'. (DC) #
print STDOUT '$MyANEX_Main::TEST_LEVEL_cmrg_gbp = ', $MyANEX_Main::TEST_LEVEL_cmrg_gbp, " ,\n\n";
	# END of "ADDED in creation of 'test_cmerge_gblock_pair.pl'. (DC)" #

=For the predecessor, 'test_purge_gblock_pair.pl'. (DC1)
	# ADDED in creation of 'test_purge_gblock_pair.pl'. (DC 3) #
print STDOUT '$MyANEX_Main::TEST_LEVEL_prg_gbp = ', $MyANEX_Main::TEST_LEVEL_prg_gbp, " ,\n\n";
	# END of "ADDED in creation of 'test_purge_gblock_pair.pl'. (DC 3)" #
=cut # END of "For the predecessor, 'test_purge_gblock_pair.pl'. (DC1)"

=For the predecessor, 'test_serial_shifts_point2point.pl'. (DC 2)
		# ADDED in creation of 'test_serial_shifts_point2point.pl'. (DC) #
print STDOUT '$MyANEX_Main::TEST_LEVEL_ssh_p2p = ', $MyANEX_Main::TEST_LEVEL_ssh_p2p, " ,\n\n";
print STDOUT '$MyANEX_Main::TEST_LEVEL_ssh_sgblk = ', $MyANEX_Main::TEST_LEVEL_ssh_sgblk, " ,\n\n";
		# End of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (DC)" #
=cut # END of "For the predecessor, 'test_serial_shifts_point2point.pl'. (DC 2)"


print STDOUT '$MyANEX_Main::TEST_LEVEL_sh_gblk  = ', $MyANEX_Main::TEST_LEVEL_sh_gblk , " .\n\n\n"; # ADDED in creation of 'test_vretract_gblock_ends.pl'. (2b)

=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 3)
print STDOUT '$MyGapPatternTopology::TEST_LEVEL_cad  = ', $MyGapPatternTopology::TEST_LEVEL_cad , " .\n\n\n"; # ADDED in creation of 'test_compt_aln_degeneracy.pl'. #
=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (DC 3)"


print STDOUT "\n<<< Input Variables >>>\n\n";

print STDOUT "\n< Input Alignment ( Size = $ct_seqs (#{sequences}) x $lenaln (#{sites}) ) >\n\n";

unless ( pr_ODEN_input (@seqids, @full_msa, 50, *STDOUT ) ) {
	print STDOUT "[ERROR '$plscript_name'] 'pr_ODEN_input' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n";
	die ;
}
print STDOUT "\n\n";

print STDOUT "\n< Phylogenetic Tree of the Aligned Sequences (Top node: $topnode_id) >\n\n";

unless ( output_tree ($topnode_id, %node2ch, %id2name, %br_attr, *STDOUT, 1, 1) ) {
	print STDOUT "[ERROR '$plscript_name'] The subroutine 'output_tree' FAILED to print out the input tree !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n";
	die ;
}

print STDOUT "\n\n< Relationships between Nodes >\n\n";
print STDOUT join ("\t", 'Node_ID', 'parent', '[child,node,IDs]'), "\n\n";

foreach my $node (sort {$a <=> $b} keys %{$node2pa}, $topnode_id) {
	my $pa = $node2pa->{$node};
	(defined $pa) or ($pa = 'undef');
	my $children = $node2ch{$node};
	my $cnct_children = (defined $children) ? join (',', @{$children}) : '';
	print STDOUT join ("\t", $node, $pa, "[$cnct_children]"), "\n";
}
print STDOUT "\n\n";


=DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (2)

print STDOUT "\n< Residue Frequences at the root node >\n\n";
##print STDOUT "\n< Equilibrium Residue Frequences >\n\n";

print STDOUT "Freq [", join (', ', @RESIDUES), "] = (", join (', ', @equil_resfreqs), ") .\n\n";

print STDOUT "\n< Substitution Transition Matrices Assigned to the Branches >\n\n";

foreach my $br_id (sort {$a <=> $b} keys %br2tr_mtrx) {

	my $tr_mtrx = $br2tr_mtrx{$br_id};

	print STDOUT ' ' x 3, "( Branch ID: $br_id )\n\n";
	print STDOUT ' ' x 3, join ("\t", 'From\To', @RESIDUES), "\n\n";
	for (my $r=0; $r<$CT_NUCLS; $r++) { print STDOUT ' ' x 3, join ("\t", $RESIDUES[$r], @{$tr_mtrx->[$r]}), "\n"; }
	print STDOUT "\n\n";
}
=cut # END of "DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (2)"

	# ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (0a) #

print STDOUT "\n\n<< Preliminary (0a): Copy the input MSA >>\n\n\n";

my @cp_full_msa = ();
foreach my $seq (@full_msa) {
	my $cp_seq = ${$seq};
	push @cp_full_msa, \$cp_seq;
}

print STDOUT "... Finished Copying the MSA !!\n\n\n";

print STDOUT "\n\n<< Preliminary (0b): Compute the depth and #[external offsprings} of every node >>\n\n\n";

my ($node2depth, $node2ct_exoffs, $br2eq, $br2nn, $set_all_nodes) 
    = enum_psm_indel_hsts_for_msa_finer_PRE ($topnode_id, %node2ch, %{$node2pa});
unless (defined $set_all_nodes) {
	print STDOUT "[ERROR '$plscript_name'] The 0th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_PRE' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 0th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_PRE' ENDED ...\n\n";

##my $node2depth = make_node2abs_depth ($topnode_id, %node2ch);
##unless (defined $node2depth) {
##	print STDOUT "[ERROR '$plscript_name'] The 0th Preliminary Subroutine 'make_node2abs_depth' FAILED !\n";
##	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
##	die ;
##}
##print STDOUT "\n --- The 0th Preliminary Subroutine 'make_node2abs_depth' ENDED ...\n\n";

print STDOUT "\n<< Contents of the Preliminary Output (0b), ", '%{$node2depth} & %{$node2ct_exoffs}', " >>\n\n";

print STDOUT join ("\t", 'Node_ID', 'depth', '#{external_offsprings}'), "\n\n";

foreach my $node (sort { $a <=> $b } keys %{$node2depth}) {
	my $depth = $node2depth->{$node};
	my $ct_exoffs = $node2ct_exoffs->{$node};
	unless (defined $ct_exoffs) { $ct_exoffs = 'undef'; }
	print STDOUT join ("\t", $node, $depth, $ct_exoffs), "\n";
}
print STDOUT "\n\n";

	# END of "ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (0a)" #


=DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (3)

print STDOUT "\n\n<<< Preliminary (1): Calculate the Conditional Probabilities of the Residue States of Descendants of Each Ancestor Node, given the Residue States at the Ancestor. >>>\n\n\n"; # MODIFIED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. #
##print STDOUT "\n\n<<< Now, Calculate the Conditional Probabilities of the Residue States of Descendants of Each Ancestor Node, given the Residue States at the Ancestor. >>>\n\n\n";

	## MODIFIED in creation of 'test_calc_prob_descresstats2.pl'. ##
my ($node2set_sw_cond_probs, $node2set_sw_extcond_probs0) = calc_prob_descresstats_cond_ancstat2 (@full_msa, @seqids, %name2id, %node2ch, %br2tr_mtrx, $GAP);
##my $node2set_sw_cond_probs = calc_prob_descresstats_cond_ancstat (@full_msa, @seqids, %name2id, %node2ch, %br2tr_mtrx, $GAP);

unless (defined $node2set_sw_cond_probs) {
	print STDOUT "[ERROR '$plscript_name'] The 1st Preliminary Subroutine 'calc_prob_descresstats_cond_ancstat2' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 1st Preliminary Subroutine 'calc_prob_descresstats_cond_ancstat2' ENDED ...\n\n";
##print STDOUT "\n --- The MAIN Subroutine 'calc_prob_descresstats_cond_ancstat2' ENDED ...\n\n";

print STDOUT "\n<< Contents of the Preliminary Output (1a), ", '%{$node2set_sw_cond_probs}', " >>\n\n";
##print STDOUT "\n<< Contents of the Main Output (1), ", '%{$node2set_sw_cond_probs}', " >>\n\n";

foreach my $node_id (sort {$a <=> $b} keys %{$node2set_sw_cond_probs}) { # 1st preliminary outer foreach-loop (over nodes). #

	my $set_sw_cond_probs = $node2set_sw_cond_probs->{$node_id};

	my $ct_sites = @{$set_sw_cond_probs};

	unless ($ct_sites == $lenaln) {
	    print STDOUT "\n[WARNING '$plscript_name'] The number of sites (=$ct_sites) CLASHES with the MSA lengths (=$lenaln): $! !\n\n";
	}

	print STDOUT "< Node ID: $node_id (#{sites} = $ct_sites) >\n\n";

	print STDOUT "[ Descendant Residue State Probabilities, conditioned on the residue state of the node itself ]\n\n";

	print STDOUT join ("\t", 'Site\Conditioned_on:', @NUCLEOTIDES), "\n\n";

	for (my $s=0; $s<$ct_sites; $s++) { # Preliminary inner for-loop (over sites). #
	    if (@{$set_sw_cond_probs->[$s]}>0) {
		print STDOUT join ("\t", $s, @{$set_sw_cond_probs->[$s]}), "\n";
	    } else {
		print STDOUT join ("\t", $s, '[EMPTY]'), "\n";
	    }
	} 			# End of the preliminary inner for-loop (over sites). #

	print STDOUT "\n\n";

}			# End of the 1st preliminary outer foreach-loop (over nodes). #


print STDOUT "\n<< Contents of the Preliminary Output (1b), ", '%{$node2set_sw_extcond_probs0}', " >>\n\n";
##print STDOUT "\n<< Contents of the Main Output (2), ", '%{$node2set_sw_extcond_probs0}', " >>\n\n";

foreach my $node_id (sort {$a <=> $b} keys %{$node2set_sw_extcond_probs0}) { # 2nd preliminary outer foreach-loop (over branches). #

	my $set_sw_extcond_probs = $node2set_sw_extcond_probs0->{$node_id};

	my $ct_sites = @{$set_sw_extcond_probs};

	unless ($ct_sites == $lenaln) {
	    print STDOUT "\n[WARNING '$plscript_name'] The number of sites (=$ct_sites) CLASHES with the MSA lengths (=$lenaln): $! !\n\n";
	}

	print STDOUT "< Branch ID: $node_id (#{sites} = $ct_sites) >\n\n";

	print STDOUT "[ Descendant Residue State Probabilities, conditioned on the residue state of the parent node of the subject branch ]\n\n";

	print STDOUT join ("\t", 'Site\Conditioned_on:', @NUCLEOTIDES), "\n\n";

	for (my $s=0; $s<$ct_sites; $s++) { # Preliminary inner for-loop (over sites). #
	    if (@{$set_sw_extcond_probs->[$s]}>0) {
		print STDOUT join ("\t", $s, @{$set_sw_extcond_probs->[$s]}), "\n";
	    } else {
		print STDOUT join ("\t", $s, '[EMPTY]'), "\n";
	    }
	} 			# End of the preliminary inner for-loop (over sites). #

	print STDOUT "\n\n";

}			# End of the 2nd preliminary outer foreach-loop (over nodes). #



	## ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (2) ##

print STDOUT "\n\n<<< Preliminary (2): Calculate the Probabilities of all columns. >>>\n\n\n";

my $set_clm_probs = calc_clm_probs (@equil_resfreqs, %{$node2set_sw_cond_probs}, $topnode_id);
unless (defined $set_clm_probs) {
	print STDOUT "[ERROR '$plscript_name'] The 2nd Preliminary Subroutine 'calc_clm_probs' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 2nd Preliminary Subroutine 'calc_clm_probs' ENDED ...\n\n";


my $ct_clm_prbs = @{$set_clm_probs};
print STDOUT "\n<< Contents of the Preliminary Output (2), ", '@{$set_clm_probs}', " (#{elements} = $ct_clm_prbs) >>\n\n";

print STDOUT join ("\t", 'Column', 'Probability'), "\n\n";
##print STDOUT join ("\t", 'Site', 'Probability'), "\n\n";

for (my $c=0; $c < $ct_clm_prbs; $c++) { # 3rd preliminary for-loop (over columns). #

	print STDOUT join ("\t", $c, $set_clm_probs->[$c]), "\n";

}	# End of the 3rd preliminary for-loop (over columns). #

print STDOUT "\n\n";

=cut # END of "DISABLED in creation of 'test_extensive_exam_inter_block_relations.pl'. (3)"

		## Restarted on 2019/02/28. ##

print STDOUT "\n\n<<< Preliminary (3): Create ", '@nodeids_in_msa', ", an IMPORTANT INPUT of 'mk_init_set_columns0' & 'br_calc_sbst_prob_sgl_clm', AND '%nodeid2msa_row', an IMPORTANT INPUT of 'extract_br_info_gblocks'.  >>>\n\n\n";

my ($nodeids_in_msa, $nodeid2msa_row) = associate_nodeids_w_msa_rows (@seqids, %name2id);

unless (defined $nodeid2msa_row) {
	print STDOUT "[ERROR '$plscript_name'] The 3rd Preliminary Subroutine 'associate_nodeids_w_msa_rows' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 3rd Preliminary Subroutine 'associate_nodeids_w_msa_rows' ENDED ...\n\n";


print STDOUT "\n<< Contents of the Preliminary Output (3a), ", '@{$nodeids_in_msa}', " >>\n\n";

print STDOUT join ("\t", 'Row', 'node_ID'), "\n\n";
for (my $r = 0; $r < $ct_seqs; $r++) { print STDOUT join ("\t", $r, $nodeids_in_msa->[$r]), "\n"; }
print STDOUT "\n\n";


print STDOUT "\n<< Contents of the Preliminary Output (3b), ", '%{$nodeid2msa_row}', " >>\n\n";

print STDOUT '%{$nodeid2msa_row} = (', "\n";
foreach my $nodeid (sort {$a <=> $b} keys %{$nodeid2msa_row} ) {
	print STDOUT "\t", $nodeid, ' => ', $nodeid2msa_row->{$nodeid}, ",\n";
}
print STDOUT "\t)\n\n";


print STDOUT "\n\n<<< Preliminary (5): Create ", '\@set_cls_gpbs & \@init_psm_hst_for_cls', ", 2 IMPORTANT INPUTS of 'mk_init_set_columns0'. >>>\n\n\n";


my ($set_gpatterns, $set_node2dparsstat, $set_br2change, $info_psm_indel_hsts0) = enum_psm_indel_hsts_for_msa_finer_1ST_HF (%node2ch, %{$node2pa}, %name2id, @seqids, @cp_full_msa, $GAP, $CHAR_PRES, %{$node2depth}, %{$node2ct_exoffs});
unless (defined $info_psm_indel_hsts0) {
	print STDOUT "[ERROR '$plscript_name'] The 5th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_1ST_HF' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 5th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_1ST_HF' ENDED ...\n\n";

my ($set_cls_gpbs, $totcts0_indels_for_cls, $init_psm_hsts_for_cls) = @{$info_psm_indel_hsts0};

my $ct_gpd_sgs = @{$set_cls_gpbs};


print STDOUT "\n<< Contents of the Preliminary Outputs (5), ", '@{$set_cls_gpbs} & @{$init_psm_hsts_for_cls}', " (#{gapped segments} = $ct_gpd_sgs) >>\n\n";


for (my $cl = 0; $cl<$ct_gpd_sgs; $cl++) { # 5th preliminary outer for-loop (over the gapped segments) #

	my $cls_gblks = $set_cls_gpbs->[$cl];
	my $ct_gblks = @{$cls_gblks};

	print STDOUT "< The $cl th gapped segment (#{gap-pattern-blocks} = $ct_gblks) >\n\n";

	print STDOUT "[ Gap-pattern-blocks in the cluster ]\n\n";

	print STDOUT join ("\t", 'Block_no.', 'length', 'start_coord', 'end_coord', 'indx_gp', "'gap_pattern(horizontal_representation)'"), "\n\n";

	for (my $bl=0; $bl<$ct_gblks; $bl++) { # 1st middle for-loop (over the gap-blocks) #
	    my ($indx_gp, $len_gb, $start, $end) = @{$cls_gblks->[$bl]};

	    my $gpattern = ${$set_gpatterns->[$indx_gp]};
	    print STDOUT join ("\t", $bl, $len_gb, $start, $end, $indx_gp, "'$gpattern'"), "\n";
	}			# End of the 1st middle for-loop (over the gap-blocks) #
	print STDOUT "\n\n";

## my ($set_cls_gpbs, $init_totcts_indels_for_cls, $init_psm_hsts_for_cls) = @{$info_init_psm_hst} ;

	my $init_totct_indel = $totcts0_indels_for_cls->[$cl];
	my $init_psm_hst = $init_psm_hsts_for_cls->[$cl];

	print STDOUT "\n[ Initial Candidate Indel History (Total#{indel events}_init = $init_totct_indel) ]\n\n";

	my ($br2indels0, $node2bw_gstats0) = @{$init_psm_hst};

	print STDOUT "( Map of block-wise gap states onto the nodes )\n\n";
	print STDOUT join ("\t", 'Node_ID', "'block_wise_gap_states(concatenated)'"), "\n\n";
	foreach my $node (sort {$a <=> $b} keys %{$node2bw_gstats0}) { # 1st inner foreach-loop #
	    my $cnct_bw_gstats = join ('', @{$node2bw_gstats0->{$node}});
	    print STDOUT join ("\t", $node, "'$cnct_bw_gstats'"), "\n";
	}				# End of the 1st inner foreach-loop #
	print STDOUT "\n\n";

	print STDOUT "( Map of indel events onto the branches )\n\n";
	print STDOUT join ("\t", 'Branch_ID', 'state_ue/state_le/indices,blocks,involved', '...'), "\n\n";
	foreach my $br (sort {$a <=> $b} keys %{$br2indels0}) { # 2nd inner foreach-loop #
	    my @out_indel_info = ();
	    foreach my $indel_info (@{$br2indels0->{$br}}) { # Innermost foreach-loop #
		my ($stat_ue, $stat_le, $indices_blk) = @{$indel_info};
		(defined $stat_ue) or ($stat_ue = 'undef');
		(defined $stat_le) or ($stat_le = 'undef');
		my $cnct_indices_blk = (defined $indices_blk) ? join (',', @{$indices_blk}) : 'undef';
		push @out_indel_info, join ('/', $stat_ue, $stat_le, $cnct_indices_blk);
	    }			# End of the innermost foreach-loop #
	    print STDOUT join ("\t", $br, @out_indel_info), "\n";
	}				# End of the 2nd inner foreach-loop #
	print STDOUT "\n\n";

}		# End of the 5th preliminary outer for-loop (over the gapped segments) #

print STDOUT "\n";


	## ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (1) ##


print STDOUT "\n\n<<< Preliminary (6): Prepare the lists of gap-blocks >>>\n\n\n";


my @set_exnodes = ();
foreach my $node (sort {$a <=> $b} keys %{$node2ct_exoffs}) { 
    if ($node2ct_exoffs->{$node} == 1) {
	push @set_exnodes, $node; 
    }
}

my @set_lists_gblocks0 = ();
for (my $cl = 0; $cl<$ct_gpd_sgs; $cl++) { # 6th preliminary outer for-loop (over the gapped segments) #

	print STDOUT "| For the $cl th gapped segment |\n\n";

	my $cls_gblks = $set_cls_gpbs->[$cl];
	my $init_psm_hst = $init_psm_hsts_for_cls->[$cl];
	my ($br2indels0, $node2bw_gstats0) = @{$init_psm_hst};

	my $br_list_gblocks0 = br_list_gblocks (%{$br2indels0}, @set_exnodes, $GAP, %node2ch);
	unless (defined $br_list_gblocks0) {
	    print STDOUT "[ERROR '$plscript_name'] The 6th Preliminary Subroutine 'br_list_gblocks' FAILED on the $cl th gapped segment !\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die ;
	}
	print STDOUT "\n --- The 6th Preliminary Subroutine 'br_list_gblocks' ENDED on the $cl th gapped segment ...\n\n";

	my $ct_gbs0 = @{$br_list_gblocks0};
	print STDOUT '[ Contents of @{$br_list_gblocks0} ', "(#{gap-blocks} = $ct_gbs0) ]\n\n";
	print STDOUT join ("\t", 'Indx_gb', 'br_ID', 'up(U)_or_lw(L)', 'lm_gpb', 'rm_gpb', '(involved,gap,pattern,blocks)', '[affected,external,nodes]', '$e'), "\n\n";

	for (my $gb = 0; $gb < $ct_gbs0; $gb++) {
	    my ($br, $up_or_lw, $lm_gpb, $rm_gpb, $invlvd_gpbs, $affd_exnodes, $e) = @{$br_list_gblocks0->[$gb]};
	    my $cnct_invlvd_gpbs = join (',' , @{$invlvd_gpbs});
	    $cnct_invlvd_gpbs = "($cnct_invlvd_gpbs)";
	    my $cnct_affd_exnodes = join (',', @{$affd_exnodes});
	    $cnct_affd_exnodes = "[$cnct_affd_exnodes]";
	    print STDOUT join ("\t", $gb, $br, $up_or_lw, $lm_gpb, $rm_gpb, $cnct_invlvd_gpbs, $cnct_affd_exnodes, $e), "\n";
	}
	print STDOUT "\n\n";

	$set_lists_gblocks0[$cl] = $br_list_gblocks0;

}		# End of the 6th preliminary outer for-loop (over the gapped segments) #


print STDOUT "\n\n<<< Preliminary (7): Prepare Sliding Windows >>>\n\n\n";

	# A 'make-shift' preparation of the input data sets for 'prepare_sliding_windows'. #
my ($beg_in_msa, $end_in_msa) = (0, $lenaln -1);
my @artf_cls = ([0 .. $ct_gpd_sgs -1]);
my @cmplx_cands = ();
my $ct_exnodes = @set_exnodes;
my $wdth_margin = 3;
my $hf_wdth_shift = 10;

my $num_max = 15; # MODIFIED in major revision of 'test_chk_posrel_amg_vequiv_gblks.pl' (on 2019/04/03).
##my $num_max = 8; # MODIFIED in creation of 'test_extensive_exam_inter_block_relations.pl' (on 2019/03/12).
####my $num_max = 5;

print STDOUT "<< 'Make-shift' Inputs of 'prepare_sliding_windows': >>\n\n";
print STDOUT '($beg_in_msa, $end_in_msa) = ', "($beg_in_msa, $end_in_msa) .\n\n";

print STDOUT '@artf_cls = (', "\n";
foreach my $acls (@artf_cls) {
	print STDOUT "\t[", join (', ', @{$acls}), "],\n";
}
print STDOUT "\t) .\n\n\n";

print STDOUT '@cmplx_cands = ()', " .\n\n";

print STDOUT '$ct_exnodes = ', "$ct_exnodes .\n\n";

print STDOUT '($wdth_margin, $hf_wdth_shift, $num_max) = ', "($wdth_margin, $hf_wdth_shift, $num_max) .\n\n\n";

my ($window_frames, $prohibited_zones, $set_windows, $set_lists_gblocks_in_wds) =  prepare_sliding_windows ($beg_in_msa, $end_in_msa, @{$set_cls_gpbs}, @artf_cls, @cmplx_cands, @set_lists_gblocks0, $ct_exnodes, $wdth_margin, $hf_wdth_shift, $num_max);
unless (defined $set_lists_gblocks_in_wds) {
	print STDOUT "[ERROR '$plscript_name'] The 7th Preliminary Subroutine 'prepare_sliding_windows' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 7th Preliminary Subroutine 'prepare_sliding_windows' ENDED ...\n\n";

my $ct_frms = @{$window_frames};
my $ct_wds = @{$set_windows};

print STDOUT "\n<< Outputs of 'prepare_sliding_windows' >>\n\n";

print STDOUT '[ Contents of @{$window_frames} ', " (#{frames} = $ct_frms) ]\n\n";
print STDOUT join ("\t", 'Indx_fr', 'beg_fr', 'end_fr'), "\n\n";

for (my $fr = 0; $fr < $ct_frms; $fr++) { print STDOUT join ("\t", $fr, @{$window_frames->[$fr]}), "\n"; }
print STDOUT "\n\n";

print STDOUT '[ Contents of @{$set_windows} ', " (#{windows} = $ct_wds) ]\n\n";
print STDOUT join ("\t", 'Indx_wd', 'beg_wd', 'end_wd', '(involved,gapped,segments)', '#{gap-blocks}', 'Indx_fr'), "\n\n";

for (my $wd = 0; $wd < $ct_wds; $wd++) {
	my ($beg_wd, $end_wd, $invlvd_gpd_sgs, $ct_gbs, $fr) = @{$set_windows->[$wd]};
	my $cnct_invlvd_gpd_sgs = join (',', @{$invlvd_gpd_sgs});
	$cnct_invlvd_gpd_sgs = "($cnct_invlvd_gpd_sgs)";
	print STDOUT join ("\t", $wd, $beg_wd, $end_wd, $cnct_invlvd_gpd_sgs, $ct_gbs, $fr), "\n";
}
print STDOUT "\n\n";

print STDOUT '[ Contents of @{$set_lists_gblocks_in_wds} ]', "\n\n";

for (my $wd = 0; $wd < $ct_wds; $wd++) {

	my $list_gblocks_in_wd = $set_lists_gblocks_in_wds->[$wd];
	my $ct_gbs = @{$list_gblocks_in_wd};

	print STDOUT "| The $wd th window (#{gap-blocks} = $ct_gbs) |\n\n";
	print STDOUT join ("\t", 'Indx_gb_in_wd', 'br_ID', 'up(U)_or_lw(L)', 'lm_clm', 'rm_clm', '(involved,gap,pattern,blocks)', '[affected,external,nodes]', '$e', '$gs', 'indx_gb_in_gs'), "\n\n";

	for (my $gb = 0; $gb < $ct_gbs; $gb++) {
	     my ($br, $up_or_lw, $lm_clm, $rm_clm, $invlvd_gpbs, $affd_exnodes, $e, $gs, $gb_in_gs) = @{$list_gblocks_in_wd->[$gb]};
	    my $cnct_invlvd_gpbs = join (',' , @{$invlvd_gpbs});
	    $cnct_invlvd_gpbs = "($cnct_invlvd_gpbs)";
	    my $cnct_affd_exnodes = join (',', @{$affd_exnodes});
	    $cnct_affd_exnodes = "[$cnct_affd_exnodes]";
	    print STDOUT join ("\t", $gb, $br, $up_or_lw, $lm_clm, $rm_clm, $cnct_invlvd_gpbs, $cnct_affd_exnodes, $e, $gs, $gb_in_gs), "\n";
	}
	print STDOUT "\n\n";
}

print STDOUT "\n   ... In the Following, we will use the 0 th window for our tests ...\n\n";


my $left_end_wd = $set_windows->[0][0];
print STDOUT "\n\n<<< Preliminary (7'): Extract key information on the 0 th window (w/  {left-end} = $left_end_wd) >>>\n\n\n";

my ($bds_gblocks0, $rows_affd_by_blks) = extract_br_info_gblocks ($left_end_wd, @{$set_lists_gblocks_in_wds->[0]}, %{$nodeid2msa_row});
unless (defined $rows_affd_by_blks) {
	print STDOUT "[ERROR '$plscript_name'] The 7'-th Preliminary Subroutine 'extract_br_info_gblocks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 7'-th Preliminary Subroutine 'extract_br_info_gblocks' ENDED ...\n\n";

my $ct_gbs7p = @{$bds_gblocks0};

print STDOUT "<< Contents of the 7'-th preliminary output:", '@{$bds_gblocks0} & @{$rows_aff_by_blks}', " (#{gap-blocks} = $ct_gbs7p) >>\n\n";

print STDOUT join ("\t", 'Indx_gb', 'left-bound', 'right-bound', '[rows,affected,by,the,block]'), "\n\n";
for (my $gb = 0; $gb < $ct_gbs7p; $gb++) {
	my $cnct_rows = join (',', @{$rows_affd_by_blks->[$gb]});
	$cnct_rows = "[$cnct_rows]";
	print STDOUT join ("\t", $gb, @{$bds_gblocks0->[$gb]}, $cnct_rows), "\n";
}
print STDOUT "\n\n";


	## END of "ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (1)" ##


print STDOUT "\n\n<<< Preliminary (8): Create ", '\@set_columns0', ", an IMPORTANT INPUT of 'shift_bl_and_compt_prob_incr' >>>\n\n\n"; # MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. 
##print STDOUT "\n\n<<<<< Sub-MAIN: Create ", '\@set_columns0', ", an IMPORTANT INPUT of 'br_calc_sbst_prob_sgl_clm' >>>>>\n\n\n";

	# MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #


my ($beg_wd, $end_wd, $invlvd_gpd_sgs, $ct_gbs, $fr) = @{$set_windows->[0]};
my @invlvd_gpd_sgs = @{$invlvd_gpd_sgs};
##
##	# Create a make-shift "window" #
##my ($beg_wd, $end_wd) = (0, $lenaln -1);
##my @invlvd_gpd_sgs = (0 .. $ct_gpd_sgs -1);

##print STDOUT "<< Inputs of 'mk_init_set_columns0': information on the 'make-shift' window >>\n\n";
print STDOUT "<< Inputs of 'mk_init_set_columns0': the 0 th window created above >>\n\n";

print STDOUT '($beg_wd, $end_wd) = ', "($beg_wd, $end_wd) .\n\n";
print STDOUT '@invlvd_gpd_sgs = (', join (', ', @invlvd_gpd_sgs), ") .\n\n\n";

my $set_columns0 = mk_init_set_columns0 (@{$nodeids_in_msa}, $GAP, $beg_wd, $end_wd, @invlvd_gpd_sgs, @{$set_cls_gpbs}, @{$init_psm_hsts_for_cls});
unless (defined $set_columns0) {
	print STDOUT "[ERROR '$plscript_name'] The 8th Preliminary Subroutine 'mk_init_set_columns0' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 8th Preliminary Subroutine 'mk_init_set_columns0' ENDED ...\n\n";

my $ct_clms0 = @{$set_columns0};

print STDOUT "\n<< Contents of the 8th Preliminary Output, ", '@{$set_columns0}', " (#{columns} = $ct_clms0) >>\n\n"; # MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #
##print STDOUT "\n<< Contents of the Sub-MAIN Output, ", '@{$set_columns0}', " (#{columns} = $ct_clms0) >>\n\n";

print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";

for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #

	my $column0 = $set_columns0->[$c];
	print STDOUT join ("\t", $c, @{$column0}), "\n";

}	# End of the sub-main for-loop (over columns). #
print STDOUT "\n\n";

	### ADDED in creation of 'test_search_for_coll_cmpl_gblks.pl'. (1) ###

print STDOUT "\n\n<<<<< Preliminary (9): Create ", '\@{$inter_block_relations}', ", an IMPORTANT INPUT of 'mk_list_gblock_sizes'. >>>>>\n\n\n";
##print STDOUT "\n\n<<<<< Sub-Sub-MAIN (1): Create ", '\@{$inter_block_relations}', ", an IMPORTANT INPUT of 'mk_list_gblock_sizes'. >>>>>\n\n\n";

my $list_gblocks_in_wd = $set_lists_gblocks_in_wds->[0];

my $ct_gblks = @{$list_gblocks_in_wd};

my ($inter_block_relations) = mk_inter_block_relations (@{$list_gblocks_in_wd}, 0, 1, %{$node2pa}, %node2ch, $topnode_id, %{$br2eq});
unless (defined $inter_block_relations) {
	print STDOUT "[ERROR '$plscript_name'] The 9th Preliminary Subroutine 'mk_inter_block_relations' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 9th Preliminary Subroutine 'mk_inter_block_relations' ENDED ...\n\n";

	# mk_inter_block_relations

print STDOUT "\n", '<< Contents of the 9th Preliminary output, @{$inter_block_relations}: >>', "\n\n";
print STDOUT join ("\t", 'Gb1\gb2:', (0 .. $ct_gblks-1) ), "\n\n";

for (my $gb1  = 0; $gb1 < $ct_gblks; $gb1++) {
    my @out_inter_block_rels = @{$inter_block_relations->[$gb1]};
    $out_inter_block_rels[$gb1] = 'undef';
    print STDOUT join ("\t", $gb1, @out_inter_block_rels), "\n";
}
print STDOUT "\n\n";

	### ADDED in creation of 'test_vextend_gblock_ends.pl'. (1) ###

print STDOUT "\n\n<<<<< Preliminary (10): Create ", '\@{$gblks_w_spec_lb} & @{$gblks_w_spec_rb}', ", IMPORTANT INPUTs of the MAIN subroutines. >>>>>\n\n\n";

my ($le_wd, $re_wd) = (0, $ct_clms0-1);
my ($gblks_w_spec_lb, $gblks_w_spec_rb) = mk_lists_gblocks_w_spec_bounds ($le_wd, $re_wd, @{$bds_gblocks0});
unless (defined $gblks_w_spec_rb) {
	print STDOUT "[ERROR '$plscript_name'] The 10th Preliminary Subroutine 'mk_lists_gblocks_w_spec_bounds' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 10th Preliminary Subroutine 'mk_lists_gblocks_w_spec_bounds' ENDED ...\n\n";


print STDOUT "\n", '<< Contents of the 10th Preliminary outputs, @{$gblks_w_spec_lb} & @{$gblks_w_spec_rb}: >>', "\n\n";

print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";

for (my $c = $le_wd; $c <= $re_wd; $c++) {
	my $cnct_gblks_w_lb_eq_c = join (',', @{$gblks_w_spec_lb->[$c]});
	my $cnct_gblks_w_rb_eq_c = join (',', @{$gblks_w_spec_rb->[$c]});
	print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
}
print STDOUT "\n\n";


	# ADDED in creation of 'test_vretract_gblock_ends.pl'. (Pre-MAIN) #

print STDOUT "\n\n<<<<< Preliminary (11): Create ", '\@{$gblock_sizes}', ", an IMPORTANT INPUT of 'search_for_coll_cmpl_gblks'. >>>>>\n\n\n";

my ($gblock_sizes) = mk_list_gblock_sizes (@{$list_gblocks_in_wd}, 2, 3, @{$inter_block_relations});
unless (defined $gblock_sizes) {
	print STDOUT "[ERROR '$plscript_name'] The 11th Preliminary Subroutine 'mk_list_gblock_sizes' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 11th Preliminary Subroutine 'mk_list_gblock_sizes' ENDED ...\n\n";

print STDOUT "\n", '<< Contents of the 11th Preliminary output, @{$gblock_sizes}: >>', "\n\n";
print STDOUT join ("\t", 'Indx_gb', 'gblock_size'), "\n\n";

for (my $gb=0; $gb < $ct_gblks; $gb++) {
	print STDOUT join ("\t", $gb, $gblock_sizes->[$gb]), "\n";
}
print STDOUT "\n\n";


=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Pre 12,13,14)

		### ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1) ###

print STDOUT "\n\n<<<<< Preliminary (12): Create ", '%{$br2up_down2blocks}', ", an IMPORTANT INPUT of 'mk_sets_vert_equiv_gblks'. >>>>>\n\n\n";
##print STDOUT "\n\n<<<<< Sub-Sub-MAIN (5): Create ", '%{$br2up_down2blocks}', ", an IMPORTANT INPUT of 'mk_sets_vert_equiv_gblks'. >>>>>\n\n\n";

my $br2up_down2blocks = mk_br2up_down2blocks (@{$list_gblocks_in_wd}, 0, 1);
unless (defined $br2up_down2blocks) {
	print STDOUT "[ERROR '$plscript_name'] The 12th Preliminary Subroutine 'mk_br2up_down2blocks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 12th Preliminary Subroutine 'mk_br2up_down2blocks' ENDED ...\n\n";

print STDOUT "\n", '<< Contents of the 12th Preliminary output, %{$br2up_down2blocks}: >>', "\n\n";
print STDOUT join ("\t", 'Indx_br', 'up(U)_or_down(L)', '[relevant,gap,blocks]'), "\n\n";

foreach my $br (sort {$a <=> $b} keys %{$br2up_down2blocks}) {
	my $up_down2blocks = $br2up_down2blocks->{$br};
	foreach my $u_or_d (sort keys %{$up_down2blocks}) {
	    my $cnct_blocks = join (',', @{$up_down2blocks->{$u_or_d}});
	    print STDOUT join ("\t", $br, $u_or_d, "[$cnct_blocks]"), "\n";
	}
}
print STDOUT "\n";


print STDOUT "\n\n<<<<<<< Preliminary (13):  Create the sets of vertically equivalent gap-blocks, using 'mk_sets_vert_equiv_gblks'.  >>>>>>>\n\n\n";
##print STDOUT "\n\n<<<<<<< Sub-MAIN (1):  Create the sets of vertically equivalent gap-blocks, using 'mk_sets_vert_equiv_gblks'.  >>>>>>>\n\n\n";

my $sets_vequiv_gblks = mk_sets_vert_equiv_gblks (%{$br2up_down2blocks}, %{$br2eq});
unless (defined $sets_vequiv_gblks) {
	print STDOUT "[ERROR '$plscript_name'] The 13th Preliminary Subroutine 'mk_sets_vert_equiv_gblks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 13th Preliminary Subroutine 'mk_sets_vert_equiv_gblks' ENDED ...\n\n";

my $ct_veq_gblks = @{$sets_vequiv_gblks};

print STDOUT "\n", '<< Contents of the 13th Preliminary output, @{$sets_vequiv_gblks} ', "(size = $ct_veq_gblks): >>\n\n";

print STDOUT join ("\t", 'Indx_set', '[vertically,equivalent,gap,blocks]'), "\n\n";

for (my $k = 0; $k < $ct_veq_gblks; $k++) { 

	my $cnct_veq_gblks = join (',' , @{$sets_vequiv_gblks->[$k]});
	print STDOUT join ("\t", $k, "[$cnct_veq_gblks]"), "\n";
}
print STDOUT "\n";


print STDOUT "\n\n<<<<<<< Preliminary (14):  Create the sets of swappable gap-blocks, using 'mk_sets_swappable_gblks'.  >>>>>>>\n\n\n";
##print STDOUT "\n\n<<<<<<< Sub-MAIN (2):  Create the sets of swappable gap-blocks, using 'mk_sets_swappable_gblks'.  >>>>>>>\n\n\n";

my $sets_swappable_gblks = mk_sets_swappable_gblks (@{$sets_vequiv_gblks}, @{$gblock_sizes});
unless (defined $sets_swappable_gblks) {
	print STDOUT "[ERROR '$plscript_name'] The 14th Preliminary Subroutine 'mk_sets_swappable_gblks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 14th Preliminary Subroutine 'mk_sets_swappable_gblks' ENDED ...\n\n";

my $ct_swpbl_gblks = @{$sets_swappable_gblks};

print STDOUT "\n", '<< Contents of the 14th Preliminary output, @{$sets_swappable_gblks} ', "(size = $ct_swpbl_gblks): >>\n\n";

for (my $i=0; $i < $ct_swpbl_gblks; $i++) {
	my $cnct_swpbl_gblks = join (',', @{$sets_swappable_gblks->[$i]});
	print STDOUT join ("\t", $i, "[$cnct_swpbl_gblks]"), "\n";
}
print STDOUT "\n";

		### END of "ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1)" ###

=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Pre 12,13,14)"


		### ADDED in creation of 'test_compt_aln_degeneracy.pl'. (Sub-MAIN 1&2) ###

=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 1)

print STDOUT "\n\n<<<<< Sub-MAIN (1): Search for ALL sets of collectively complementary gap-blocks, using 'search_for_coll_cmpl_gblks'. >>>>>\n\n\n";

my ($br2up_down2blocks2, $coll_cmpl_gblocks, $gblock2coll_cmpl)
    = search_for_coll_cmpl_gblks (@{$list_gblocks_in_wd}, 0, 1, $topnode_id, %node2ch, %{$node2depth}, @{$gblock_sizes});
unless (defined $gblock2coll_cmpl) {
	print STDOUT "[ERROR '$plscript_name'] The 1st Sub-MAIN Subroutine 'search_for_coll_cmpl_gblks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 1st Sub-MAIN Subroutine 'search_for_coll_cmpl_gblks' ENDED ...\n\n";

=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 1)"


print STDOUT "\n\n<<<<< Sub-MAIN (2): Create the origins and the boundaries of the gap-block coordinates, using 'mk_orgs_bds_gb_coords'. >>>>>\n\n\n";


##my ($le_wd, $re_wd) = (0, $ct_clms0-1);

		# MODIFIED in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2A) #
my ($orgs_gb_coords, $bds_gb_coords, $gb_coords_wd_frm) = mk_orgs_bds_gb_coords (@{$bds_gblocks0}, $le_wd, $re_wd, @{$inter_block_relations}, $MAXCT_1WAY_SHIFTS);
## my ($orgs_gb_coords, $bds_gb_coords) = mk_orgs_bds_gb_coords (@{$bds_gblocks0}, $le_wd, $re_wd, @{$inter_block_relations}, $MAXCT_1WAY_SHIFTS);
		# End of "MODIFIED in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2A)" #
unless (defined $gb_coords_wd_frm) {
##unless (defined $bds_gb_coords) {...}
	print STDOUT "[ERROR '$plscript_name'] The 2nd Sub-MAIN Subroutine 'mk_orgs_bds_gb_coords' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 2nd Sub-MAIN Subroutine 'mk_orgs_bds_gb_coords' ENDED ...\n\n";

print STDOUT "\n", '<< Contents of the 2nd Sub-MAIN outputs, @{$orgs_gb_coords} & @{$bds_gb_coords} & @{$gb_coords_wd_frm} : >>', "\n\n"; # Modified in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). #
##print STDOUT "\n", '<< Contents of the 2nd Sub-MAIN outputs, @{$orgs_gb_coords} & @{$bds_gb_coords}: >>', "\n\n";

print STDOUT join ("\t", 'Indx_gb', 'org_coord', 'lbd_coord', 'rbd_coord', 'coord_le_wd', 'coord_re_wd'), "\n\n"; # Modified in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). #
##print STDOUT join ("\t", 'Indx_gb', 'org_coord', 'lbd_coord', 'rb_coord'), "\n\n";

for (my $gb = 0; $gb < $ct_gblks; $gb++) { # 2nd sub-main for-loop (over gap-blocks). #

	my $org = $orgs_gb_coords->[$gb];
	my ($lbd, $rbd) = @{$bds_gb_coords->[$gb]};
	my ($coord_le_wd, $coord_re_wd) = @{$gb_coords_wd_frm->[$gb]}; # Added in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2B) #

	foreach my $ref (\$org, \$lbd, \$rbd, \$coord_le_wd, \$coord_re_wd) { # Modified in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2C) #
	##foreach my $ref (\$org, \$lbd, \$rbd) { ... }
	    unless (defined ${$ref}) { ${$ref} = 'undef'; }
	}

		# MODIFIED in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2D) #
	print STDOUT join ("\t", $gb, $org, $lbd, $rbd, $coord_le_wd, $coord_re_wd), "\n";
	##print STDOUT join ("\t", $gb, $org, $lbd, $rbd), "\n";
		# End of "MODIFIED in creation of 'test_serial_shifts_point2point.pl' (on 2019/07/10). (Sub-MAIN 2D)" #
} # End of the 2nd sub-main for-loop (over gap-blocks). #
print STDOUT "\n\n";


=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 2)
print STDOUT ' ... In the following, we will SET: @cp_gb_coords = @{$orgs_gb_coords}, & @BDS_GB_COORDS = @{$bds_gb_coords} ...', "\n\n";

my @cp_gb_coords = @{$orgs_gb_coords};
my @BDS_GB_COORDS = @{$bds_gb_coords};
=cut # End of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 2)"

		### END of "ADDED in creation of 'test_compt_aln_degeneracy.pl'. (Sub-MAIN 1&2)" ###


		### ADDED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 3) ###

print STDOUT "\n\n", '<<<<< Sub-MAIN (3): Create @{$cts_vincluding}, @{$cts_vincluded} & @{$cts_onx},', " via 'cts_vincluding_vincluded_onx_gblks'. >>>>>\n\n\n";

my ($cts_vincluding, $cts_vincluded, $cts_onx) = cts_vincluding_vincluded_onx_gblks (@{$inter_block_relations});
unless (defined $cts_onx) {
	print STDOUT "[ERROR '$plscript_name'] The 3rd Sub-MAIN Subroutine 'cts_vincluding_vincluded_onx_gblks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 3rd Sub-MAIN Subroutine 'cts_vincluding_vincluded_onx_gblks' ENDED ...\n\n";

print STDOUT "\n", '<< Contents of the 3rd Sub-MAIN outputs, @{$cts_vincluding}, @{$cts_vincluded} & @{$cts_onx} : >>', "\n\n"; 

print STDOUT join ("\t", 'Indx_gb', '#{vincluding_gbs}', '#{vincluded_gbs}', '#{gbs_w_onx_relations}'), "\n\n";

for (my $gb = 0; $gb < $ct_gblks; $gb++) { # 3rd sub-main for-loop (over gap-blocks). #

	print STDOUT join ("\t", $gb, $cts_vincluding->[$gb], $cts_vincluded->[$gb], $cts_onx->[$gb]), "\n";

} # End of the 3rd sub-main for-loop (over gap-blocks). #
print STDOUT "\n\n";

		### End of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (Sub-MAIN 3)" ###


		### ADDED in creation of 'test_purge_gblock_pair.pl'. (MAIN) ###

print STDOUT "\n\n<<<<<<< MAIN: Examine the behaviors of 'list_nn_purge_and_cmerge_candidates' & 'cmerge_gblock_pair' .  >>>>>>>\n\n\n"; # MODIFIED in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19). #
##print STDOUT "\n\n<<<<<<< MAIN: Examine the behaviors of 'list_nn_purge_and_cmerge_candidates' & 'purge_gblock_pair' .  >>>>>>>\n\n\n";

	# (MAIN 1): Perform 'list_nn_purge_and_cmerge_candidates'.

print STDOUT "\n<<< First, search for gap-block pairs to be \"purge\"d, via 'list_nn_purge_and_cmerge_candidates'.  >>>\n\n";

my ($to_be_purged, $to_be_cmerged)
 = list_nn_purge_and_cmerge_candidates (@{$bds_gblocks0}, @{$gblock_sizes}, @{$inter_block_relations}, $THRSH_DIST_PURGE, $THRSH_DIST_CMERGE);
unless (defined $to_be_cmerged) {
	print STDOUT "[ERROR '$plscript_name'] The 1st MAIN Subroutine 'list_nn_purge_and_cmerge_candidates' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
my $ct_to_be_purged = @{$to_be_purged};
my $ct_to_be_cmerged = @{$to_be_cmerged};

print STDOUT "\n --- The 1st MAIN Subroutine 'list_nn_purge_and_cmerge_candidates' ENDED (w/ #{to_be_purged}=$ct_to_be_purged, #{to_be_cmerged}=$ct_to_be_cmerged) ...\n\n";

print STDOUT "\n[[ Outputs of 'list_nn_purge_and_cmerge_candidates' ]]\n\n";

print STDOUT '( Contents of @{$to_be_purged}: )', "\n\n";

print STDOUT join ("\t", 'No.', 'indx_gb1', 'indx_gb2', 'distance'), "\n\n";

for (my $i=0; $i <$ct_to_be_purged; $i++) { # 1st for-loop trailing 1st MAIN subroutine.

	print STDOUT join ("\t", $i, @{$to_be_purged->[$i]}), "\n";

} # End of the 1st for-loop trailing 1st MAIN subroutine.
print STDOUT "\n\n";

print STDOUT '( Contents of @{$to_be_cmerged}: )', "\n\n";

print STDOUT join ("\t", 'No.', 'indx_gb1', 'indx_gb2', 'distance'), "\n\n";

for (my $i=0; $i <$ct_to_be_cmerged; $i++) { # 2nd for-loop trailing 1st MAIN subroutine.

	print STDOUT join ("\t", $i, @{$to_be_cmerged->[$i]}), "\n";

} # End of the 2nd for-loop trailing 1st MAIN subroutine.
print STDOUT "\n\n";


		### MODIFIED in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19). (MAIN) ###

			### RESTART FROM HERE (on 2019/07/19). ###

	# (MAIN 2): Perform 'cmerge_gblock_pair'. 

print STDOUT "\n<< Second, Perform the Subroutine, 'cmerge_gblock_pair', on every complementary gap-block pair to be \"merge\"d. >>\n\n";

my @null_column = ();
for (1 .. $ct_seqs) { push @null_column, $GAP; }
my $cnct_null_clm = join (':', @null_column);

print STDOUT "[ An Additional Input: ]\n\n";
print STDOUT '$cnct_null_clm = ', $cnct_null_clm, " .\n";
print STDOUT "\n\n";

my @curr_gb_coords = @{$orgs_gb_coords};
my @curr_set_clms = @{$set_columns0};
my @curr_bds_gblks = @{$bds_gblocks0};
my @curr_gblks_w_spec_lb = @{$gblks_w_spec_lb};
my @curr_gblks_w_spec_rb = @{$gblks_w_spec_rb};

for (my $i=0; $i < $ct_to_be_cmerged; $i++) { # Main Outer for-loop (over complementary pairs to be "merge"d). #

	my ($gb1, $gb2, $dist) = @{$to_be_cmerged->[$i]};

	print STDOUT "\n< The $i th complementary pair to be \"merge\"d: (indx_gb1, indx_gb2) = ($gb1, $gb2) ; (distance=$dist) >\n\n";

	print STDOUT join ("\t", 'Indx_gb', 'curr_coord', 'lb_coord', 'rb_coord', 'coord_le_wd', 'coord_re_wd', 'lm_clm', 'rm_clm', 'block_size', '[msa,rows,affected]'), "\n\n";

	foreach my $gb ($gb1, $gb2) { # Inner foreach-loop (over gap-blocks in the pair). #
	    my $cnct_rows_affd = join (',', @{$rows_affd_by_blks->[$gb]});
	    print STDOUT join ("\t", $gb, $curr_gb_coords[$gb], @{$bds_gb_coords->[$gb]}, @{$gb_coords_wd_frm->[$gb]}, @{$curr_bds_gblks[$gb]}, $gblock_sizes->[$gb], "[$cnct_rows_affd]"), "\n";

	} # End of the inner foreach-loop (over gap-blocks in the pair). #
	print STDOUT "\n\n";

	print STDOUT " --- Now, Perform the MAIN Subroutine, 'cmerge_gblock_pair' ...\n\n";

	my ($flag_end, $bl_sbj, $incr_coord_sbj, $gb_rmvd, $gb_kpt, $ct_rmvd_null_clms, $new_indices_gbs, $old_indices_gbs,
	    $new_curr_set_clms, $new_curr_bds_gblks, $new_curr_bl_coords, $new_bds_gb_coords, $new_gb_coords_wd_frm,
	    $new_curr_gblks_w_spec_lb, $new_curr_gblks_w_spec_rb, $rows_affd_by_new_blks,
	    $new_inter_block_relations, $new_cts_vincluding, $new_cts_vincluded, $new_cts_onx, $new_gblock_sizes)
	  = cmerge_gblock_pair (
	     $gb1, $gb2, @curr_set_clms, @curr_bds_gblks, @curr_gb_coords, @{$bds_gb_coords}, @{$gb_coords_wd_frm},
	     @curr_gblks_w_spec_lb, @curr_gblks_w_spec_rb, @{$rows_affd_by_blks}, $cnct_null_clm,
	     @{$inter_block_relations}, @{$cts_vincluding}, @{$cts_vincluded}, @{$cts_onx}, @{$gblock_sizes}
		);
	unless ($flag_end) {
	    print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'cmerge_gblock_pair' FAILED !\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die ;
	}
	print STDOUT "\n --- The MAIN Subroutine 'cmerge_gblock_pair' ENDED (w/ \$bl_sbj = $bl_sbj, \$incr_coord_sbj = $incr_coord_sbj, \$gb_rmvd = $gb_rmvd, \$gb_kpt = $gb_kpt, \$ct_rmvd_null_clms = $ct_rmvd_null_clms) ...\n\n\n";


} # End of the Main Outer for-loop (over complementary pairs to be "merge"d). #


		### END of "MODIFIED in creation of 'test_cmerge_gblock_pair.pl' (on 2019/07/19). (MAIN)" ###

=For the precedessor, 'test_purge_gblock_pair.pl'. (MAIN)

	# (MAIN 2): Perform 'purge_gblock_pair'. 

print STDOUT "\n<< Second, Perform the Subroutine, 'purge_gblock_pair', on every gap-block pair to be \"purge\"d. >>\n\n";

my @null_column = ();
for (1 .. $ct_seqs) { push @null_column, $GAP; }
my $cnct_null_clm = join (':', @null_column);

print STDOUT "[ An Additional Input: ]\n\n";
print STDOUT '$cnct_null_clm = ', $cnct_null_clm, " .\n";
print STDOUT "\n\n";

my @curr_gb_coords = @{$orgs_gb_coords};
my @curr_set_clms = @{$set_columns0};
my @curr_bds_gblks = @{$bds_gblocks0};
my @curr_gblks_w_spec_lb = @{$gblks_w_spec_lb};
my @curr_gblks_w_spec_rb = @{$gblks_w_spec_rb};

for (my $i=0; $i < $ct_to_be_purged; $i++) { # Main Outer for-loop (over pairs to be "purge"d). #

	my ($gb1, $gb2, $dist) = @{$to_be_purged->[$i]};

	print STDOUT "\n< The $i th pair to be \"purge\"d: (indx_gb1, indx_gb2) = ($gb1, $gb2) ; (distance=$dist) >\n\n";

	print STDOUT join ("\t", 'Indx_gb', 'curr_coord', 'lb_coord', 'rb_coord', 'coord_le_wd', 'coord_re_wd', 'lm_clm', 'rm_clm', 'block_size', '[msa,rows,affected]'), "\n\n";

	foreach my $gb ($gb1, $gb2) { # Inner foreach-loop (over gap-blocks in the pair). #
	    my $cnct_rows_affd = join (',', @{$rows_affd_by_blks->[$gb]});
	    print STDOUT join ("\t", $gb, $curr_gb_coords[$gb], @{$bds_gb_coords->[$gb]}, @{$gb_coords_wd_frm->[$gb]}, @{$curr_bds_gblks[$gb]}, $gblock_sizes->[$gb], "[$cnct_rows_affd]"), "\n";

	} # End of the inner foreach-loop (over gap-blocks in the pair). #
	print STDOUT "\n\n";

	print STDOUT " --- Now, Perform the MAIN Subroutine, 'purge_gblock_pair' ...\n\n";

	my ($flag_end, $bl_sbj, $incr_coord_sbj, $ct_rmvd_null_clms, $new_indices_gbs, $old_indices_gbs,
	    $new_curr_set_clms, $new_curr_bds_gblks, $new_curr_bl_coords, $new_bds_gb_coords, $new_gb_coords_wd_frm,
	    $new_curr_gblks_w_spec_lb, $new_curr_gblks_w_spec_rb, $rows_affd_by_new_blks,
	    $new_inter_block_relations, $new_cts_vincluding, $new_cts_vincluded, $new_cts_onx, $new_gblock_sizes)
	  = purge_gblock_pair (
	     $gb1, $gb2, @curr_set_clms, @curr_bds_gblks, @curr_gb_coords, @{$bds_gb_coords}, @{$gb_coords_wd_frm},
	     @curr_gblks_w_spec_lb, @curr_gblks_w_spec_rb, @{$rows_affd_by_blks}, $cnct_null_clm,
	     @{$inter_block_relations}, @{$cts_vincluding}, @{$cts_vincluded}, @{$cts_onx}, @{$gblock_sizes}
		);
	unless ($flag_end) {
	    print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'purge_gblock_pair' FAILED !\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die ;
	}
	print STDOUT "\n --- The MAIN Subroutine 'purge_gblock_pair' ENDED (w/ \$bl_sbj = $bl_sbj, \$incr_coord_sbj = $incr_coord_sbj, \$ct_rmvd_null_clms = $ct_rmvd_null_clms) ...\n\n\n";


} # End of the Main Outer for-loop (over pairs to be "purge"d). #


=cut # END of "For the precedessor, 'test_purge_gblock_pair.pl'. (MAIN)"


		### END of "ADDED in creation of 'test_purge_gblock_pair.pl'. (MAIN)" ###

=For the predecessor, 'test_serial_shifts_point2point.pl'. (MAIN)

		### ADDED in creation of 'test_serial_shifts_point2point.pl'. (MAIN) ###

print STDOUT "\n\n<<<<<<< MAIN: Examine the behaviors of 'serial_shifts_point2point', as well as of its main satellite subroutine, 'serial_shifts_sgl_gblock' .  >>>>>>>\n\n\n";

my @curr_set_clms = @{$set_columns0};
my @curr_bds_gblks = @{$bds_gblocks0};
my @curr_gblks_w_spec_lb = @{$gblks_w_spec_lb};
my @curr_gblks_w_spec_rb = @{$gblks_w_spec_rb};
# @{$rows_affd_by_blks}


print STDOUT "\n", '<<< First, prepare @gb_coords_frm & @gb_coords_to & $cnct_null_clm . >>>', "\n\n";

my @gb_coords_frm = @{$orgs_gb_coords};

my @gb_coords_to = @gb_coords_frm;

for (my $gb = 0; $gb < $ct_gblks; $gb++) { # 1st main for-loop (over gap-blocks).

	my ($lbd_bf, $rbd_bf) = @{$curr_bds_gblks[$gb]};

	## print STDOUT "{{ The $gb th gap-block w/ (lbd, rbd)_bf = ($lbd_bf, $rbd_bf) }}\n\n";

	my $SHIFT = $LRBDS2SHIFT{"$lbd_bf:$rbd_bf"};
	if (defined $SHIFT) { $gb_coords_to[$gb] +=  $SHIFT; }

} # End of the 1st main for-loop (over gap-blocks). #


my @null_column = ();
for (1 .. $ct_seqs) { push @null_column, $GAP; }
my $cnct_null_clm = join (':', @null_column);


print STDOUT "[[ Auxiliary Input Data ]]\n\n";

print STDOUT '@gb_coords_frm = (', join (', ', @gb_coords_frm), ") .\n";
print STDOUT '@gb_coords_to  = (', join (', ', @gb_coords_to), ") .\n\n";

print STDOUT '$cnct_null_clm = ', $cnct_null_clm, " .\n\n\n";


print STDOUT "\n<<< Now, Perform 'serial_shifts_point2point' . >>>\n\n\n";

my ($flag_end, $tot_incr_ct_null_clms)
  = serial_shifts_point2point (
     @curr_set_clms, @curr_bds_gblks, @gb_coords_frm, @gb_coords_to, @{$gb_coords_wd_frm},
     @curr_gblks_w_spec_lb, @curr_gblks_w_spec_rb, @{$rows_affd_by_blks}, $cnct_null_clm,
     @{$inter_block_relations}, @{$cts_vincluding}, @{$cts_vincluded}, @{$cts_onx}, @{$gblock_sizes}
	);
unless ((defined $flag_end) and ($flag_end == 0)) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'serial_shifts_point2point' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The MAIN Subroutine 'serial_shifts_point2point' ENDED (w/ \$tot_incr_ct_null_clms = $tot_incr_ct_null_clms) ...\n\n\n";


		### END of "ADDED in creation of 'test_serial_shifts_point2point.pl'. (MAIN)" ###

=cut # END of "For the predecessor, 'test_serial_shifts_point2point.pl'. (MAIN)".


=DISABLED in creation of 'test_serial_shifts_point2point.pl'. (MAIN)

print STDOUT "\n\n<<<<<<< MAIN: Examine the behaviors of 'compt_aln_degeneracy' BEFORE and AFTER the \"shift\"s of the subject gap-blocks.  >>>>>>>\n\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'.

##print STDOUT "\n\n<<<<<<< MAIN (3 & 5): Examine the behaviors of 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' BEFORE and AFTER the \"shift\"s of the subject gap-block.  >>>>>>>\n\n\n"; # MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.
##print STDOUT "\n\n<<<<<<< MAIN: Examine the behaviors of 'vretract_right/left_ends_vincluded_gblks' & 'vretract_left/right_end_sbj_gblk' on the subject gap-block.  >>>>>>>\n\n\n";

my @null_column = ();
for (1 .. $ct_seqs) { push @null_column, $GAP; }
my $cnct_null_clm = join (':', @null_column);

#=DISABLED in creation of 'test_compt_aln_degeneracy.pl'.
#my @init_gb_coords = ();
#for (1 .. $ct_gblks) { push @init_gb_coords, 10; }
###for (1 .. $ct_gblks) { push @init_gb_coords, 5; }
#=cut # END of "DISABLED in creation of 'test_compt_aln_degeneracy.pl'."

print STDOUT "[[ Auxiliary Input Data ]]\n\n";

print STDOUT '$cnct_null_clm = ', $cnct_null_clm, " .\n\n\n";
##print STDOUT '@init_gb_coords  = (', join (', ', @init_gb_coords ), ") .\n\n\n"; # DISABLED in creation of 'test_compt_aln_degeneracy.pl'.


	# MOVED from within the 1st MAIN for-loop (in creation of 'test_compt_aln_degeneracy.pl'). #

my @cp_bds_gblks = ();
foreach my $bds (@{$bds_gblocks0}) {
    my @cp_bds = @{$bds};
    push @cp_bds_gblks, \@cp_bds;
}
my @cp_set_clms = ();
foreach my $clm (@{$set_columns0}) {
    my @cp_clm = @{$clm};
    push @cp_set_clms, \@cp_clm;
}
my @cp_gblks_w_spec_lb = ();
foreach my $set (@{$gblks_w_spec_lb}) {
    my @cp = @{$set};
    push @cp_gblks_w_spec_lb, \@cp;
}
my @cp_gblks_w_spec_rb = ();
foreach my $set (@{$gblks_w_spec_rb}) {
    my @cp = @{$set};
    push @cp_gblks_w_spec_rb, \@cp;
}

##my @cp_gb_coords = @init_gb_coords; # MOVED from within the middle for-loop. (in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.) => DISABLED in creation of 'test_compt_aln_degeneracy.pl'.

	# END of "MOVED from within the 1st MAIN for-loop (in creation of 'test_compt_aln_degeneracy.pl')." #

##print STDOUT "\n\n<<<<< MAIN (3 & 5): Examine the behaviors of 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' BEFORE and AFTER the \"shift\"s of the subject gap-block.  >>>>>\n\n\n"; # MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. => DISABLED in creation of 'test_compt_aln_degeneracy.pl'. 


		## MOVED from within the main for-loop (in creation of 'test_compt_aln_degeneracy.pl'). ##
	print STDOUT "\n{ (Sub-1) 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' BEFORE the \"shift\"s }\n\n";

	my $IF_OVERLAP1 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb); # UPDATED on 2019/04/03.
	##my $IF_OVERLAP1 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks);
	unless (defined $IF_OVERLAP1) {
	    print STDOUT "[ERROR '$plscript_name'] The 3rd Sub-MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' FAILED !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 3rd Sub-MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' ENDED BEFORE the \"shift\"s (w/ \$IF_OVERLAP1 = $IF_OVERLAP1) ...\n\n";

	my $IF_RIGHT_ORDER1 = chk_pos_orders_amg_swpbl_gblks (@{$sets_swappable_gblks}, @cp_bds_gblks);
	unless (defined $IF_RIGHT_ORDER1) { # A BUG fixed on 2019/04/01.
	##unless ($IF_RIGHT_ORDER1) {
	    print STDOUT "[ERROR '$plscript_name'] The 5th Sub-MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' FAILED !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 5th Sub-MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' ENDED BEFORE the \"shift\"s (w/ \$IF_RIGHT_ORDER1 = $IF_RIGHT_ORDER1) ...\n\n";
		## END of "MOVED from within the main for-loop (in creation of 'test_compt_aln_degeneracy.pl')." ##

		## ADDED in creation of  'test_compt_aln_degeneracy.pl'. (MAIN1) ##

	print STDOUT "\n{ (MAIN-1) 'compt_aln_degeneracy' BEFORE the \"shift\"s }\n\n";

	my ($DEGENERACY1, $code1) = compt_aln_degeneracy (@{$coll_cmpl_gblocks}, @cp_bds_gblks, @cp_gb_coords, @BDS_GB_COORDS, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);
	unless (defined $DEGENERACY1) {
	    print STDOUT "[ERROR '$plscript_name'] The MAIN subroutine 'compt_aln_degeneracy' FAILED  BEFORE the \"shift\"s !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The MAIN subroutine 'compt_aln_degeneracy' ENDED BEFORE the \"shift\"s (w/ \$DEGENERACY1 = $DEGENERACY1) ...\n\n\n";


		## END of "ADDED in creation of  'test_compt_aln_degeneracy.pl'. (MAIN1)" ##


for (my $gb = 0; $gb < $ct_gblks; $gb++) { # 1st main for-loop (over gap-blocks).

	my ($lbd_bf, $rbd_bf) = @{$cp_bds_gblks[$gb]};

	print STDOUT "{{ The $gb th gap-block w/ (lbd, rbd)_bf = ($lbd_bf, $rbd_bf) }}\n\n";

		# ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 2) #
		# => MODIFIED in creation of 'test_compt_aln_degeneracy.pl'. #

	my $SHIFT = $LRBDS2SHIFT{"$lbd_bf:$rbd_bf"};
	unless (defined $SHIFT) {
	##unless (($lbd_bf == $LBD_SBJ) and ($rbd_bf == $RBD_SBJ)) {
	    print STDOUT " ... NOT SUBJECT !! ... SKIP the behavior TESTs... \n\n\n";
	    next;
	}
		# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 2)" #

	print STDOUT "[ \$SHIFT = $SHIFT ]\n\n";

		# ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2A+) #

#=MOVED to above the main for-loop.
#	print STDOUT "\n{ (1) 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' BEFORE the \"shift\"s }\n\n";
#
#	my $IF_OVERLAP1 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb); # UPDATED on 2019/04/03.
#	##my $IF_OVERLAP1 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks);
#	unless (defined $IF_OVERLAP1) {
#	    print STDOUT "[ERROR '$plscript_name'] The 3rd MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' FAILED !\n\n";
#	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
#	    die;
#	}
#	print STDOUT "\n --- The 3rd MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' ENDED BEFORE the \"shift\"s (w/ \$IF_OVERLAP1 = $IF_OVERLAP1) ...\n\n";
#
#	my $IF_RIGHT_ORDER1 = chk_pos_orders_amg_swpbl_gblks (@{$sets_swappable_gblks}, @cp_bds_gblks);
#	unless (defined $IF_RIGHT_ORDER1) { # A BUG fixed on 2019/04/01.
#	##unless ($IF_RIGHT_ORDER1) {
#	    print STDOUT "[ERROR '$plscript_name'] The 5th MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' FAILED !\n\n";
#	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
#	    die;
#	}
#	print STDOUT "\n --- The 5th MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' ENDED BEFORE the \"shift\"s (w/ \$IF_RIGHT_ORDER1 = $IF_RIGHT_ORDER1) ...\n\n";
#=cut # END of "MOVED to above the main for-loop."


	my $abs_shift = ($SHIFT > 0) ? $SHIFT : -$SHIFT; # ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.

	print STDOUT "\n{ (Sub-2) Performing $SHIFT \"shift\"s (munus=to the left, plus=to the right) }\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'. #
	##print STDOUT "\n{ (2) Performing $abs_shift \"shift\"s }\n\n";


    for (my $round = 1; $round <= $abs_shift; $round++) { # Middle for-loop (repeating $abs_shift times).

	print STDOUT "   | The $round th round |\n\n";

		# END of "ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2A+)" #

    if ($SHIFT > 0) { # ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 1) => MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. => MOVED from above the 1st main for-loop (in creation of 'test_compt_aln_degeneracy.pl').

	my $ct_vextensions = vextend_right_end_sbj_gblk ($gb, @cp_bds_gblks, @cp_set_clms, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);
	unless (defined $ct_vextensions) {
	    print STDOUT "[ERROR '$plscript_name'] The 1st Sub-Sub-MAIN subroutine 'vextend_right_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 1st Sub-Sub-MAIN Subroutine 'vextend_right_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtual extensions} = $ct_vextensions) ...\n\n";

#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1)
#	print STDOUT "[[ Data sets AFTER 'vextend_right_end_sbj_gblk' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n"; # A BUG fixed on 2019/03/24.
#	    ##print STDOUT join ("\t", $gb, @{$cp_bds_gblks[$gb]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb & @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_set_clms: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";
#	
#	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
#		print STDOUT join ("\t", $c, @{$cp_set_clms[$c]}), "\n";
#	}	# End of the sub-main for-loop (over columns). #
#	print STDOUT "\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1)"


	my $ct_vextended = vextend_rear_ends_rflnk_vincluded_gblks ($gb, @cp_bds_gblks, @{$inter_block_relations}, @cp_gblks_w_spec_lb);
	unless (defined $ct_vextended) {
	    print STDOUT "[ERROR '$plscript_name'] The 2nd Sub-Sub-MAIN subroutine 'vextend_rear_ends_rflnk_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 2nd Sub-Sub-MAIN Subroutine 'vextend_rear_ends_rflnk_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually extended rear-ends} = $ct_vextended) ...\n\n";

#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2)
#	print STDOUT "[[ Data sets AFTER 'vextend_rear_ends_rflnk_vincluded_gblks' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n"; # A BUG fixed on 2019/03/24.
#	    ##print STDOUT join ("\t", $gb, @{$cp_bds_gblks[$gb]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n";
#
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2)"

		# ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 3A) #

	##my $ct_vextensions = vextend_right_end_sbj_gblk ($gb, @cp_bds_gblks, @cp_set_clms, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);

	##my @cp_gb_coords = @init_gb_coords; # MOVED to above the middle for-loop. (in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.)

	my ($flag, $incr_ct_null_clms) = shift_gblock (@cp_set_clms, @cp_bds_gblks, @cp_gb_coords, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb, $gb, $SHIFT/$abs_shift, @{$rows_affd_by_blks}, $cnct_null_clm); # MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.
	##my ($flag, $incr_ct_null_clms) = shift_gblock (@cp_set_clms, @cp_bds_gblks, @cp_gb_coords, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb, $gb, $SHIFT, @{$rows_affd_by_blks}, $cnct_null_clm);
   ## ($bds_gblocks0, $rows_affd_by_blks) = extract_br_info_gblocks ($left_end_wd, @{$set_lists_gblocks_in_wds->[0]}, %{$nodeid2msa_row});

	unless ((defined $flag) and ($flag == 0)) {
	    unless (defined $flag) { $flag = 'undef'; }
	    print STDOUT "[ERROR '$plscript_name'] The 3rd Sub-Sub-MAIN subroutine 'shift_gblock' FAILED on the $gb th gap-block (flag = $flag)!\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 3rd Sub-Sub-MAIN Subroutine 'shift_gblock' ENDED on the $gb th gap-block (increment of #{null columns} = $incr_ct_null_clms) ...\n\n";

#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 3)
#	print STDOUT "[[ Data sets AFTER 'shift_gblock' ]]\n\n";
#
#	print STDOUT '@cp_gb_coords = (', join (', ', @cp_gb_coords), ") .\n\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb & @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_set_clms: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";
#	
#	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
#		print STDOUT join ("\t", $c, @{$cp_set_clms[$c]}), "\n";
#	}	# End of the sub-main for-loop (over columns). #
#	print STDOUT "\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 3)"


	my $ct_vretracted = vretract_right_ends_vincluded_gblks ($gb, @cp_bds_gblks, @{$inter_block_relations}, @{$gblock_sizes}, @cp_gblks_w_spec_rb);
	unless (defined $ct_vretracted) {
	    print STDOUT "[ERROR '$plscript_name'] The 5th Sub-Sub-MAIN subroutine 'vretract_right_ends_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    ##print STDOUT "[ERROR '$plscript_name'] The 1st MAIN subroutine 'vretract_right_ends_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 5th Sub-Sub-MAIN Subroutine 'vretract_right_ends_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually retracted gap-blocks} = $ct_vretracted) ...\n\n";
	##print STDOUT "\n --- The 1st MAIN Subroutine 'vretract_right_ends_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually retracted gap-blocks} = $ct_vretracted) ...\n\n";


#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 5)
#	print STDOUT "[[ Data sets AFTER 'vretract_right_ends_vincluded_gblks' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 5)"


	my $ct_vretracting = vretract_left_end_sbj_gblk ($gb, @cp_bds_gblks, @{$inter_block_relations}, @{$gblock_sizes}, @cp_gblks_w_spec_lb);
	unless (defined $ct_vretracting) {
	    print STDOUT "[ERROR '$plscript_name'] The 6th Sub-Sub-MAIN subroutine 'vretract_left_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    ##print STDOUT "[ERROR '$plscript_name'] The 2nd MAIN subroutine 'vretract_left_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 6th Sub-Sub-MAIN Subroutine 'vretract_left_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtually retracting the subject} = $ct_vretracting) ...\n\n";
	##print STDOUT "\n --- The 2nd MAIN Subroutine 'vretract_left_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtually retracting the subject} = $ct_vretracting) ...\n\n";


#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 6)
#	print STDOUT "[[ Data sets AFTER 'vretract_left_end_sbj_gblk' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 6)"

		# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 3A)" #

    } else { # if ($SHIFT < 0) # ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 1) => MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. => MOVED from below the 1st main for-loop (in creation of 'test_compt_aln_degeneracy.pl').

		## MOVED from within the middle for-loop, which in turn is within the 2nd main for-loop (in creation of 'test_compt_aln_degeneracy.pl'). ##

	my $ct_vextensions = vextend_left_end_sbj_gblk ($gb, @cp_bds_gblks, @cp_set_clms, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);
	unless (defined $ct_vextensions) {
	    print STDOUT "[ERROR '$plscript_name'] The 1st Sub-Sub-MAIN subroutine 'vextend_left_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n"; die;
	}
	print STDOUT "\n --- The 1st Sub-Sub-MAIN Subroutine 'vextend_left_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtual extensions} = $ct_vextensions) ...\n\n";

#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1)
#	print STDOUT "[[ Data sets AFTER 'vextend_left_end_sbj_gblk' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n"; # A BUG fixed on 2019/03/24.
#	    ##print STDOUT join ("\t", $gb, @{$cp_bds_gblks[$gb]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb & @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_set_clms: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";
#	
#	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
#		print STDOUT join ("\t", $c, @{$cp_set_clms[$c]}), "\n";
#	}	# End of the sub-main for-loop (over columns). #
#	print STDOUT "\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 1)"


	my $ct_vextended = vextend_rear_ends_lflnk_vincluded_gblks ($gb, @cp_bds_gblks, @{$inter_block_relations}, @cp_gblks_w_spec_rb);
	unless (defined $ct_vextended) {
	    print STDOUT "[ERROR '$plscript_name'] The 2nd Sub-Sub-MAIN subroutine 'vextend_rear_ends_lflnk_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 2nd Sub-Sub-MAIN Subroutine 'vextend_rear_ends_lflnk_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually extended rear-ends} = $ct_vextended) ...\n\n";


#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2)
#	print STDOUT "[[ Data sets AFTER 'vextend_rear_ends_lflnk_vincluded_gblks' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n"; # A BUG fixed on 2019/03/24.
#	    ##print STDOUT join ("\t", $gb, @{$cp_bds_gblks[$gb]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2)"


		# ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 3B) #

	##my $ct_vextensions = vextend_right_end_sbj_gblk ($gb, @cp_bds_gblks, @cp_set_clms, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);

	##my @cp_gb_coords = @init_gb_coords; # MOVED to above the middle for-loop.

	my ($flag, $incr_ct_null_clms) = shift_gblock (@cp_set_clms, @cp_bds_gblks, @cp_gb_coords, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb, $gb, $SHIFT/$abs_shift, @{$rows_affd_by_blks}, $cnct_null_clm); # MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'.
	##my ($flag, $incr_ct_null_clms) = shift_gblock (@cp_set_clms, @cp_bds_gblks, @cp_gb_coords, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb, $gb, $SHIFT, @{$rows_affd_by_blks}, $cnct_null_clm);
   ## ($bds_gblocks0, $rows_affd_by_blks) = extract_br_info_gblocks ($left_end_wd, @{$set_lists_gblocks_in_wds->[0]}, %{$nodeid2msa_row});

	unless ((defined $flag) and ($flag == 0)) {
	    unless (defined $flag) { $flag = 'undef'; }
	    print STDOUT "[ERROR '$plscript_name'] The 3rd Sub-Sub-MAIN subroutine 'shift_gblock' FAILED on the $gb th gap-block (flag = $flag)!\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 3rd Sub-Sub-MAIN Subroutine 'shift_gblock' ENDED on the $gb th gap-block (increment of #{null columns} = $incr_ct_null_clms) ...\n\n";

#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 3)
#	print STDOUT "[[ Data sets AFTER 'shift_gblock' ]]\n\n";
#
#	print STDOUT '@cp_gb_coords = (', join (', ', @cp_gb_coords), ") .\n\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb & @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_set_clms: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";
#	
#	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
#		print STDOUT join ("\t", $c, @{$cp_set_clms[$c]}), "\n";
#	}	# End of the sub-main for-loop (over columns). #
#	print STDOUT "\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 3)"


	my $ct_vretracted = vretract_left_ends_vincluded_gblks ($gb, @cp_bds_gblks, @{$inter_block_relations}, @{$gblock_sizes}, @cp_gblks_w_spec_lb);
	unless (defined $ct_vretracted) {
	    print STDOUT "[ERROR '$plscript_name'] The 5th Sub-Sub-MAIN subroutine 'vretract_left_ends_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    ##print STDOUT "[ERROR '$plscript_name'] The 1st MAIN subroutine 'vretract_left_ends_vincluded_gblks' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 5th Sub-Sub-MAIN Subroutine 'vretract_left_ends_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually retracted gap-blocks} = $ct_vretracted) ...\n\n";
	##print STDOUT "\n --- The 1st MAIN Subroutine 'vretract_left_ends_vincluded_gblks' ENDED on the $gb th gap-block (#{virtually retracted gap-blocks} = $ct_vretracted) ...\n\n";


#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 5)
#	print STDOUT "[[ Data sets AFTER 'vretract_left_ends_vincluded_gblks' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_lb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 5)"


	my $ct_vretracting = vretract_right_end_sbj_gblk ($gb, @cp_bds_gblks, @{$inter_block_relations}, @{$gblock_sizes}, @cp_gblks_w_spec_rb);
	unless (defined $ct_vretracting) {
	    print STDOUT "[ERROR '$plscript_name'] The 6th Sub-Sub-MAIN subroutine 'vretract_right_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    ##print STDOUT "[ERROR '$plscript_name'] The 2nd MAIN subroutine 'vretract_right_end_sbj_gblk' FAILED on the $gb th gap-block !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 6th Sub-Sub-MAIN Subroutine 'vretract_right_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtually retracting the subject} = $ct_vretracting) ...\n\n";
	##print STDOUT "\n --- The 2nd MAIN Subroutine 'vretract_right_end_sbj_gblk' ENDED on the $gb th gap-block (#{virtually retracting the subject} = $ct_vretracting) ...\n\n";


#=DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 6)
#	print STDOUT "[[ Data sets AFTER 'vretract_right_end_sbj_gblk' ]]\n\n";
#
#	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
#	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
#	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
#	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
#	}
#	print STDOUT "\n\n";
#
#	print STDOUT '[ Contents of @cp_gblks_w_spec_rb: ]', "\n\n";
#
#	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,rb=c]'), "\n\n";
#	
#	for (my $c = $le_wd; $c <= $re_wd; $c++) {
#	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
#	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_rb_eq_c]"), "\n";
#	}
#	print STDOUT "\n\n\n\n";
#=cut # END of "DISABLED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 6)"

		# END of "ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 3B)" #

		## END of "MOVED from within the middle for-loop, which in turn is within the 2nd main for-loop (in creation of 'test_compt_aln_degeneracy.pl')." ##

    } # END of "if ($SHIFT > 0) {...} else {...} # ADDED in creation of 'test_vretract_gblock_ends.pl'. (MAIN 1) => MODIFIED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'." => MOVED from below the 2nd main for-loop (in creation of 'test_compt_aln_degeneracy.pl').

		# ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2B+) #

    } # End of the middle for-loop (repeating $abs_shift times). # MOVED to below (on 2019/04/01). => MOVED BACK from below (in creation of 'test_compt_aln_degeneracy.pl').


	print STDOUT "[[ Data sets AFTER the $SHIFT \"shift\"s (plus = to the right, munus = to the left) ]]\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'.
	##print STDOUT "[[ Data sets AFTER the $round th \"shift\" ]]\n\n"; # MODIFIED on 2019/04/01.
	####print STDOUT "[[ Data sets AFTER the $abs_shift \"shift\"s ]]\n\n";

	print STDOUT '@cp_gb_coords = (', join (', ', @cp_gb_coords), ") .\n\n\n";

	print STDOUT '[ Contents of @cp_bds_gblks: ]', "\n\n";
	print STDOUT join ("\t", 'Indx_gb', 'lbd', 'rbd'), "\n\n";
	for (my $gb2 = 0; $gb2 < $ct_gblks; $gb2++) {
	    print STDOUT join ("\t", $gb2, @{$cp_bds_gblks[$gb2]}), "\n";
	}
	print STDOUT "\n\n";

	print STDOUT '[ Contents of @cp_gblks_w_spec_lb & @cp_gblks_w_spec_rb: ]', "\n\n";

	print STDOUT join ("\t", 'Indx_clm(=c)', '[gap,blocks,w,lb=c]', '[gap,blocks,w,rb=c]'), "\n\n";
	
	for (my $c = $le_wd; $c <= $re_wd; $c++) {
	    my $cnct_gblks_w_lb_eq_c = join (',', @{$cp_gblks_w_spec_lb[$c]});
	    my $cnct_gblks_w_rb_eq_c = join (',', @{$cp_gblks_w_spec_rb[$c]});
	    print STDOUT join ("\t", $c, "[$cnct_gblks_w_lb_eq_c]", "[$cnct_gblks_w_rb_eq_c]"), "\n";
	}
	print STDOUT "\n\n";

	print STDOUT '[ Contents of @cp_set_clms: ]', "\n\n";

	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";
	
	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
		print STDOUT join ("\t", $c, @{$cp_set_clms[$c]}), "\n";
	}	# End of the sub-main for-loop (over columns). #
	print STDOUT "\n\n";


	print STDOUT "\n{ (Sub-3) 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' AFTER the $SHIFT \"shift\"s }\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'.
	##print STDOUT "\n{ (3) 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' AFTER the $round th \"shift\" }\n\n"; # MODIFIED on 2019/04/01.
	##print STDOUT "\n{ (3) 'chk_ovlp_bw_vequiv_gblks' & 'chk_pos_orders_amg_swpbl_gblks' AFTER the $abs_shift \"shift\"s }\n\n";

	my $IF_OVERLAP2 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb); # UPDATED on 2019/04/03.
	##my $IF_OVERLAP2 = chk_ovlp_bw_vequiv_gblks (@{$sets_vequiv_gblks}, @cp_bds_gblks);
	unless (defined $IF_OVERLAP2) {
	    print STDOUT "[ERROR '$plscript_name'] The 3rd Sub-MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' FAILED !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 3rd Sub-MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' ENDED AFTER the $SHIFT \"shift\"s (w/ \$IF_OVERLAP2 = $IF_OVERLAP2) ...\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'.
	##print STDOUT "\n --- The 3rd MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' ENDED AFTER the $round th \"shift\"s (w/ \$IF_OVERLAP2 = $IF_OVERLAP2) ...\n\n"; # MODIFIED on 2019/04/01.
	####print STDOUT "\n --- The 3rd MAIN subroutine 'chk_ovlp_bw_vequiv_gblks' ENDED AFTER the \"shift\"s (w/ \$IF_OVERLAP2 = $IF_OVERLAP2) ...\n\n";

	my $IF_RIGHT_ORDER2 = chk_pos_orders_amg_swpbl_gblks (@{$sets_swappable_gblks}, @cp_bds_gblks);
	unless (defined $IF_RIGHT_ORDER2) { # A BUG fixed on 2019/04/01.
	##unless ($IF_RIGHT_ORDER2) {
	    print STDOUT "[ERROR '$plscript_name'] The 5th Sub-MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' FAILED !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The 5th Sub-MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' ENDED AFTER the $SHIFT \"shift\"s (w/ \$IF_RIGHT_ORDER2 = $IF_RIGHT_ORDER2) ...\n\n"; # MODIFIED in creation of 'test_compt_aln_degeneracy.pl'. 
	##print STDOUT "\n --- The 5th MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' ENDED AFTER the $round th \"shift\"s (w/ \$IF_RIGHT_ORDER2 = $IF_RIGHT_ORDER2) ...\n\n"; # MODIFIED on 2019/04/01.
	####print STDOUT "\n --- The 5th MAIN subroutine 'chk_pos_orders_amg_swpbl_gblks' ENDED AFTER the \"shift\"s (w/ \$IF_RIGHT_ORDER2 = $IF_RIGHT_ORDER2) ...\n\n";

	print STDOUT "\n\n"; # ADDED on 2019/04/01.

    ##} # End of the middle for-loop (repeating $abs_shift times). # MOVED from above (on 2019/04/01). => MOVED BACK to above (in creation of 'test_compt_aln_degeneracy.pl'). #

		# END of "ADDED in creation of 'test_chk_posrel_amg_vequiv_gblks.pl'. (MAIN 2B+)" #


		## ADDED in creation of  'test_compt_aln_degeneracy.pl'. (MAIN2) ##

	print STDOUT "\n{ (MAIN-2) 'compt_aln_degeneracy' AFTER the \"shift\"s }\n\n";

	my ($DEGENERACY2, $code2) = compt_aln_degeneracy (@{$coll_cmpl_gblocks}, @cp_bds_gblks, @cp_gb_coords, @BDS_GB_COORDS, @{$inter_block_relations}, @cp_gblks_w_spec_lb, @cp_gblks_w_spec_rb);
	unless (defined $DEGENERACY2) {
	    print STDOUT "[ERROR '$plscript_name'] The MAIN subroutine 'compt_aln_degeneracy' FAILED AFTER the \"shift\"s !\n\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die;
	}
	print STDOUT "\n --- The MAIN subroutine 'compt_aln_degeneracy' ENDED AFTER the \"shift\"s (w/ \$DEGENERACY2 = $DEGENERACY2) ...\n\n\n";

		## END of "ADDED in creation of  'test_compt_aln_degeneracy.pl'. (MAIN2)" ##


} # End of the 1st main for-loop (over gap-blocks).



	### NOTE: The 2nd main for-loop were REMOVED, after MOVING some IMPORTANT parts (in creation of 'test_compt_aln_degeneracy.pl'). ###


	### END of "ADDED in creation of 'test_vextend_gblock_ends.pl'. (1)" ###

=cut # END of "DISABLED in creation of 'test_serial_shifts_point2point.pl'. (MAIN)"



print STDOUT "\n\n  === The Script '$plscript_name' ENDED !! ===\n\n\n";


