#!/usr/bin/perl
#
# test_nonrec_mlt_shifts_gapblocks.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'nonrec_mlt_shifts_gapblocks',
#	of the Perl package, "MyANEX_Main.pm".
#	The script was created by modifying its predecessor, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'.
#	[CREATION STARTED on 2019/05/30, ENDED on 2019/mm/dd.]
#
#	[MAJOR REVISION on 2019/06/27]:
#	CHANGED the source of the subroutine, 'associate_nodeids_w_msa_rows',
#	from "MyANEX_Supple.pm" to "MyTreeMap_sppl.pm".
#
# test_nonrec_mlt_shifts_noninf_gapblocks.pl:
#	This Perl script examines the behavior of a MAIN subroutine, 'nonrec_mlt_shifts_noninf_gapblocks', of the Perl package "MyANEX_Main.pm".
#	The script was created by slightly modifying the script 'test_shift_bl_and_compt_prob_incr.pl'.
#	[CREATION STARTED on 2019/03/03, ENDED on 2019/03/07.]
#
# test_shift_bl_and_compt_prob_incr.pl:
#	This Perl script examines the behaviors of the subroutine, 'shift_bl_and_compt_prob_incr',
#	in the Perl package "MyANEX_Main.pm".
#	It also briefly examines the behaviors of the subroutines that prepare the inputs
#	of 'shift_bl_and_compt_prob_incr'.
#	The script was created by modifying 'test_br_calc_sbst_prob_sgl_clm.pl'.
#	[CREATION STARTED on 2019/03/01, ENDED on 2019/03/03.]
#
# test_br_calc_sbst_prob_sgl_clm.pl:
#	This Perl script examines the behaviors of the subroutine, 'br_calc_sbst_prob_sgl_clm',
#	in the Perl package "MyLikelihoods_respattern_msa_dna.pm".
#	It also briefly examines the behaviors of the subroutines, 'associate_nodeids_w_msa_rows' & 'mk_init_set_columns0', in "MyANEX_Supple.pm".
#	[CREATION STARTED on 2019/02/27, ENDED on 2019/03/01.]
#
# test_calc_prob_descresstats2.pl:
#	This Perl script examines the behaviors of the subroutine, 'calc_prob_descresstats_cond_ancstat2',
#	in the Perl package 'MyLikelihoods_respattern_msa_dna.pm.'
#	The script was created by modifying 'test_calc_prob_descresstats.pl'.
#	(CREATED on Apr 30 (Sat), 2016.)
#
# test_calc_prob_descresstats.pl:
#	This Perl script examines the behavoirs of subroutines,
#	'calc_prob_descresstats_cond_ancstat' and 'calc_prob_descresstats',
#	in the Perl package 'MyPRANK_Scores.pm.'	
#	The script was created by partially exploiting the framework of 'test_create_pw_imp_score_mtrx.pl'.
#	(CREATED on Sep 20 (Sat), 2014)
#

use strict;
use warnings;

use MyMalnIO qw(
	pr_ODEN_input
	);

use MyTreeManipu_II qw( output_tree make_node2parent );

	# MODIFIED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. #
use MyLikelihoods_respattern_msa_dna qw(
	calc_prob_descresstats_cond_ancstat2
	calc_clm_probs
	br_calc_sbst_prob_sgl_clm
	);
##use MyLikelihoods_respattern_msa_dna qw(
##	calc_prob_descresstats_cond_ancstat2
##	);

=for the predecessor 'test_calc_prob_descresstats.pl'
use MyPRANK_Scores qw(
	calc_prob_descresstats_cond_ancstat
	calc_prob_descresstats
	);
=cut

	# ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (1) #
use MyTreeMap_indels_spt_odr_finer qw(
	enum_psm_indel_hsts_for_msa_finer_PRE
	enum_psm_indel_hsts_for_msa_finer_1ST_HF
	);
#use MyTreeManipu_III qw(
#	make_node2abs_depth
#	);

	# MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #

	# => Further MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. #
use MyANEX_Supple qw(
	prepare_sliding_windows
	extract_br_info_gblocks
	mk_init_set_columns0
	mk_orgs_bds_gb_coords
	); # (Newly added 'mk_orgs_bds_gb_coords' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'.) #
	# EXCLUDED 'associate_nodeids_w_msa_rows' in REVISION (on 2019/06/27).
#use MyANEX_Supple qw(
#	associate_nodeids_w_msa_rows
#	mk_init_set_columns0
#	);

	# END of "ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (1)" #

	# ADDED in REVISION (on 2019/06/27). #
use MyTreeMap_sppl qw(
	associate_nodeids_w_msa_rows
	);
	# END of "ADDED in REVISION (on 2019/06/27)." #

	# ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0) #
use MyTreeMap_indels_spt_odr2 qw(
	br_list_gblocks
	);

	# MODIFIED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #
	# => Further MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/05/30) (0a): (Added 'nonrec_mlt_shifts_gapblocks'.)
use MyANEX_Main qw(
	nonrec_mlt_shifts_noninf_gapblocks
	nonrec_mlt_shifts_gapblocks
	printout_multidim_storage
	);
##use MyANEX_Main qw(
##	shift_bl_and_compt_prob_incr
##	);
	# END of "ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0)" #

	# ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (P) #

use MyGapPatternTopology qw(
	mk_inter_block_relations
	);

use MyReadAlnProbIngredients qw(
	readin_delta_del
	assign_br2log_mfacs
	);
	# END of "ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (P)" #

$| = 1; # Flush the input buffer as soon as it receives data.

my ($plscript_name) = ($0 =~ m!([^/]+)$!);

	### Glogal parameter setting ###

our $TOP_NODE = $MyTreeManipu_II::TOP_NODE;
our $INDX_LENGTH = $MyTreeManipu_II::INDX_LENGTH;
our $INDX_BOOT = $MyTreeManipu_II::INDX_BOOT; # RESURRECTED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. #

our $GAP = '-';
our $CHAR_PRES = 'N'; # Added on 2019/02/28.

our @RESIDUES = our @NUCLEOTIDES = @MyLikelihoods_respattern_msa_dna::NUCLEOTIDES; # Unless otherwise stated, nucleotide MSA scores will be calculated according to this order (or index assignment) of the nucleotide bases.
##our @RESIDUES = our @NUCLEOTIDES = @MyPRANK_Scores::NUCLEOTIDES; # Unless otherwise stated, nucleotide MSA scores will be calculated according to this order (or index assignment) of the nucleotide bases.
our $CT_NUCLS = @NUCLEOTIDES;

my @labels_resfreqs = ();
foreach my $res (@NUCLEOTIDES) { push @labels_resfreqs, "f($res)"; }


our $STRING_UNDEF = 'undef'; # Added on 2019/03/04. #
##our $STRING_UNDEF = 'N/A'; # Added on 2019/03/04. #


	### IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Parameters) ###

	## File names storing important parameters. ##

our $FILENAME_DELTA_DEL = 'delta_del.txt'; # The name of the file storing '$delta_del', which is important for calculating the exit rate of the entire sequence. #

our @FILENAMES_LOG_MFACS = ( # Names of the files storing logarithmic multiplication factors, which are in $indir_mfacs. #

		# In the bulk #
	'lmfacs_asites_vs_dgaps.txt', # For the cases where there are some ancestral sites and no descendant sites in between preserved ancestral sites (PASs). #
	'lmfacs_agaps_vs_dsites.txt', # For the cases where there are no ancestral sites and some descendant sites in between PASs.
	'lmfacs_asites_nhom_dsites.txt', # For the cases where there are some ancestral sites and some descendant sites in between PASs.

		# On either boundary (i.e., either PWA end). "bd_$filename" corresponds to $filename above. #
	'bd_lmfacs_asites_vs_dgaps.txt',
	'bd_lmfacs_agaps_vs_dsites.txt',
	'bd_lmfacs_asites_nhom_dsites.txt'
	);


	## Parameters for indel component of alignment probability. ##

our $DISTRI_INS = 'P'; # 'P' stands for a Zipf power-law distribution.
our $DISTRI_DEL = 'P';

	# Total rate of insertions at a site relative to the substitution rate.
our $TOTRATE_INS = 0.1;
	# Total rate of deletions at a site relative to the substitution rate.
our $TOTRATE_DEL = 0.1;

 	# Exponent for the power-law distribution of insertion length (when $INDEL_MODEL = 'zipf').
our $PARAM_INS = 1.6;
	# Exponent for the power-law distribution of deletion length (when $INDEL_MODEL = 'zipf').
our $PARAM_DEL = 1.6;


	# Cut-off insertion length.
our $CUTOFF_INS_LEN = 20;
	# Cut-off deletion length.
our $CUTOFF_DEL_LEN = 20;

our @PARAMS_INS = ($TOTRATE_INS, $DISTRI_INS, $PARAM_INS);

our @PARAMS_DEL = ($TOTRATE_DEL, $DISTRI_DEL, $PARAM_DEL); 

	### END of "IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Parameters)" ###


	### Parameters to adjust the verboseness of the test outputs. ###
	### (0, silent; 1, very modest; 2, modest; 3, medium; 4, verbose; 5, very verbose.)

        # For 'calc_prob_descresstats_cond_ancstat2'. #
$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 0;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 1;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 5;
##$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = 6;

=for the predecessor 'test_calc_prob_descresstats.pl'
        # For 'calc_prob_descresstats_cond_ancstat'. #
##$MyPRANK_Scores::TEST_LEVEL_cpdca = 0;
##$MyPRANK_Scores::TEST_LEVEL_cpdca = 5;
$MyPRANK_Scores::TEST_LEVEL_cpdca = 6;
=cut


	# Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0b) #

	# For 'shift_bl_and_compt_prob_incr'. #
$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr = 0;
##$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr = 5;

	# END of "Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0b)" #

	# ADDED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (0b) #

	# For 'nonrec_mlt_shifts_noninf_gapblocks'. #
$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = 0;
##$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = 6;

	# END of "ADDED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (0b)" #

	# ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0b) #

	# For 'nonrec_mlt_shifts_gapblocks'. #
$MyANEX_Main::TEST_LEVEL_nr_msht_gblks = 0;
##$MyANEX_Main::TEST_LEVEL_nr_msht_gblks = 3.5;
##$MyANEX_Main::TEST_LEVEL_nr_msht_gblks = 7;

	# For the ingredients of alignment probabilities in 'nonrec_mlt_shifts_gapblocks'. (Added on 2019/06/06) #
$MyANEX_Main::TEST_LEVEL_nr_msht_gblks2 = 3;


	# For 'enum_psm_indel_scns_for_msa_hs_mrounds' in "$MyTreeMap_indels_spt_odr_hs.pm". #
$MyTreeMap_indels_spt_odr_hs::TEST_LEVEL = 0;
#$MyTreeMap_indels_spt_odr_hs::TEST_LEVEL = 3;
#$MyTreeMap_indels_spt_odr_hs::TEST_LEVEL = 5;

	# For 'apprx1_tot_lnlk_gpattern_msa2_hs' in "MyTreeMap_indels_ML_hs_hs.pm". #
$MyTreeMap_indels_ML_hs_hs::TEST_LEVEL = 0;
#$MyTreeMap_indels_ML_hs_hs::TEST_LEVEL = 3;
#$MyTreeMap_indels_ML_hs_hs::TEST_LEVEL = 5;

	# END of "ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0b)" #


=For 'test 3ext-dbg1'. (ADDED on 2019/06/06).

$MyANEX_Main::TEST_LEVEL_nr_msht_gblks = 7;
$MyTreeMap_indels_spt_odr_hs::TEST_LEVEL = 5;
$MyTreeMap_indels_ML_hs_hs::TEST_LEVEL = 0;

=cut # End of "For 'test 3ext-dbg1'. (ADDED on 2019/06/06)."


	### Input Variables. ###

	# Equilibrium residue frequencies. #

my @equil_resfreqs = (0.1, 0.2, 0.3, 0.4);

	# Full MSA. #


	# MOVED to below (with modification) (on 2019/03/01).
##my $ct_seqs = 4;
##
##my @seqids = ();
##for (my $k=1; $k<=$ct_seqs; $k++) { push @seqids, sprintf ("seq%04d", $k); }

=for test 1
my @sequences = (
	#0123456789
	"at-gca--gc", # seq 1
	"attg--ttgc", # seq 2
	"-ttg--ttgc", # seq 3
	"attgca--gc", # seq 4
	);
=cut
=for test 2
my @sequences = (
	#0123456789
	"at---", # seq 1
	"g----", # seq 2
	"----c", # seq 3
	"---gt", # seq 4
	);
=cut
=for test 3pre.
my @sequences = (
	#0123456789AB
	"a---atgcatgc", # seq 1
	"a---atacatac", # seq 2
	"gtgc-cgtatcc", # seq 3
	"atgc-tgcatgc", # seq 4
	"ataca----tgt", # seq 5
	"gtacg----tgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	[0, 1, '>'],
	[1, 2, '<']
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

=cut # End of "for test 3pre."
=for tests 3 & 3ext & 3pre2.
my @sequences = (
	#0123456789AB
	"a---atgcatgc", # seq 1
	"a---atacatac", # seq 2
	"gtgc-cgtatcc", # seq 3
	"atgc-tgcatgc", # seq 4
	"ataca----tgt", # seq 5
	"gtacg----tgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #
=cut # End of "for tests 3 & 3ext & 3pre2."

=For test 3pre & 3pre2.
my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([2, 2], [1, 3], [2, 2]);
=cut # End of "For test 3pre & 3pre2."
=For test 3.
my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([1, 3], [1, 3], [1, 3]); # NEW values.
#my @bds_bl_coords = ([0, 3], [1, 3], [1, 3]); # OLD values. ... This ends up in an ERROR, in the subroutine 'nonrec_mlt_shifts_gapblocks'!!
##my @bds_bl_coords = ([0, 4], [0, 4], [0, 4]);
=cut # End of "For test 3."
=For test 3ext.
my @org_bl_coords = (1, 4, 5);
my @bds_bl_coords = ([0, 9], [0, 11], [0, 8]);
=cut # End of "For test 3ext."

		## ADDED for DEBUGGING (on 2019/06/06). ##

=for test 3ext-dbg1.
my @sequences = (
	#0123456789AB
	"aa---tgcatgc", # seq 1
	"aa---tacatac", # seq 2
	"g-tgccgtatcc", # seq 3
	"a-tgctgcatgc", # seq 4
	"ataca----tgt", # seq 5
	"gtacg----tgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 1, 5);
my @bds_bl_coords = ([2, 2], [1, 1], [0, 5]);
=cut # End of "for test 3ext-dbg1."

		## End of "ADDED for DEBUGGING (on 2019/06/06)." ##

#=for test 5.
my @sequences = (
	#0123456789ABCD
	"a---atgcatgctg", # seq 1
	"a---atacatactg", # seq 2
	"gtgc-cgtatcccg", # seq 3
	"atgc-tgcatgcca", # seq 4
	"atacat---tgttg", # seq 5
	"gtacgtgca---tg", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (1, 4, 6, 9);
my @bds_bl_coords = ([0, 10], [0, 13], [0, 11], [0, 11]);

#=cut # End of "for test 5."

=for test 5p.
my @sequences = (
	#0123456789ABCD
	"a---atgcatgctg", # seq 1
	"a---atacatactg", # seq 2
	"gtgc-cgtatcccg", # seq 3
	"atgc-tgcatgcca", # seq 4
	"atacat---tgttg", # seq 5
	"gtacgtgca---tg", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	[0, 1, '>'],
	[2, 3, '=']
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

=cut # End of "for test 5p."
=for test 6a & 6b & 6c. 
	# Testing the boundary status (a) or the overlap of vertially equivalent gap-blocks (b), or both (c). #
my @sequences = (
	#0123456789AB
	"a---ac--a--c", # seq 1
	"a---ac--a--c", # seq 2
	"gtgcacgtatcc", # seq 3
	"atgcatgcatgc", # seq 4
	"atacatgcatgt", # seq 5
	"gtacgtgcatgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
#my @bds_bl_coords = ([1,2], [2,2], [2,3]); # For test 6a.
#my @bds_bl_coords = ([2,2], [2,3], [1,2]); # For test 6b.
my @bds_bl_coords = ([2,2], [2,3], [2,3]); # For test 6c.

=cut # End of "for test 6a & 6b & 6c."
=for test 6d.
	# Testing the boundary status. #
my @sequences = (
	#0123456789AB
	"---cac--at--", # seq 1
	"---cac--at--", # seq 2
	"gtgcacgtatcc", # seq 3
	"atgcatgcatgc", # seq 4
	"atacatgcatgt", # seq 5
	"gtacgtgcatgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([2,3], [2,2], [1,2]);
=cut # End of "for test 6d."
=for test 7.
	# Testing the change in topology (between gap-blocks in vertical child-parent relationships). #
my @sequences = (
	#0123456789AB
	"a---a---a--c", # seq 1
	"a---a---a--c", # seq 2
	"gtgca---atcc", # seq 3
	"atgca---atgc", # seq 4
	"atacatgcatgt", # seq 5
	"gtacgtgcatgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	[0, 1, '-'],
	[0, 2, '-']
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([1,3], [2,2], [2,2]);
=cut # End of "for test 7."
=for test 8a & 8b.
	# Testing the (colletively) complementary gap-blocks. #
my @sequences = (
	#0123456789AB
	"c--gt-tgt", # seq 1
	"c--gt-tgt", # seq 2
	"c--gt-tcc", # seq 3
	"c--gc-tgc", # seq 4
	"catg-atgt", # seq 5
	"cgtg-atgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
#my @bds_bl_coords = ([2,3], [2,2], [2,2]); # For test 8a. (Behavior against UNpermitted topology.)
my @bds_bl_coords = ([2,2], [1,2], [2,3]); # For test 8b. (Behavior against a topology of compleentary gap-blocks causing degeneracy.) #
=cut # End of "for test 8a & 8b."
=for test 9a.
	# Testing the v-extensions & v-retractions. #
my @sequences = (
	#0123456789AB
	"atgc------gc", # seq 1
	"atgc-------c", # seq 2
	"gtgca-----cc", # seq 3
	"atgca-----gc", # seq 4
	"atacatgcatgt", # seq 5
	"gtacgtgcatgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([2,2], [2,3], [2,2]);
=cut # End of "for test 9a."
=for test 9b.
	# Testing the v-extensions & v-retractions. #
my @sequences = (
	#0123456789AB
	"atg-------gc", # seq 1
	"atgc------gc", # seq 2
	"gtgc-----tcc", # seq 3
	"atgc-----tgc", # seq 4
	"atacatgcatgt", # seq 5
	"gtacgtgcatgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2, 2);
my @bds_bl_coords = ([2,2], [1,2], [2,2]);
=cut # End of "for test 9b."
=for test 10a & 10b.
	# Testing the behavior against gap-blocks in an 'onx' relationship. #
my @sequences = (
	#0123456789AB
	"cg-atgt", # seq 1
	"cg-atgt", # seq 2
	"cgt-tcc", # seq 3
	"cgt-tgc", # seq 4
	"cg--tgt", # seq 5
	"cg--tgt", # seq 6
	);

	# Specify the binary horizontal relationships to be excluded from the analysis.
	# (ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).) #
my @list_excluded_bin_hrels = (
	);
	# End of "(ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl' (on 2019/06/02).)" #

my @org_bl_coords = (2, 2);
#my @bds_bl_coords = ([2,3], [2,2]); # For test 10a.
my @bds_bl_coords = ([2,2], [1,2]); # For test 10b.

=cut # End of "for test 10a & 10b."


		## ADDITIONAL SETTINGS for the MAIN subroutine, nonrec_mlt_shifts_gapblocks' (added on 2019/05/31). ##

#my ($if_on_le_msa, $if_on_re_msa) = (0, 0); # If you want, set them as you like(, which will enable testing the behavior of the main subroutine 'nonrec_mlt_shifts_gapblocks' at a wider variety of settings).
my ($if_on_le_msa, $if_on_re_msa); # If you want them to take their natural values.

		## ADDITIONAL SETTINGS for the MAIN subroutine, nonrec_mlt_shifts_gapblocks' (added on 2019/05/31). ##


=DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #
	## Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0c) #

	# Set of $bl-$sh pairs to be tried. #
#my @set_bl_sh_pairs = ([0, +1], [0, +1], [2, -1], [2, -1]); # For test 3A.
#my @set_bl_sh_pairs = ([0, -2], [0, -1], [0, -1]); # For test 3B.
my @set_bl_sh_pairs = ([2, +2], [2, +1], [2, +1], [2, +1], [2, +1]); # For test 3C.

	## END of "Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (0c)" #
=cut # END of "DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'." #


	# MOVED from above with modification (on 2019/03/01). #
my $ct_seqs = @sequences;

my @seqids = ();
for (my $k=1; $k<=$ct_seqs; $k++) { push @seqids, sprintf ("seq%04d", $k); }

	# END of "MOVED from above with modification (on 2019/03/01)." #


my @full_msa = ();
foreach my $seq (@sequences) { push @full_msa, \$seq; }

my $lenaln = length $sequences[0] ;


	# Phylogenetic Tree. #

=for tests 1 & 2
my %node2ch = (
	5 => [1, 2],
	6 => [3, 4],
	7 => [5, 6],
	);
my %name2id = (
	$TOP_NODE => 7,
	);
=cut # End of "for tests 1 & 2"
#=for tests 3, 3ext, 5, 3pre, 3pre2, 6{a,b,c}, 7, 8{a,b}, 9{a,b}, 10{a,b}.
my %node2ch = (
	7 => [1, 2],
	8 => [3, 4],
	9 => [5, 6],
	10 => [7,8],
	11 => [9, 10],
	);
my %name2id = (
	$TOP_NODE => 11,
	);
#=cut # End of "for tests 3, 3ext, 5, 3pre, 3pre2, 6{a,b,c}, 7, 8{a,b}, 9{a,b}, 10{a,b}."

for (my $k=0; $k< $ct_seqs; $k++) { my $name = $seqids[$k]; $name2id{$name} = $k +1; }


	# Pre-processing before the main tests. #

my $node2pa = make_node2parent (%node2ch);
my %id2name;
foreach my $name (keys %name2id) { # 2nd preliminary foreach-loop #
	($name eq $TOP_NODE) and next;
	my $id = $name2id{$name};
	$id2name{$id} = $name;
}			# End of the 2nd preliminary foreach-loop #
my $topnode_id = $name2id{$TOP_NODE};

	# IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (1) #
my %br_attr ;
foreach my $node (sort {$a <=> $b} keys %{$node2pa}) {
	my @attr = ();
	##$attr[$INDX_LENGTH] = 0.2; # MODIFIED in creation of 'test_MOD_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. #
	$attr[$INDX_LENGTH] = 1/2; # MODIFIED in creation of 'test_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. #
	##$attr[$INDX_LENGTH] = 1;

	$attr[$INDX_BOOT] = 100;
	$br_attr{$node} = \@attr;
}
	# END of "IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (1)" #

=For the predecessor 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'.
my %br_attr ; # Dummy.
=cut # End of "For the predecessor 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'."


	# Assign 'transition matrix' to each branch in the tree. #

=for tests 1 & 2.
my %br2tr_mtrx = (
	1 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	2 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	3 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	4 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	5 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	6 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],
	);
=cut # End of "for tests 1 & 2."

#=for tests 3, 3ext, 5.
my %br2tr_mtrx = (
	1 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	2 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	3 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	4 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	5 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	6 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	7 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	8 =>  [	[0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	9 =>  [	[0.4, 0.1, 0.2, 0.3],
		[0.7, 0.1, 0.1, 0.1],
		[0.4, 0.3, 0.1, 0.2],
		[0.4, 0.2, 0.2, 0.2] ],

	10 =>  [ [0.5, 0.2, 0.2, 0.1],
		[0.4, 0.1, 0.2, 0.3],
		[0.6, 0.1, 0.1, 0.2],
		[0.4, 0.3, 0.2, 0.1] ],

	##11 =>  [ [0.4, 0.1, 0.2, 0.3],
	##	[0.7, 0.1, 0.1, 0.1],
	##	[0.4, 0.3, 0.1, 0.2],
	##	[0.4, 0.2, 0.2, 0.2] ], # Usually, NO transition matrix is assigned to the root.

	);
#=cut # End of "for tests 3, 3ext, 5."


	### IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Files) ###

	## Input files/directories. ##

my $indir_mfacs = './InData/PL1.6_co20'; # MUST BE MODIFIED according to your file system environment. #

my $infile_delta_del = "$indir_mfacs/$FILENAME_DELTA_DEL"; # This file stores '$delta_del', which is important for calculating the exit rate of the entire sequence. #


	## Check input files/directories. ##

unless (( -d $indir_mfacs ) and ( -r $indir_mfacs )) { # ADDED in creation of 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl'.
	print STDOUT "[ERROR '$plscript_name'] CanNOT FIND a readable DIRECTORY, '$indir_mfacs', that stores data files for the multiplication factors !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n\n";
	die ;
}

foreach my $file ($infile_delta_del) {
    unless (( -f $file ) and ( -r $file )){
	print STDOUT "[ERROR '$plscript_name'] CanNOT FIND a readable INPUT FILE '$file' !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n\n";
	die ;
    }
}

foreach my $filename (@FILENAMES_LOG_MFACS) { # ADDED in creation of 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl'. #
    my $file = "$indir_mfacs/$filename";
    unless (( -f $file ) and ( -r $file )){
	print STDOUT "[ERROR '$plscript_name'] CanNOT FIND a readable INPUT FILE '$file' !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n\n";
	die ;
    }
}
	### END of "IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Files)" ###


	### Declare the beginning of the script ###

print STDOUT "\n<<<< Program name: $plscript_name (path: $0) >>>>\n\n";

		## IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Print 1) ##
print STDOUT "Input Files:\n\n";
print STDOUT "Input file recording ", '$delta_del', ": $infile_delta_del .\n\n";
print STDOUT "Input directory storing (log-)multiplication factors: $indir_mfacs ,\n\n";
print STDOUT "   which holds the following input files:\n\n";
print STDOUT '     ', join (', ', @FILENAMES_LOG_MFACS), " .\n\n\n";
		## END of "IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Print 1)" ##


print STDOUT "<< Glogal Parameters >>\n\n";

print STDOUT '$GAP = ', $GAP, " ,\n";
print STDOUT '$CHAR_PRES = ', $CHAR_PRES, " .\n\n"; # Added on 2019/03/01.

print STDOUT '$STRING_UNDEF = ', $STRING_UNDEF, " .\n\n"; # Added on 2019/03/04. #


		## IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Print 2) #
print STDOUT "\n";
print STDOUT '@PARAMS_INS = ($TOTRATE_INS, $DISTRI_INS, $PARAM_INS) = (', join (', ', @PARAMS_INS), ") ,\n";
print STDOUT '@PARAMS_DEL = ($TOTRATE_DEL, $DISTRI_DEL, $PARAM_DEL) = (', join (', ', @PARAMS_DEL), ") .\n\n";

print STDOUT '$CUTOFF_INS_LEN = ', "$CUTOFF_INS_LEN ,\n";
print STDOUT '$CUTOFF_DEL_LEN = ', "$CUTOFF_DEL_LEN .\n\n\n";
		## END of "IMPORTED from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl' in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Print 2)" #


print STDOUT '$MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca = ', $MyLikelihoods_respattern_msa_dna::TEST_LEVEL_cpdca, " .\n\n";
##print STDOUT '$MyPRANK_Scores::TEST_LEVEL_cpdca = ', $MyPRANK_Scores::TEST_LEVEL_cpdca, " .\n\n"; # For the predecessor 'test_calc_prob_descresstats.pl'.

print STDOUT '$MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr  = ', $MyANEX_Main::TEST_LEVEL_sh_bl_cmpt_p_incr , " .\n\n"; # Added in creation of 'test_shift_bl_and_compt_prob_incr.pl'#


	# MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0c) #

print STDOUT '$MyANEX_Main::TEST_LEVEL_nr_msht_gblks  = ',  $MyANEX_Main::TEST_LEVEL_nr_msht_gblks , " .\n\n";
print STDOUT '$MyANEX_Main::TEST_LEVEL_nr_msht_gblks2 = ', $MyANEX_Main::TEST_LEVEL_nr_msht_gblks2 , " .\n\n"; # Added on 2019/06/06.

=For the predecessor, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'.
print STDOUT '$MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks = ', $MyANEX_Main::TEST_LEVEL_nr_msht_ninf_gblks , " .\n\n"; # Added in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #
=cut # End of "For the predecessor, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'."
	# END of "MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0c)" #

	# ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0c+) #
print STDOUT '$MyTreeMap_indels_spt_odr_hs::TEST_LEVEL = ', $MyTreeMap_indels_spt_odr_hs::TEST_LEVEL, " .\n";
print STDOUT '$MyTreeMap_indels_ML_hs_hs::TEST_LEVEL = ', $MyTreeMap_indels_ML_hs_hs::TEST_LEVEL, " .\n";
print STDOUT "\n\n";
	# END of "ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (0c+)" #

print STDOUT "\n<<< Input Variables >>>\n\n";

print STDOUT "\n< Input Alignment ( Size = $ct_seqs (#{sequences}) x $lenaln (#{sites}) ) >\n\n";

unless ( pr_ODEN_input (@seqids, @full_msa, 50, *STDOUT ) ) {
	print STDOUT "[ERROR '$plscript_name'] 'pr_ODEN_input' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n";
	die ;
}
print STDOUT "\n\n";

print STDOUT "\n< Phylogenetic Tree of the Aligned Sequences (Top node: $topnode_id) >\n\n";

unless ( output_tree ($topnode_id, %node2ch, %id2name, %br_attr, *STDOUT, 1, 1) ) {
	print STDOUT "[ERROR '$plscript_name'] The subroutine 'output_tree' FAILED to print out the input tree !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n";
	die ;
}

print STDOUT "\n\n< Relationships between Nodes >\n\n";
print STDOUT join ("\t", 'Node_ID', 'parent', '[child,node,IDs]'), "\n\n";

foreach my $node (sort {$a <=> $b} keys %{$node2pa}, $topnode_id) {
	my $pa = $node2pa->{$node};
	(defined $pa) or ($pa = 'undef');
	my $children = $node2ch{$node};
	my $cnct_children = (defined $children) ? join (',', @{$children}) : '';
	print STDOUT join ("\t", $node, $pa, "[$cnct_children]"), "\n";
}
print STDOUT "\n\n";


print STDOUT "\n< Residue Frequences at the root node >\n\n";
##print STDOUT "\n< Equilibrium Residue Frequences >\n\n";

print STDOUT "Freq [", join (', ', @RESIDUES), "] = (", join (', ', @equil_resfreqs), ") .\n\n";

print STDOUT "\n< Substitution Transition Matrices Assigned to the Branches >\n\n";

foreach my $br_id (sort {$a <=> $b} keys %br2tr_mtrx) {

	my $tr_mtrx = $br2tr_mtrx{$br_id};

	print STDOUT ' ' x 3, "( Branch ID: $br_id )\n\n";
	print STDOUT ' ' x 3, join ("\t", 'From\To', @RESIDUES), "\n\n";
	for (my $r=0; $r<$CT_NUCLS; $r++) { print STDOUT ' ' x 3, join ("\t", $RESIDUES[$r], @{$tr_mtrx->[$r]}), "\n"; }
	print STDOUT "\n\n";
}


	### IMPORTED with some modifications from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl'. (Pre-Pre) ###

	## IMPORTED from 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl' in creation of 'test_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. (C) ##

print STDOUT "\n<<< Pre-Preliminary (1A): Read in the multiplication factor '\$delta_del' for a 'universal' term of log-lilekihood ... >>>\n\n";

my $delta_del = readin_delta_del ($infile_delta_del);
unless (defined $delta_del) {
	print STDOUT "[ERROR '$plscript_name'] The subroutine 'readin_delta_del' FAILED !\n\n";
	print STDERR "[ERROR '$plscript_name'] $!\n\n";
	die;
}
print STDOUT "\n ... The subroutine 'readin_delta_del' Ended (w/ \$delta_del = $delta_del) ...\n\n\n";

	## END of "IMPORTED from 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl' in creation of 'test_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. (C)" ##

	## IMPORTED from 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl' in creation of 'test_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. (D) ##

print STDOUT "\n<<< Pre-Preliminary (1B): Assign the logarithmic multiplication factors to each branche, based on the files in '$indir_mfacs' ... >>>\n\n";

my $br2log_mfacs = assign_br2log_mfacs (%br_attr, $TOTRATE_INS + $TOTRATE_DEL, $indir_mfacs, @FILENAMES_LOG_MFACS);
unless (defined $br2log_mfacs) {
	print STDOUT "[ERROR '$plscript_name'] The subroutine 'assign_br2log_mfacs' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $!\n\n";
	die ;
}
print STDOUT "\n ... The subroutine 'assign_br2log_mfacs' Ended (w/ \$br2log_mfacs = $br2log_mfacs) ...\n\n\n";

	## END of "IMPORTED from 'br_infer_psm_indel_events_spt_odr_dawg.hs.pl' in creation of 'test_apprx1_tot_lnlk_gpattern_msa2_finer1.pl'. (D)" ##

	### END of "IMPORTED with some modifications from 'test_enum_psm_indel_scns_for_msa_hs_mrounds.pl'. (Pre-Pre)" ###


	# ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (0a) #

print STDOUT "\n\n<< Preliminary (0a): Copy the input MSA >>\n\n\n";

my @cp_full_msa = ();
foreach my $seq (@full_msa) {
	my $cp_seq = ${$seq};
	push @cp_full_msa, \$cp_seq;
}

print STDOUT "... Finished Copying the MSA !!\n\n\n";

print STDOUT "\n\n<< Preliminary (0b): Compute the depth and #[external offsprings} of every node >>\n\n\n";

my ($node2depth, $node2ct_exoffs, $br2eq, $br2nn, $set_all_nodes) 
    = enum_psm_indel_hsts_for_msa_finer_PRE ($topnode_id, %node2ch, %{$node2pa});
unless (defined $set_all_nodes) {
	print STDOUT "[ERROR '$plscript_name'] The 0th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_PRE' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 0th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_PRE' ENDED ...\n\n";

##my $node2depth = make_node2abs_depth ($topnode_id, %node2ch);
##unless (defined $node2depth) {
##	print STDOUT "[ERROR '$plscript_name'] The 0th Preliminary Subroutine 'make_node2abs_depth' FAILED !\n";
##	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
##	die ;
##}
##print STDOUT "\n --- The 0th Preliminary Subroutine 'make_node2abs_depth' ENDED ...\n\n";

print STDOUT "\n<< Contents of the Preliminary Output (0b), ", '%{$node2depth} & %{$node2ct_exoffs}', " >>\n\n";

print STDOUT join ("\t", 'Node_ID', 'depth', '#{external_offsprings}'), "\n\n";

foreach my $node (sort { $a <=> $b } keys %{$node2depth}) {
	my $depth = $node2depth->{$node};
	my $ct_exoffs = $node2ct_exoffs->{$node};
	unless (defined $ct_exoffs) { $ct_exoffs = 'undef'; }
	print STDOUT join ("\t", $node, $depth, $ct_exoffs), "\n";
}
print STDOUT "\n\n";

	# END of "ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (0a)" #


print STDOUT "\n\n<<< Preliminary (1): Calculate the Conditional Probabilities of the Residue States of Descendants of Each Ancestor Node, given the Residue States at the Ancestor. >>>\n\n\n"; # MODIFIED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. #
##print STDOUT "\n\n<<< Now, Calculate the Conditional Probabilities of the Residue States of Descendants of Each Ancestor Node, given the Residue States at the Ancestor. >>>\n\n\n";

	## MODIFIED in creation of 'test_calc_prob_descresstats2.pl'. ##
my ($node2set_sw_cond_probs, $node2set_sw_extcond_probs0) = calc_prob_descresstats_cond_ancstat2 (@full_msa, @seqids, %name2id, %node2ch, %br2tr_mtrx, $GAP);
##my $node2set_sw_cond_probs = calc_prob_descresstats_cond_ancstat (@full_msa, @seqids, %name2id, %node2ch, %br2tr_mtrx, $GAP);

unless (defined $node2set_sw_cond_probs) {
	print STDOUT "[ERROR '$plscript_name'] The 1st Preliminary Subroutine 'calc_prob_descresstats_cond_ancstat2' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 1st Preliminary Subroutine 'calc_prob_descresstats_cond_ancstat2' ENDED ...\n\n";
##print STDOUT "\n --- The MAIN Subroutine 'calc_prob_descresstats_cond_ancstat2' ENDED ...\n\n";

print STDOUT "\n<< Contents of the Preliminary Output (1a), ", '%{$node2set_sw_cond_probs}', " >>\n\n";
##print STDOUT "\n<< Contents of the Main Output (1), ", '%{$node2set_sw_cond_probs}', " >>\n\n";

foreach my $node_id (sort {$a <=> $b} keys %{$node2set_sw_cond_probs}) { # 1st preliminary outer foreach-loop (over nodes). #

	my $set_sw_cond_probs = $node2set_sw_cond_probs->{$node_id};

	my $ct_sites = @{$set_sw_cond_probs};

	unless ($ct_sites == $lenaln) {
	    print STDOUT "\n[WARNING '$plscript_name'] The number of sites (=$ct_sites) CLASHES with the MSA lengths (=$lenaln): $! !\n\n";
	}

	print STDOUT "< Node ID: $node_id (#{sites} = $ct_sites) >\n\n";

	print STDOUT "[ Descendant Residue State Probabilities, conditioned on the residue state of the node itself ]\n\n";

	print STDOUT join ("\t", 'Site\Conditioned_on:', @NUCLEOTIDES), "\n\n";

	for (my $s=0; $s<$ct_sites; $s++) { # Preliminary inner for-loop (over sites). #
	    if (@{$set_sw_cond_probs->[$s]}>0) {
		print STDOUT join ("\t", $s, @{$set_sw_cond_probs->[$s]}), "\n";
	    } else {
		print STDOUT join ("\t", $s, '[EMPTY]'), "\n";
	    }
	} 			# End of the preliminary inner for-loop (over sites). #

	print STDOUT "\n\n";

}			# End of the 1st preliminary outer foreach-loop (over nodes). #


print STDOUT "\n<< Contents of the Preliminary Output (1b), ", '%{$node2set_sw_extcond_probs0}', " >>\n\n";
##print STDOUT "\n<< Contents of the Main Output (2), ", '%{$node2set_sw_extcond_probs0}', " >>\n\n";

foreach my $node_id (sort {$a <=> $b} keys %{$node2set_sw_extcond_probs0}) { # 2nd preliminary outer foreach-loop (over branches). #

	my $set_sw_extcond_probs = $node2set_sw_extcond_probs0->{$node_id};

	my $ct_sites = @{$set_sw_extcond_probs};

	unless ($ct_sites == $lenaln) {
	    print STDOUT "\n[WARNING '$plscript_name'] The number of sites (=$ct_sites) CLASHES with the MSA lengths (=$lenaln): $! !\n\n";
	}

	print STDOUT "< Branch ID: $node_id (#{sites} = $ct_sites) >\n\n";

	print STDOUT "[ Descendant Residue State Probabilities, conditioned on the residue state of the parent node of the subject branch ]\n\n";

	print STDOUT join ("\t", 'Site\Conditioned_on:', @NUCLEOTIDES), "\n\n";

	for (my $s=0; $s<$ct_sites; $s++) { # Preliminary inner for-loop (over sites). #
	    if (@{$set_sw_extcond_probs->[$s]}>0) {
		print STDOUT join ("\t", $s, @{$set_sw_extcond_probs->[$s]}), "\n";
	    } else {
		print STDOUT join ("\t", $s, '[EMPTY]'), "\n";
	    }
	} 			# End of the preliminary inner for-loop (over sites). #

	print STDOUT "\n\n";

}			# End of the 2nd preliminary outer foreach-loop (over nodes). #



	## ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (2) ##

print STDOUT "\n\n<<< Preliminary (2): Calculate the Probabilities of all columns. >>>\n\n\n";

my $set_clm_probs = calc_clm_probs (@equil_resfreqs, %{$node2set_sw_cond_probs}, $topnode_id);
unless (defined $set_clm_probs) {
	print STDOUT "[ERROR '$plscript_name'] The 2nd Preliminary Subroutine 'calc_clm_probs' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 2nd Preliminary Subroutine 'calc_clm_probs' ENDED ...\n\n";


my $ct_clm_prbs = @{$set_clm_probs};
print STDOUT "\n<< Contents of the Preliminary Output (2), ", '@{$set_clm_probs}', " (#{elements} = $ct_clm_prbs) >>\n\n";

print STDOUT join ("\t", 'Column', 'Probability'), "\n\n";
##print STDOUT join ("\t", 'Site', 'Probability'), "\n\n";

for (my $c=0; $c < $ct_clm_prbs; $c++) { # 3rd preliminary for-loop (over columns). #

	print STDOUT join ("\t", $c, $set_clm_probs->[$c]), "\n";

}	# End of the 3rd preliminary for-loop (over columns). #

print STDOUT "\n\n";

		## Restarted on 2019/02/28. ##

print STDOUT "\n\n<<< Preliminary (3): Create ", '@nodeids_in_msa', ", an IMPORTANT INPUT of 'mk_init_set_columns0' & 'br_calc_sbst_prob_sgl_clm', AND '%nodeid2msa_row', an IMPORTANT INPUT of 'extract_br_info_gblocks'.  >>>\n\n\n";

my ($nodeids_in_msa, $nodeid2msa_row) = associate_nodeids_w_msa_rows (@seqids, %name2id);

unless (defined $nodeid2msa_row) {
	print STDOUT "[ERROR '$plscript_name'] The 3rd Preliminary Subroutine 'associate_nodeids_w_msa_rows' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 3rd Preliminary Subroutine 'associate_nodeids_w_msa_rows' ENDED ...\n\n";


print STDOUT "\n<< Contents of the Preliminary Output (3a), ", '@{$nodeids_in_msa}', " >>\n\n";

print STDOUT join ("\t", 'Row', 'node_ID'), "\n\n";
for (my $r = 0; $r < $ct_seqs; $r++) { print STDOUT join ("\t", $r, $nodeids_in_msa->[$r]), "\n"; }
print STDOUT "\n\n";


print STDOUT "\n<< Contents of the Preliminary Output (3b), ", '%{$nodeid2msa_row}', " >>\n\n";

print STDOUT '%{$nodeid2msa_row} = (', "\n";
foreach my $nodeid (sort {$a <=> $b} keys %{$nodeid2msa_row} ) {
	print STDOUT "\t", $nodeid, ' => ', $nodeid2msa_row->{$nodeid}, ",\n";
}
print STDOUT "\t)\n\n";


print STDOUT "\n\n<<< Preliminary (5): Create ", '\@set_cls_gpbs & \@init_psm_hst_for_cls', ", 2 IMPORTANT INPUTS of 'mk_init_set_columns0'. >>>\n\n\n";


my ($set_gpatterns, $set_node2dparsstat, $set_br2change, $info_psm_indel_hsts0) = enum_psm_indel_hsts_for_msa_finer_1ST_HF (%node2ch, %{$node2pa}, %name2id, @seqids, @cp_full_msa, $GAP, $CHAR_PRES, %{$node2depth}, %{$node2ct_exoffs});
unless (defined $info_psm_indel_hsts0) {
	print STDOUT "[ERROR '$plscript_name'] The 5th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_1ST_HF' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 5th Preliminary Subroutine 'enum_psm_indel_hsts_for_msa_finer_1ST_HF' ENDED ...\n\n";

my ($set_cls_gpbs, $totcts0_indels_for_cls, $init_psm_hsts_for_cls) = @{$info_psm_indel_hsts0};

my $ct_gpd_sgs = @{$set_cls_gpbs};


print STDOUT "\n<< Contents of the Preliminary Outputs (5), ", '@{$set_cls_gpbs} & @{$init_psm_hsts_for_cls}', " (#{gapped segments} = $ct_gpd_sgs) >>\n\n";


for (my $cl = 0; $cl<$ct_gpd_sgs; $cl++) { # 5th preliminary outer for-loop (over the gapped segments) #

	my $cls_gblks = $set_cls_gpbs->[$cl];
	my $ct_gblks = @{$cls_gblks};

	print STDOUT "< The $cl th gapped segment (#{gap-pattern-blocks} = $ct_gblks) >\n\n";

	print STDOUT "[ Gap-pattern-blocks in the cluster ]\n\n";

	print STDOUT join ("\t", 'Block_no.', 'length', 'start_coord', 'end_coord', 'indx_gp', "'gap_pattern(horizontal_representation)'"), "\n\n";

	for (my $bl=0; $bl<$ct_gblks; $bl++) { # 1st middle for-loop (over the gap-blocks) #
	    my ($indx_gp, $len_gb, $start, $end) = @{$cls_gblks->[$bl]};

	    my $gpattern = ${$set_gpatterns->[$indx_gp]};
	    print STDOUT join ("\t", $bl, $len_gb, $start, $end, $indx_gp, "'$gpattern'"), "\n";
	}			# End of the 1st middle for-loop (over the gap-blocks) #
	print STDOUT "\n\n";

## my ($set_cls_gpbs, $init_totcts_indels_for_cls, $init_psm_hsts_for_cls) = @{$info_init_psm_hst} ;

	my $init_totct_indel = $totcts0_indels_for_cls->[$cl];
	my $init_psm_hst = $init_psm_hsts_for_cls->[$cl];

	print STDOUT "\n[ Initial Candidate Indel History (Total#{indel events}_init = $init_totct_indel) ]\n\n";

	my ($br2indels0, $node2bw_gstats0) = @{$init_psm_hst};

	print STDOUT "( Map of block-wise gap states onto the nodes )\n\n";
	print STDOUT join ("\t", 'Node_ID', "'block_wise_gap_states(concatenated)'"), "\n\n";
	foreach my $node (sort {$a <=> $b} keys %{$node2bw_gstats0}) { # 1st inner foreach-loop #
	    my $cnct_bw_gstats = join ('', @{$node2bw_gstats0->{$node}});
	    print STDOUT join ("\t", $node, "'$cnct_bw_gstats'"), "\n";
	}				# End of the 1st inner foreach-loop #
	print STDOUT "\n\n";

	print STDOUT "( Map of indel events onto the branches )\n\n";
	print STDOUT join ("\t", 'Branch_ID', 'state_ue/state_le/indices,blocks,involved', '...'), "\n\n";
	foreach my $br (sort {$a <=> $b} keys %{$br2indels0}) { # 2nd inner foreach-loop #
	    my @out_indel_info = ();
	    foreach my $indel_info (@{$br2indels0->{$br}}) { # Innermost foreach-loop #
		my ($stat_ue, $stat_le, $indices_blk) = @{$indel_info};
		(defined $stat_ue) or ($stat_ue = 'undef');
		(defined $stat_le) or ($stat_le = 'undef');
		my $cnct_indices_blk = (defined $indices_blk) ? join (',', @{$indices_blk}) : 'undef';
		push @out_indel_info, join ('/', $stat_ue, $stat_le, $cnct_indices_blk);
	    }			# End of the innermost foreach-loop #
	    print STDOUT join ("\t", $br, @out_indel_info), "\n";
	}				# End of the 2nd inner foreach-loop #
	print STDOUT "\n\n";

}		# End of the 5th preliminary outer for-loop (over the gapped segments) #

print STDOUT "\n";


	## ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (1) ##


print STDOUT "\n\n<<< Preliminary (6): Prepare the lists of gap-blocks >>>\n\n\n";


my @set_exnodes = ();
foreach my $node (sort {$a <=> $b} keys %{$node2ct_exoffs}) { 
    if ($node2ct_exoffs->{$node} == 1) {
	push @set_exnodes, $node; 
    }
}

my @set_lists_gblocks0 = ();
for (my $cl = 0; $cl<$ct_gpd_sgs; $cl++) { # 6th preliminary outer for-loop (over the gapped segments) #

	print STDOUT "| For the $cl th gapped segment |\n\n";

	my $cls_gblks = $set_cls_gpbs->[$cl];
	my $init_psm_hst = $init_psm_hsts_for_cls->[$cl];
	my ($br2indels0, $node2bw_gstats0) = @{$init_psm_hst};

	my $br_list_gblocks0 = br_list_gblocks (%{$br2indels0}, @set_exnodes, $GAP, %node2ch);
	unless (defined $br_list_gblocks0) {
	    print STDOUT "[ERROR '$plscript_name'] The 6th Preliminary Subroutine 'br_list_gblocks' FAILED on the $cl th gapped segment !\n";
	    print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	    die ;
	}
	print STDOUT "\n --- The 6th Preliminary Subroutine 'br_list_gblocks' ENDED on the $cl th gapped segment ...\n\n";

	my $ct_gbs0 = @{$br_list_gblocks0};
	print STDOUT '[ Contents of @{$br_list_gblocks0} ', "(#{gap-blocks} = $ct_gbs0) ]\n\n";
	print STDOUT join ("\t", 'Indx_gb', 'br_ID', 'up(U)_or_lw(L)', 'lm_gpb', 'rm_gpb', '(involved,gap,pattern,blocks)', '[affected,external,nodes]', '$e'), "\n\n";

	for (my $gb = 0; $gb < $ct_gbs0; $gb++) {
	    my ($br, $up_or_lw, $lm_gpb, $rm_gpb, $invlvd_gpbs, $affd_exnodes, $e) = @{$br_list_gblocks0->[$gb]};
	    my $cnct_invlvd_gpbs = join (',' , @{$invlvd_gpbs});
	    $cnct_invlvd_gpbs = "($cnct_invlvd_gpbs)";
	    my $cnct_affd_exnodes = join (',', @{$affd_exnodes});
	    $cnct_affd_exnodes = "[$cnct_affd_exnodes]";
	    print STDOUT join ("\t", $gb, $br, $up_or_lw, $lm_gpb, $rm_gpb, $cnct_invlvd_gpbs, $cnct_affd_exnodes, $e), "\n";
	}
	print STDOUT "\n\n";

	$set_lists_gblocks0[$cl] = $br_list_gblocks0;

}		# End of the 6th preliminary outer for-loop (over the gapped segments) #

		### RESTART FROM HERE (1) ###

print STDOUT "\n\n<<< Preliminary (7): Prepare Sliding Windows >>>\n\n\n";

	# A 'make-shift' preparation of the input data sets for 'prepare_sliding_windows'. #
my ($beg_in_msa, $end_in_msa) = (0, $lenaln -1);
my @artf_cls = ([0 .. $ct_gpd_sgs -1]);
my @cmplx_cands = ();
my $ct_exnodes = @set_exnodes;
my $wdth_margin = 3;
my $hf_wdth_shift = 10;
my $num_max = 5;

print STDOUT "<< 'Make-shift' Inputs of 'prepare_sliding_windows': >>\n\n";
print STDOUT '($beg_in_msa, $end_in_msa) = ', "($beg_in_msa, $end_in_msa) .\n\n";

print STDOUT '@artf_cls = (', "\n";
foreach my $acls (@artf_cls) {
	print STDOUT "\t[", join (', ', @{$acls}), "],\n";
}
print STDOUT "\t) .\n\n\n";

print STDOUT '@cmplx_cands = ()', " .\n\n";

print STDOUT '$ct_exnodes = ', "$ct_exnodes .\n\n";

print STDOUT '($wdth_margin, $hf_wdth_shift, $num_max) = ', "($wdth_margin, $hf_wdth_shift, $num_max) .\n\n\n";

my ($window_frames, $prohibited_zones, $set_windows, $set_lists_gblocks_in_wds) =  prepare_sliding_windows ($beg_in_msa, $end_in_msa, @{$set_cls_gpbs}, @artf_cls, @cmplx_cands, @set_lists_gblocks0, $ct_exnodes, $wdth_margin, $hf_wdth_shift, $num_max);
unless (defined $set_lists_gblocks_in_wds) {
	print STDOUT "[ERROR '$plscript_name'] The 7th Preliminary Subroutine 'prepare_sliding_windows' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 7th Preliminary Subroutine 'prepare_sliding_windows' ENDED ...\n\n";

my $ct_frms = @{$window_frames};
my $ct_wds = @{$set_windows};

print STDOUT "\n<< Outputs of 'prepare_sliding_windows' >>\n\n";

print STDOUT '[ Contents of @{$window_frames} ', " (#{frames} = $ct_frms) ]\n\n";
print STDOUT join ("\t", 'Indx_fr', 'beg_fr', 'end_fr'), "\n\n";

for (my $fr = 0; $fr < $ct_frms; $fr++) { print STDOUT join ("\t", $fr, @{$window_frames->[$fr]}), "\n"; }
print STDOUT "\n\n";

print STDOUT '[ Contents of @{$set_windows} ', " (#{windows} = $ct_wds) ]\n\n";
print STDOUT join ("\t", 'Indx_wd', 'beg_wd', 'end_wd', '(involved,gapped,segments)', '#{gap-blocks}', 'Indx_fr'), "\n\n";

for (my $wd = 0; $wd < $ct_wds; $wd++) {
	my ($beg_wd, $end_wd, $invlvd_gpd_sgs, $ct_gbs, $fr) = @{$set_windows->[$wd]};
	my $cnct_invlvd_gpd_sgs = join (',', @{$invlvd_gpd_sgs});
	$cnct_invlvd_gpd_sgs = "($cnct_invlvd_gpd_sgs)";
	print STDOUT join ("\t", $wd, $beg_wd, $end_wd, $cnct_invlvd_gpd_sgs, $ct_gbs, $fr), "\n";
}
print STDOUT "\n\n";

print STDOUT '[ Contents of @{$set_lists_gblocks_in_wds} ]', "\n\n";

for (my $wd = 0; $wd < $ct_wds; $wd++) {

	my $list_gblocks_in_wd = $set_lists_gblocks_in_wds->[$wd];
	my $ct_gbs = @{$list_gblocks_in_wd};

	print STDOUT "| The $wd th window (#{gap-blocks} = $ct_gbs) |\n\n";
	print STDOUT join ("\t", 'Indx_gb_in_wd', 'br_ID', 'up(U)_or_lw(L)', 'lm_clm', 'rm_clm', '(involved,gap,pattern,blocks)', '[affected,external,nodes]', '$e', '$gs', 'indx_gb_in_gs'), "\n\n";

	for (my $gb = 0; $gb < $ct_gbs; $gb++) {
	     my ($br, $up_or_lw, $lm_clm, $rm_clm, $invlvd_gpbs, $affd_exnodes, $e, $gs, $gb_in_gs) = @{$list_gblocks_in_wd->[$gb]};
	    my $cnct_invlvd_gpbs = join (',' , @{$invlvd_gpbs});
	    $cnct_invlvd_gpbs = "($cnct_invlvd_gpbs)";
	    my $cnct_affd_exnodes = join (',', @{$affd_exnodes});
	    $cnct_affd_exnodes = "[$cnct_affd_exnodes]";
	    print STDOUT join ("\t", $gb, $br, $up_or_lw, $lm_clm, $rm_clm, $cnct_invlvd_gpbs, $cnct_affd_exnodes, $e, $gs, $gb_in_gs), "\n";
	}
	print STDOUT "\n\n";
}

print STDOUT "\n   ... In the Following, we will use the 0 th window for our tests ...\n\n";


my $left_end_wd = $set_windows->[0][0];
print STDOUT "\n\n<<< Preliminary (7'): Extract key information on the 0 th window (w/  {left-end} = $left_end_wd) >>>\n\n\n";

my $list_gblocks_in_wd0 = $set_lists_gblocks_in_wds->[0]; # ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. #

		## MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. ##
my ($bds_gblocks0, $rows_affd_by_blks) = extract_br_info_gblocks ($left_end_wd, @{$list_gblocks_in_wd0}, %{$nodeid2msa_row});
##my ($bds_gblocks0, $rows_affd_by_blks) = extract_br_info_gblocks ($left_end_wd, @{$set_lists_gblocks_in_wds->[0]}, %{$nodeid2msa_row});
		## END of "MODIFIED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'." ##
unless (defined $rows_affd_by_blks) {
	print STDOUT "[ERROR '$plscript_name'] The 7'-th Preliminary Subroutine 'extract_br_info_gblocks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 7'-th Preliminary Subroutine 'extract_br_info_gblocks' ENDED ...\n\n";

my $ct_gbs7p = @{$bds_gblocks0};

print STDOUT "<< Contents of the 7'-th preliminary output:", '@{$bds_gblocks0} & @{$rows_aff_by_blks}', " (#{gap-blocks} = $ct_gbs7p) >>\n\n";

print STDOUT join ("\t", 'Indx_gb', 'left-bound', 'right-bound', '[rows,affected,by,the,block]'), "\n\n";
for (my $gb = 0; $gb < $ct_gbs7p; $gb++) {
	my $cnct_rows = join (',', @{$rows_affd_by_blks->[$gb]});
	$cnct_rows = "[$cnct_rows]";
	print STDOUT join ("\t", $gb, @{$bds_gblocks0->[$gb]}, $cnct_rows), "\n";
}
print STDOUT "\n\n";


	## END of "ADDED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. (1)" ##


print STDOUT "\n\n<<< Preliminary (8): Create ", '\@set_columns0', ", an IMPORTANT INPUT of 'shift_bl_and_compt_prob_incr' >>>\n\n\n"; # MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. 
##print STDOUT "\n\n<<<<< Sub-MAIN: Create ", '\@set_columns0', ", an IMPORTANT INPUT of 'br_calc_sbst_prob_sgl_clm' >>>>>\n\n\n";

	# MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #


my ($beg_wd, $end_wd, $invlvd_gpd_sgs, $ct_gbs, $fr) = @{$set_windows->[0]};
my @invlvd_gpd_sgs = @{$invlvd_gpd_sgs};
##
##	# Create a make-shift "window" #
##my ($beg_wd, $end_wd) = (0, $lenaln -1);
##my @invlvd_gpd_sgs = (0 .. $ct_gpd_sgs -1);

##print STDOUT "<< Inputs of 'mk_init_set_columns0': information on the 'make-shift' window >>\n\n";
print STDOUT "<< Inputs of 'mk_init_set_columns0': the 0 th window created above >>\n\n";

print STDOUT '($beg_wd, $end_wd) = ', "($beg_wd, $end_wd) .\n\n";
print STDOUT '@invlvd_gpd_sgs = (', join (', ', @invlvd_gpd_sgs), ") .\n\n\n";

my $set_columns0 = mk_init_set_columns0 (@{$nodeids_in_msa}, $GAP, $beg_wd, $end_wd, @invlvd_gpd_sgs, @{$set_cls_gpbs}, @{$init_psm_hsts_for_cls});
unless (defined $set_columns0) {
	print STDOUT "[ERROR '$plscript_name'] The 8th Preliminary Subroutine 'mk_init_set_columns0' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 8th Preliminary Subroutine 'mk_init_set_columns0' ENDED ...\n\n";

my $ct_clms0 = @{$set_columns0};

print STDOUT "\n<< Contents of the 8th Preliminary Output, ", '@{$set_columns0}', " (#{columns} = $ct_clms0) >>\n\n"; # MODIFIED in creation of 'test_shift_bl_and_compt_prob_incr.pl'. #
##print STDOUT "\n<< Contents of the Sub-MAIN Output, ", '@{$set_columns0}', " (#{columns} = $ct_clms0) >>\n\n";

print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";

for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #

	my $column0 = $set_columns0->[$c];
	print STDOUT join ("\t", $c, @{$column0}), "\n";

}	# End of the sub-main for-loop (over columns). #
print STDOUT "\n\n";


		### ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Preliminary 9 & 10) ###

print STDOUT "\n\n<<< Preliminary (9): Create ", '\@inter_block_relations', " an INPUT of 'mk_orgs_bds_gb_coords'. >>>\n\n\n";

	# Added in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'.
	# (MOVED from the "MAIN".)
my $list_gblocks0 = $list_gblocks_in_wd0;
my ($indx_br, $indx_u_or_d) = (0, 1);

print STDOUT "\n", 'Set: my $list_gblocks0 = $list_gblocks_in_wd0 (= $set_lists_gblocks_in_wds->[0])', "\n";
print STDOUT       '   & ($indx_br, $indx_u_or_d) = ', "($indx_br, $indx_u_or_d) .\n";
print STDOUT "\n\n";
	# END of "(MOVED from the "MAIN".)"

my ($inter_block_relations) = mk_inter_block_relations (@{$list_gblocks0}, $indx_br, $indx_u_or_d, %{$node2pa}, %node2ch, $topnode_id, %{$br2eq});
unless (defined $inter_block_relations) {
	print STDOUT "[ERROR '$plscript_name'] The 9-th Preliminary Subroutine 'mk_inter_block_relations' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 9-th Preliminary Subroutine 'mk_inter_block_relations' ENDED ...\n\n";

print STDOUT "[ Output of 'mk_inter_block_relations': Contents of ", '@{inter_block_relations}', " ]\n\n";
print STDOUT join ("\t", 'Gb1\Gb2:', (0 .. $ct_gbs-1)), "\n\n";
for (my $gb1=0; $gb1<$ct_gbs; $gb1++) {
	my $rels_w_gb1 = $inter_block_relations->[$gb1];

		# A BUG fixed on 2019/06/02. #
	my @out_rels_w_gb1 = ();
	for (my $gb2=0; $gb2<$ct_gbs; $gb2++) {
	    my $rel = $rels_w_gb1->[$gb2];
	    push @out_rels_w_gb1, ((defined $rel) ? $rel : 'undef');
	}
	print STDOUT join ("\t", $gb1, @out_rels_w_gb1), "\n";
	##print STDOUT join ("\t", $gb1, @{$rels_w_gb1}), "\n";
}
print STDOUT "\n\n";


print STDOUT "\n\n<<< Preliminary (10): Create ", '\@gb_coords_wd_frm', " an INPUT of 'nonrec_mlt_shifts_gapblocks'. >>>\n\n\n";

my $maxct_1way_shifts = $hf_wdth_shift;
my $right_end_wd = $set_windows->[0][1];

print STDOUT "[ Additional Inputs of the subroutine 'mk_orgs_bds_gb_coords': ]\n\n";
print STDOUT '$maxct_1way_shifts (=$hf_wdth_shift) = ', $maxct_1way_shifts, " .\n\n";
print STDOUT '($left_end_wd, $right_end_wd) = ', "($left_end_wd, $right_end_wd) .\n";
print STDOUT "\n\n";

my ($orgs_gb_coords_ref, $bds_gb_coords_ref, $gb_coords_wd_frm_ref) = mk_orgs_bds_gb_coords (@{$bds_gblocks0}, $left_end_wd, $right_end_wd, @{$inter_block_relations}, $maxct_1way_shifts);
unless (defined $gb_coords_wd_frm_ref) {
	print STDOUT "[ERROR '$plscript_name'] The 10-th Preliminary Subroutine 'mk_orgs_bds_gb_coords' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The 10-th Preliminary Subroutine 'mk_orgs_bds_gb_coords' ENDED ...\n\n";

my @gb_coords_wd_frm = ();
for (my $gb=0; $gb<$ct_gbs; $gb++) {
	my $offset = $org_bl_coords[$gb] - $orgs_gb_coords_ref->[$gb];
	my ($gcoord_le_wd_ref, $gcoord_re_wd_ref) = @{$gb_coords_wd_frm_ref->[$gb]};
	$gb_coords_wd_frm[$gb] = [$gcoord_le_wd_ref + $offset, $gcoord_re_wd_ref + $offset];
}

print STDOUT '[ RESULT: Contents of @gb_coords_wd_frm ]', "\n\n";
print STDOUT join ("\t", 'Indx_bl', 'gcoord_le_wd', 'gcoord_re_wd'), "\n\n";
for (my $gb=0; $gb<$ct_gbs; $gb++) {
	print STDOUT join ("\t", $gb, @{$gb_coords_wd_frm[$gb]}), "\n";
}
print STDOUT "\n\n";


		### END of "ADDED in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Preliminary 9 & 10)" ###


		### MAJOR MODIFICATION in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (MAIN) ###

print STDOUT "\n\n<<<<< MAIN: Perform the multiple \"shift\"s, USING 'nonrec_mlt_shifts_gapblocks'.  >>>>>\n\n\n";

my %clm2ln_prb_sbst;

## @org_bl_coords = (2, 2, 2);
## @bds_bl_coords = ([0, 4], [0, 4], [0, 4]);

print STDOUT "[[ Initial Values of Some inputs of 'nonrec_mlt_shifts_gapblocks' ]]\n\n";

print STDOUT '@org_bl_coords = (', join (', ', @org_bl_coords), ") .\n\n";
print STDOUT '( Contents of @bds_bl_coords: )', "\n\n";
print STDOUT join ("\t", 'Indx_bl', 'left-bound', 'right-bound'), "\n\n";

for (my $bl = 0; $bl < $ct_gbs; $bl++) {
	print STDOUT join ("\t", $bl, @{$bds_bl_coords[$bl]}), "\n";
}
print STDOUT "\n\n";

print STDOUT '%clm2ln_prb_sbst = ( # $clm => $ln_prb_sbst, ', "\n";

foreach my $clm (sort keys %clm2ln_prb_sbst) { 
	print STDOUT "\t", $clm, ' => ', $clm2ln_prb_sbst{$clm}, ",\n";
}
print STDOUT "\t) .\n\n\n";

		### RESTART FROM HERE (2) (on 2019/05/30) ###


##=TEST1 # Test the satellite subroutine, 'extract_cls_gblocks_mrounds', of the subroutine 'enum_psm_indel_scns_for_msa_hs_mrounds' in the initialization part of the MAIN SUBJECT, 'nonrec_mlt_shifts_gapblocks', as well.

print STDOUT "\n", '[ USE the Initial Values: @set_ingredients_indel_hsts = ({}, [], [], []) . ]', "\n\n\n";

my @set_ingredients_indel_hsts = ({}, [], [], []);

##=cut # END of "TEST1 # Test the satellite subroutine, 'extract_cls_gblocks_mrounds', of the subroutine 'enum_psm_indel_scns_for_msa_hs_mrounds' in the initialization part of the MAIN SUBJECT, 'nonrec_mlt_shifts_gapblocks', as well."

=TEST2 # Test the impact of the 'extract_cls_gblocks_mrounds' on the time-consumption.

print STDOUT '[ AS the Initial Values for @set_ingredients_indel_hsts = (\%gpattern2indx, \@{$set_gpatterns}, \@{$set_node2dparsstat}, \@{$set_br2change}),', " USE the outputs of 'enum_psm_indel_hsts_for_msa_finer_1ST_HF' performed ABOVE. ]\n\n\n";

my $ct_gpatterns = @{$set_gpatterns};
my %gpattern2indx;
for (my $i=0; $i<$ct_gpatterns; $i++) {
	my $gpattern = ${$set_gpatterns->[$i]};
	$gpattern2indx{$gpattern} = $i;
}
my @set_ingredients_indel_hsts = (\%gpattern2indx, $set_gpatterns, $set_node2dparsstat, $set_br2change);

=cut # END of "TEST2 # Test the impact of the 'extract_cls_gblocks_mrounds' on the time-consumption."

		### RESTART FROM HERE (3) (on 2019/05/30) ###

my @set_ingredients_prb_msa_indel = ($TOTRATE_INS, $TOTRATE_DEL, $CUTOFF_INS_LEN, $CUTOFF_DEL_LEN, $delta_del, $br2log_mfacs); 

print STDOUT '   @set_ingredients_prb_msa_indel = ($TOTRATE_INS, $TOTRATE_DEL, $CUTOFF_INS_LEN, $CUTOFF_DEL_LEN, $delta_del, \%{$br2log_mfacs})', "\n";
print STDOUT " = ($TOTRATE_INS, $TOTRATE_DEL, $CUTOFF_INS_LEN, $CUTOFF_DEL_LEN, $delta_del, $br2log_mfacs) .\n";
print STDOUT "\n\n";


=MOVED to "Preliminary (9)" above.
	# Added in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Main) #
my $list_gblocks0 = $list_gblocks_in_wd0;
my ($indx_br, $indx_u_or_d) = (0, 1);

print STDOUT "\n", 'Set: my $list_gblocks0 = $list_gblocks_in_wd0 (= $set_lists_gblocks_in_wds->[0])', "\n";
print STDOUT       '   & ($indx_br, $indx_u_or_d) = ', "($indx_br, $indx_u_or_d) .\n";
print STDOUT "\n\n";
	# End of "Added in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (Main)" #
=cut # END of "MOVED to "Preliminary (9)" above."



	## (Added on 2019/05/31.) ##

	# If NOT DEFINED YET, set $if_on_le_msa & $if_on_re_msa to be natural values. #
unless (defined $if_on_le_msa) { $if_on_le_msa = ($left_end_wd == $beg_in_msa) ? 1 : 0; }
unless (defined $if_on_re_msa) { $if_on_re_msa = ($right_end_wd == $end_in_msa) ? 1 : 0; }

print STDOUT '($if_on_le_msa, $if_on_re_msa) = ', "($if_on_le_msa, $if_on_re_msa) .\n\n";
print STDOUT '@list_excluded_bin_hrels = ( # element = [$gb1, $gb2, $hrel],', "\n";
foreach my $element (@list_excluded_bin_hrels) { print STDOUT "\t[", join (', ', @{$element}), "],\n"; }
print STDOUT '                           );', "\n";
print STDOUT "\n\n";

	## End of "(Added on 2019/05/31.)" ##

my ($if_success, $ct_null_clms0, $degeneracy0, $minct_indels0, $ln_prb_msa0, $ln_prb_sbst0, $ln_prb_indel0, $diffs_ln_prbs_plus) 
  = nonrec_mlt_shifts_gapblocks (@org_bl_coords, @bds_bl_coords, @gb_coords_wd_frm, @{$nodeids_in_msa}, $GAP, $CHAR_PRES, @{$set_columns0}, 
	@{$list_gblocks0}, $indx_br, $indx_u_or_d, @{$bds_gblocks0}, @{$rows_affd_by_blks}, 

		# A BUG fixed on 2019/06/02. #
	%clm2ln_prb_sbst, $topnode_id, %node2ch, %{$node2pa}, %br_attr, %{$node2depth}, %{$node2ct_exoffs}, %{$br2eq},  @equil_resfreqs, %{$node2set_sw_extcond_probs0}, %br2tr_mtrx,
	##%clm2ln_prb_sbst, $topnode_id, %node2ch, %br_attr, %{$node2pa}, %{$node2depth}, %{$node2ct_exoffs}, %{$br2eq},  @equil_resfreqs, %{$node2set_sw_extcond_probs0}, %br2tr_mtrx,
		# END of "A BUG fixed on 2019/06/02." #

	@set_ingredients_indel_hsts, @set_ingredients_prb_msa_indel, $if_on_le_msa, $if_on_re_msa,
	@list_excluded_bin_hrels );

my @out_values = ();
foreach my $value ($if_success, $ct_null_clms0, $degeneracy0, $minct_indels0, $ln_prb_msa0, $ln_prb_sbst0, $ln_prb_indel0, $diffs_ln_prbs_plus) { 
	push @out_values, ((defined $value) ? $value : 'undef');
}

unless ($if_success) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'nonrec_mlt_shifts_gapblocks' FAILED !\n";
	print STDOUT "[ERROR '$plscript_name'] Outputs:\n";
	print STDOUT "[ERROR '$plscript_name']", '   ($if_success, $ct_null_clms0, $degeneracy0, $minct_indels0, $ln_prb_msa0, $ln_prb_sbst0, $ln_prb_indel0, \@{$diffs_ln_prbs_plus})', "\n";
	print STDOUT "[ERROR '$plscript_name'] = (", join (', ', @out_values), ") .\n\n\n";

	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The MAIN Subroutine 'nonrec_mlt_shifts_gapblocks' ENDED ...\n\n\n";

print STDOUT "[[ Outputs of the MAIN Subroutine 'nonrec_mlt_shifts_gapblocks'. ]]\n\n";

print STDOUT '   ($if_success, $ct_null_clms0, $degeneracy0, $minct_indels0, $ln_prb_msa0, $ln_prb_sbst0, $ln_prb_indel0, \@{$diffs_ln_prbs_plus})', "\n";
print STDOUT ' = (', join (', ', @out_values), ") .\n\n\n";


print STDOUT "[ Contents of ", '@{$diffs_ln_prbs_plus}', " (printed out USING 'printout_multidim_storage') ]\n\n";

print STDOUT "( The 0th components (= \$ct_null_clms): )\n\n";

my $flag0 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 0, *STDOUT, $STRING_UNDEF);

unless ($flag0) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 0th component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 0th components...\n\n\n";


print STDOUT "( The 1st components (= \$degeneracy): )\n\n";

my $flag1 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 1, *STDOUT, $STRING_UNDEF);

unless ($flag1) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 1st component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 1st components...\n\n\n";


print STDOUT "( The 2nd components (= \$diff_minct_indels): )\n\n";

my $flag2 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 2, *STDOUT, $STRING_UNDEF);

unless ($flag2) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 2nd component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 2nd components...\n\n\n";


print STDOUT "( The 3rd components (= \$diff_ln_prb_msa): )\n\n";

my $flag3 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 3, *STDOUT, $STRING_UNDEF);

unless ($flag3) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 3rd component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 3rd components...\n\n\n";


print STDOUT "( The 4th components (= \$diff_ln_prb_sbst): )\n\n";

my $flag4 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 4, *STDOUT, $STRING_UNDEF);

unless ($flag4) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 4th component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 4th components...\n\n\n";


print STDOUT "( The 5th components (= \$diff_ln_prb_indel): )\n\n";

my $flag5 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_plus}, 5, *STDOUT, $STRING_UNDEF);

unless ($flag5) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 5th component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 5th components...\n\n\n";



=For the predecessor, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (MAIN)

print STDOUT "\n\n<<<<< MAIN: Perform the multiple \"shift\"s, USING 'nonrec_mlt_shifts_noninf_gapblocks'.  >>>>>\n\n\n";

my %clm2ln_prb_sbst;

## @org_bl_coords = (2, 2, 2);
## @bds_bl_coords = ([0, 4], [0, 4], [0, 4]);

print STDOUT "[[ Initial Values of Some inputs of 'nonrec_mlt_shifts_noninf_gapblocks' ]]\n\n";

print STDOUT '@org_bl_coords = (', join (', ', @org_bl_coords), ") .\n\n";
print STDOUT '( Contents of @bds_bl_coords: )', "\n\n";
print STDOUT join ("\t", 'Indx_bl', 'left-bound', 'right-bound'), "\n\n";

for (my $bl = 0; $bl < $ct_gbs; $bl++) {
	print STDOUT join ("\t", $bl, @{$bds_bl_coords[$bl]}), "\n";
}
print STDOUT "\n\n";

print STDOUT '%clm2ln_prb_sbst = ( # $clm => $ln_prb_sbst, ', "\n";

foreach my $clm (sort keys %clm2ln_prb_sbst) { 
	print STDOUT "\t", $clm, ' => ', $clm2ln_prb_sbst{$clm}, ",\n";
}
print STDOUT "\t) .\n\n\n";


my ($ln_prb_sbst0, $diffs_ln_prbs_sbst) = nonrec_mlt_shifts_noninf_gapblocks (@org_bl_coords, @bds_bl_coords, @{$nodeids_in_msa}, $GAP, @{$set_columns0}, @{$bds_gblocks0}, @{$rows_affd_by_blks}, %clm2ln_prb_sbst, $topnode_id, %node2ch, %{$node2pa}, %{$node2depth}, @equil_resfreqs, %{$node2set_sw_extcond_probs0}, %br2tr_mtrx);
unless (defined $diffs_ln_prbs_sbst) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'nonrec_mlt_shifts_noninf_gapblocks' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n --- The MAIN Subroutine 'nonrec_mlt_shifts_noninf_gapblocks' ENDED ...\n\n\n";

print STDOUT "[[ Outputs of the MAIN Subroutine 'nonrec_mlt_shifts_noninf_gapblocks'. ]]\n\n";

print STDOUT '$ln_prb_sbst0 = ', $ln_prb_sbst0, " .\n\n\n";

print STDOUT "[ Contents of ", '@{$diffs_ln_prb_sbst}', " (printed out USING 'printout_multidim_storage') ]\n\n";

print STDOUT "( The 0th components: )\n\n";

my $flag0 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_sbst}, 0, *STDOUT, $STRING_UNDEF);

unless ($flag0) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 0th component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 0th component...\n\n\n";


print STDOUT "( The 1st components: )\n\n";

my $flag1 = printout_multidim_storage (@org_bl_coords, @bds_bl_coords, @{$diffs_ln_prbs_sbst}, 1, *STDOUT, $STRING_UNDEF);

unless ($flag1) {
	print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'printout_multidim_storage' FAILED on the 1st component !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	die ;
}
print STDOUT "\n\n --- The trailing subroutine 'printout_multidim_storage' ENDED on the 1st component...\n\n\n";

=cut # END of "For the predecessor, 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. (MAIN)"

		### END of "MAJOR MODIFICATION in creation of 'test_nonrec_mlt_shifts_gapblocks.pl'. (MAIN)" ###

=DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'. #

print STDOUT "\n\n<<<<< MAIN: Execute some \"shift\"s and compute the resulting probability increments , USING 'shift_bl_and_compt_prob_incr'. >>>>>\n\n\n";

my @null_clm = ();
for (@full_msa) { push @null_clm, $GAP; }
my $cnct_null_clm = join (':', @null_clm);

my @curr_bl_coords = (2, 2, 2);

my %clm2ln_prb_sbst;


print STDOUT "[[ Some supplementary inputs of 'shift_bl_and_compt_prob_incr' ]]\n\n";
print STDOUT '@curr_bl_coords = (', join (', ', @curr_bl_coords), ") .\n\n";
print STDOUT '$cnct_null_clm = ', $cnct_null_clm, " .\n\n";
print STDOUT '%clm2ln_prb_sbst = ( # $clm => $ln_prb_sbst, ', "\n";

foreach my $clm (sort keys %clm2ln_prb_sbst) { 
	print STDOUT "\t", $clm, ' => ', $clm2ln_prb_sbst{$clm}, ",\n";
}
print STDOUT "\t) .\n\n";

print STDOUT '@set_bl_sh_pairs = ( # [$bl, $sh)', "\n";
print STDOUT "\t";
foreach my $bl_and_sh (@set_bl_sh_pairs) {
	my ($bl, $sh) = @{$bl_and_sh};
	print STDOUT "  [$bl, $sh],";
}
print STDOUT "\n\t) .\n\n\n";



foreach my $bl_and_sh (@set_bl_sh_pairs) { # Main outer foreach-loop (over $bl-$sh pairs). #

	my ($bl, $sh) = @{$bl_and_sh};

	print STDOUT '||  ($bl, $sh) = ', "($bl, $sh)  ||\n\n";

	my ($flag, $incr_ln_prb_sbst, $incr_ct_null_clms)
	    = shift_bl_and_compt_prob_incr (@{$set_columns0}, @{$bds_gblocks0}, @curr_bl_coords, $bl, $sh, @{$rows_affd_by_blks}, $cnct_null_clm, %clm2ln_prb_sbst, @{$nodeids_in_msa}, $GAP, $topnode_id, %node2ch, %{$node2depth}, @equil_resfreqs, %{$node2set_sw_extcond_probs0}, %br2tr_mtrx);
	unless (defined $incr_ct_null_clms) {
	    print STDOUT "\n[CAUTION '$plscript_name'] The subroutine 'shift_bl_and_compt_prob_incr' FAILED !!\n\n\n";
	}

	foreach my $ref (\$flag, \$incr_ln_prb_sbst, \$incr_ct_null_clms) {
	    unless (defined ${$ref}) { ${$ref} = 'undef'; }
	}

	print STDOUT '$flag = ', $flag, " ,\n";
	print STDOUT '$incr_ln_prb_sbst = ', $incr_ln_prb_sbst, " ,\n";
	print STDOUT '$incr_ct_null_clms = ', $incr_ct_null_clms, " .\n\n\n";


	print STDOUT "[ Main input data-sets after the \"shift\": ]\n\n";

	print STDOUT '@curr_bl_coords = (', join (', ', @curr_bl_coords), ") .\n\n";

	print STDOUT '( Contents of @{$bds_gblocks0} )', "\n\n";
	print STDOUT join ("\t", 'Indx_gb', 'left-bound', 'right-bound'), "\n";
	for (my $gb = 0; $gb < $ct_gbs7p; $gb++) {
	    print STDOUT join ("\t", $gb, @{$bds_gblocks0->[$gb]}), "\n";
	}
	print STDOUT "\n\n";

	print STDOUT '( Contents of @{$set_columns0} )', "\n\n";

	print STDOUT join ("\t", 'Column\Row:', (0 .. $ct_seqs -1) ), "\n\n";

	for (my $c = 0; $c < $ct_clms0; $c++) { # Sub-main for-loop (over columns). #
	    my $column0 = $set_columns0->[$c];
	    print STDOUT join ("\t", $c, @{$column0}), "\n";

	}	# End of the sub-main for-loop (over columns). #
	print STDOUT "\n\n\n";


}	# End of the main outer foreach-loop (over $bl-$sh pairs). #


print STDOUT "\n", '[[ Contents of %clm2ln_prb_sbst AFTER all the \"shift\"s: ]]', "\n\n";

print STDOUT '%clm2ln_prb_sbst = ( # $clm => $ln_prb_sbst, ', "\n";

foreach my $clm (sort keys %clm2ln_prb_sbst) { 
	print STDOUT "\t", $clm, ' => ', $clm2ln_prb_sbst{$clm}, ",\n";
}
print STDOUT "\t) .\n\n";

=cut # END of "DISABLED in creation of 'test_nonrec_mlt_shifts_noninf_gapblocks.pl'." #

=DISABLED in creation of 'test_shift_bl_and_compt_prob_incr.pl'.

print STDOUT "\n\n<<<<< MAIN: Calculate the Probabilities of all columns USING 'br_calc_sbst_prob_sgl_clm' >>>>>\n\n\n";


for (my $c = 0; $c < $lenaln; $c++) { # Main for-loop (over columns). #

	print STDOUT "{{ The $c th column (i.e., site) }}\n\n";

	my $column0 = $set_columns0->[$c];
	unless (defined $column0) {
	    print STDOUT "[CAUTION '$plscript_name'] The $c th column is NOT encoded by 'mk_init_set_columns0': $! !!\n\n\n";
	    next;
	}

	my $sbst_prb_sgl_clm = br_calc_sbst_prob_sgl_clm (@{$nodeids_in_msa}, $GAP, @{$column0}, $topnode_id, %node2ch, %{$node2depth}, @equil_resfreqs, %{$node2set_sw_extcond_probs0}, %br2tr_mtrx);
	unless (defined $sbst_prb_sgl_clm) {
	     print STDOUT "[ERROR '$plscript_name'] The MAIN Subroutine 'br_calc_sbst_prob_sgl_clm' FAILED on the $c th column !\n";
	     print STDERR "[ERROR '$plscript_name'] $! !\n\n";
	     die ;
	}
	print STDOUT "\n --- The MAIN Subroutine 'br_calc_sbst_prob_sgl_clm' ENDED on the $c th column ...\n\n";

	print STDOUT '[[ Output: $sbst_prb_sgl_clm = ', "$sbst_prb_sgl_clm ]]\n\n\n";

}	# End of the Main for-loop (over columns). #

=cut # END of "DISABLED in creation of 'test_shift_bl_and_compt_prob_incr.pl'."

	## END of "ADDED in creation of 'test_br_calc_sbst_prob_sgl_clm.pl'. (2)" ##


=for the predecessor 'test_calc_prob_descresstats.pl'.

print STDOUT "\n\n<<< Finally, Calculate the Total Probabilities of the Residue States of Descendants of Each Ancestor Node. >>>\n\n\n";


my $node2set_sw_probs = calc_prob_descresstats (%{$node2set_sw_cond_probs}, @equil_resfreqs);

unless (defined $node2set_sw_probs) {
	print STDOUT "[ERROR '$plscript_name'] The 2nd MAIN Subroutine 'calc_prob_descresstats' FAILED !\n";
	print STDERR "[ERROR '$plscript_name'] $! !\n\n";
}

print STDOUT "\n<< Contents of the Main Output, ", '%{$node2set_sw_probs}', " >>\n\n";

foreach my $node_id (sort {$a <=> $b} keys %{$node2set_sw_probs}) { # 2nd main outer foreach-loop (over nodes). #

	my $set_sw_probs = $node2set_sw_probs->{$node_id};

	my $ct_sites = @{$set_sw_probs};

	unless ($ct_sites == $lenaln) {
	    print STDOUT "\n[WARNING '$plscript_name'] The number of sites (=$ct_sites) CLASHES with the MSA lengths (=$lenaln): $! !\n\n";
	}

	print STDOUT "< Node ID: $node_id (#{sites} = $ct_sites) >\n\n";

	print STDOUT "[ Total Probabilities of the Descendant Residue States of this node  ]\n\n";

	print STDOUT join ("\t", 'Site', 'Tot_Prob'), "\n\n";

	for (my $s=0; $s<$ct_sites; $s++) {
	    my $prob = $set_sw_probs->[$s];
	    print STDOUT join ("\t", $s, ((defined $prob) ? $prob : 'undef') ), "\n";
	}
	print STDOUT "\n\n";

}			# End of the 2nd main outer foreach-loop (over nodes). #

=cut



print STDOUT "\n\n  === The Script '$plscript_name' ENDED !! ===\n\n\n";


